package org.ow2.choreos.abstractionBase;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;

import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.InterfacesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.propertyAndJointBasedGroups.JointGroup;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;


public class NonFunctionalHierarchyWithNestedFAbstractions extends NonFunctionalHierarchy {//This class is exclusively for the mode = 2!


	//Variables.
	private String namesDistanceCalculatorAlgorithm;
	private String schemaRepresentationAlgorithm;


	//Constructor.
	NonFunctionalHierarchyWithNestedFAbstractions( UserSettings options, List<ServiceInterface> unRepresentedInterfaces ) {

		super( options.getCollectionID(), options.getMode(), options.getThreshold() );

		namesDistanceCalculatorAlgorithm = options.getNamesDistanceCalculatorAlgorithm();
		schemaRepresentationAlgorithm = options.getSchemaRepresentationModel();
	}


	//Getters.
	String getNamesDistanceCalculatorAlgorithm(){

		return namesDistanceCalculatorAlgorithm;
	}

	String getSchemaRepresentationAlgorithm(){

		return schemaRepresentationAlgorithm;
	}


	//Setters.
	//Adding a non-functional abstraction (mode = 2).
	NonFunctionalAbstraction addAbstraction( ServiceRegistration serviceRegistration, Integer nonFunctionalAbstractionID, Integer ancestorID, JointGroup jointGroup ){

		NonFunctionalAbstraction nonFunctionalAbstractionAncestor = null;

		if( nonFunctionalAbstractions == null ) nonFunctionalAbstractions = new Hashtable<Integer, NonFunctionalAbstraction>();

		else nonFunctionalAbstractionAncestor = lookUp( ancestorID );

		NonFunctionalAbstractionWithNestedFAbstractions addedNonFunctionalAbstraction = new NonFunctionalAbstractionWithNestedFAbstractions( nonFunctionalAbstractionID, jointGroup, nonFunctionalAbstractionAncestor );

		if( nonFunctionalAbstractionAncestor != null ) nonFunctionalAbstractionAncestor.addDescendant( addedNonFunctionalAbstraction );

		nonFunctionalAbstractions.put( nonFunctionalAbstractionID, addedNonFunctionalAbstraction );

		return addedNonFunctionalAbstraction;
	}


	//Adding a functional abstraction (mode = 2).
	ServiceInterface addAbstraction( Integer nonFunctionalAbstractionID, Integer functionalAbstractionID, Integer descendant1, Integer descendant2, InterfacesMapping interfacesMapping, ArrayList<ServiceInterface> unRepresentedInterfaces ){

		NonFunctionalAbstraction nonFunctionalAbstraction = lookUp( nonFunctionalAbstractionID );

		if( nonFunctionalAbstraction == null ) return null;

		return ((NonFunctionalAbstractionWithNestedFAbstractions) nonFunctionalAbstraction).addAbstraction( namesDistanceCalculatorAlgorithm, functionalAbstractionID, descendant1, descendant2, interfacesMapping, unRepresentedInterfaces );
	}


	//Visualization.
	DefaultMutableTreeNode visualize( ServiceRegistration serviceRegistration, String endOfPath ){

		DefaultMutableTreeNode root = new DefaultMutableTreeNode("Hierarchy");

		if( nonFunctionalAbstractions != null ){

			DefaultMutableTreeNode child2 = new DefaultMutableTreeNode("Non-functional abstractions");
			root.add(child2);

			for (Enumeration<Integer> e = nonFunctionalAbstractions.keys(); e.hasMoreElements();){

				Integer k = e.nextElement(); 

				if( nonFunctionalAbstractions.get( k ).ancestor == null ) child2 = ( (NonFunctionalAbstractionWithNestedFAbstractions) nonFunctionalAbstractions.get( k )).visualize( serviceRegistration, collectionID, child2 );
			}
		}

    	return root;
	}
}
