package org.ow2.choreos.abstractionDrivenServiceOrganization;

import java.util.ArrayList;
import java.util.List;

import org.ow2.choreos.abstractionBase.AbstractionBaseController;
import org.ow2.choreos.abstractionBase.Hierarchy;
import org.ow2.choreos.abstractionDrivenServiceOrganization.functionalOrganization.FunctionalOrganization;
import org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.NonFunctionalOrganization;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.gui.ServiceOrganizationVisualizer;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.ParameterizedServiceOrganizationVisualizer;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;


/**
 * 
 * @author dathanas
 *
 */
public class ServiceOrganizationController {


	//Methods.
	public Hierarchy produce( boolean waitProductionThreads, ServiceRegistration serviceRegistration, AbstractionBaseController abstractionBase, List<ServiceInterface> allInterfaces, UserSettings options, ServiceOrganizationVisualizer serviceOrganizationVisualizer ){


		abstractionBase.initHierarchy( options, allInterfaces );


		if( options.getMode() == 1 ) FunctionalOrganization.produceFH1( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );

		else if( options.getMode() == 2 ) NonFunctionalOrganization.produceNFH2( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );

		else if( options.getMode() == 3 ){

			Thread functionalThread = produceFunctionalHierarchy( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );

			Thread nonFunctionalThread = produceNonFunctionalHierarchy( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );

			if( waitProductionThreads ){

				List<Thread> threads = new ArrayList<Thread>();

				threads = new ArrayList<Thread>();

				threads.add( functionalThread );

				threads.add( nonFunctionalThread );

				waitProductionThreads( threads );
			}
		}

		enableStoreButton( serviceOrganizationVisualizer );//GUI!

		/*
		 * if( options.getMode() == 1 )
			functionalOrganization.produceFH( options.getStepByStepExecution(), options.getCollectionID(), allInterfaces, nonFunctionalOrganization, guiForHierarchyProducer );

		else if( options.getMode() == 2)
			nonFunctionalOrganization.produceNFH( options.getStepByStepExecution(), allInterfaces, options.getCollectionID(), functionalOrganization, guiForHierarchyProducer );

		else if( options.getMode() == 3 ){

			produceFunctionalHierarchy( functionalOrganization, options.getStepByStepExecution(), options.getCollectionID(), allInterfaces );
			if( nonFunctionalOrganization != null ) produceNonFunctionalHierarchy( nonFunctionalOrganization, options.getStepByStepExecution(), options.getCollectionID(), allInterfaces );

			changeButtonLabelToConstructHierarchies();//GUI!

			enableStoreButton();//GUI!
		}
		 */


		return abstractionBase.lookUp( options.getCollectionID() );
	}
	
	public Hierarchy produce( boolean waitProductionThreads, ServiceRegistration serviceRegistration, AbstractionBaseController abstractionBase, List<ServiceInterface> allInterfaces, UserSettings options, ParameterizedServiceOrganizationVisualizer testFrame ){
		abstractionBase.initHierarchy( options, allInterfaces );


		if( options.getMode() == 3 ){

			Thread functionalThread = produceFunctionalHierarchy( serviceRegistration, abstractionBase, options, allInterfaces, testFrame );

			if( waitProductionThreads ){

				List<Thread> threads = new ArrayList<Thread>();

				threads = new ArrayList<Thread>();

				threads.add( functionalThread );

				waitProductionThreads( threads );
			}
		}
		return abstractionBase.lookUp( options.getCollectionID() );
	}


	private Thread produceFunctionalHierarchy(final ServiceRegistration serviceRegistration,final AbstractionBaseController abstractionBase, final UserSettings options,final List<ServiceInterface> allInterfaces, final ParameterizedServiceOrganizationVisualizer serviceOrganizationVisualizer) {
		Thread functionalThread = new Thread( new Runnable() {
    		public void run() {
    			
    			FunctionalOrganization.produceFH3( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );
    			
    		}
   		});
		functionalThread.setPriority( Thread.NORM_PRIORITY ); functionalThread.start();
		return functionalThread;
	}
	private Thread produceFunctionalHierarchy( final ServiceRegistration serviceRegistration, final AbstractionBaseController abstractionBase, final UserSettings options, final List<ServiceInterface> allInterfaces, final ServiceOrganizationVisualizer serviceOrganizationVisualizer ) {

		Thread functionalThread = new Thread( new Runnable() {

    		public void run() {

    			FunctionalOrganization.produceFH3( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );
    		}
   		});

		functionalThread.setPriority( Thread.NORM_PRIORITY ); functionalThread.start();


		return functionalThread;
    }

	private Thread produceNonFunctionalHierarchy( final ServiceRegistration serviceRegistration, final AbstractionBaseController abstractionBase, final UserSettings options, final List<ServiceInterface> allInterfaces, final ServiceOrganizationVisualizer serviceOrganizationVisualizer ) {

		Thread nonFunctionalThread = new Thread( new Runnable() {

    		public void run() {

    			NonFunctionalOrganization.produceNFH3( serviceRegistration, abstractionBase, options, allInterfaces, serviceOrganizationVisualizer );
    		}
   		});

		nonFunctionalThread.setPriority( Thread.NORM_PRIORITY ); nonFunctionalThread.start();


		return nonFunctionalThread;
    }

	private void waitProductionThreads( List<Thread> threads ){

		for( int i = 0; threads != null && i < threads.size(); ++i ){

			try {

				threads.get( i ).join();

			} catch( InterruptedException e ) {}
		}
	}

	private void enableStoreButton( ServiceOrganizationVisualizer serviceOrganizationVisualizer ){

		serviceOrganizationVisualizer.getButtonOfStoringHierarchy().setEnabled(true);
	}

	//Methods for updating hierarchy.
	public void update( List<ServiceInterface> allInterfaces, UserSettings options ){//Update a hierarchy wrt: (a) updated interfaces and (b) options.

		//if(factoryChooser == null) factoryChooser = new OrganizationFactoryChooser( serviceRegistration, abstractionBase );

		//1st step: Check if mode and options are different.
		//2nd step: Check the existence of an organization factory object.
		//3rd step: Call the Update methods of the suitable organization objects based on the mode.
	}

	public void update( UserSettings options ){//Update a hierarchy wrt: options.

		/*if(factoryChooser == null) factoryChooser = new OrganizationFactoryChooser( serviceRegistration, abstractionBase );

		if( abstractionBase.equals( options )){
			//TODO: statistics! - Load in the tree!
			JOptionPane.showMessageDialog(null, "Service Organization fullyStructuredDataModelv1 - Update: The hierarchy of the collection " + options.getCollectionID() + " has been already constructed with the same options and mode.");
		}

		else{
			//abstractionBase.updateHierarchy( options );

			//OrganizationFactory organizationFactory = factoryChooser.getOrganizationFactory( options );

			//TODO: we need the 'allInterfaces'!
			if( options.getMode() == 1 )
				organizationFactory.InstantiateF().produceFH( allInterfaces, options, organizationFactory.InstantiateNF());

			else if( options.getMode() == 2)
				organizationFactory.InstantiateNF().produceNFH(abstractionBase, options, organizationFactory.InstantiateF());

			else if( options.getMode() == 3 ){
				organizationFactory.InstantiateF().produceFH(abstractionBase, options);
				organizationFactory.InstantiateNF().produceNFH(abstractionBase, options);
			}
		}*/
	}
}
