package org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.names;


class EditDistanceCalculator {


	//Methods.
	double directedCalculate( String s, String t ){
		   int m=s.length();
		    int n=t.length();
		    int[][]d=new int[m+1][n+1];
		    for(int i=0;i<=m;i++){
		      d[i][0]=i;
		    }
		    for(int j=0;j<=n;j++){
		      d[0][j]=j;
		    }
		    for(int j=1;j<=n;j++){
		      for(int i=1;i<=m;i++){
		        if(s.charAt(i-1)==t.charAt(j-1)){
		          d[i][j]=d[i-1][j-1];
		        }
		        else{
		          d[i][j]=min((d[i-1][j]+1),(d[i][j-1]+1),(d[i-1][j-1]+1));
		        }
		      }
		    }
		    return(1.0-(((double)d[m][n])/(double)Math.max(s.length(), t.length())));
		    //return(d[m][n]);
		  }
		public static int min(int a,int b,int c){
		    return(Math.min(Math.min(a,b),c));
		
	}

	static double calculate( String n1, String n2 ){

		if( n1 == null ) n1 = "";

		if( n2 == null ) n2 = "";

		if( n1.equals( "" ) && n2.equals( "" ) ) return 0.0;


		int l1 = n1.length();

		int l2 = n2.length();

		int ED1 = calculateED( n1, n2 );

		double NED1 = (double)(2 * ED1) / (double)(l1 + l2 + ED1);


		n1 = n1.toLowerCase();

		n2 = n2.toLowerCase();


		int ED2 = calculateED( n1, n2 );

		double NED2 = (double)(2 * ED2) / (double)(l1 + l2 + ED2);

		if( NED2 < NED1 ) return NED2;


		return NED1;
	}

	private static int calculateED( String n1, String n2 ){

		int ED = 0;

		int l1 = n1.length(); 
		int l2 = n2.length();

		String sub = extractName( n1, n2 );

		int lcs = sub.length();
		
		ED = l1 + l2 - 2 * lcs; 
		
		return ED;
	}

	static String extractName( String[] names ){

		if( names == null ) return "";

		if( names.length > 2 ) return "";


		String n1 = names[ 0 ], n2 = names[ 1 ];

		return extractName( n1, n2 );
	}

	static String extractName( String n1, String n2 ){

		if( n1 == null ) n1 = "";

		if( n2 == null ) n2 = "";

		if( n1.equals( "" ) && n2.equals( "" ) ) return "";


		String name1 = extract( n1, n2 );

		String name2 = extract( n1.toLowerCase(), n2.toLowerCase() );


		return name1.length() > name2.length() ? name1 : name2;
	}

	private static String extract( String n1, String n2 ){

		String tmp = "";
	    String max = "";
	                     
	    for(int i=0; i < n1.length(); i++){
	    	for (int j=0; j < n2.length(); j++){
	    		for (int k=1; (k+i) <= n1.length() && (k+j) <= n2.length(); k++){
	    			if (n1.substring(i, k+i).equals(n2.substring(j, k+j))){
	    				tmp = n1.substring(i,k+i);
	                }
	                else{
	                	if (tmp.length() > max.length())
	                		max=tmp;
	                    
	                	tmp="";
	                }
	            }

	    		if (tmp.length() > max.length())
	    			max=tmp;
	    		
	    		tmp="";
	        }
	     }

	     return max;
	}
}
