package org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.service;

import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.names.NamesDistanceCalculator;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessageTypesMapping;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.schemaRepresentation.xml.XMLBuiltInTypes;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;


public class BuiltInMessageTypesDistanceCalculator {


	public static MessageTypesMapping calculate( String namesDistanceCalculator, String targetSchemaRepresentationModel, MessageType mt1, MessageType mt2 ){

		double ND = XMLBuiltInTypes.getDistance( mt1.getReferencedComponent().getType(), mt2.getReferencedComponent().getType() ); PrintMessages.print( PrintMessages.mappingPrint, "Message type distance: ND(" +  mt1.getReferencedComponent().getType() + ", " +  mt2.getReferencedComponent().getType() + ") = " + ND );


		double distance;

		if( ND == 1.0 ) distance = 1.0;

		else{

			double NED = NamesDistanceCalculator.calculate( namesDistanceCalculator, mt1.getName(), mt2.getName() ); PrintMessages.print( PrintMessages.mappingPrint, "Message type distance: NED(" + mt1.getName() + ", " + mt2.getName() + ") = " + NED );

			distance = ( NED + ND ) / 2; PrintMessages.print( PrintMessages.mappingPrint, "Message type distance: d(" + mt1.getTag() + ", " + mt2.getTag() + ") = " + distance );
		}


		if( distance == 1.0 ) return null;

		else{

			MessageTypesMapping messageTypesMapping = new MessageTypesMapping();

			messageTypesMapping.add( mt1 );
			messageTypesMapping.add( mt2 );
			messageTypesMapping.set( targetSchemaRepresentationModel );
			messageTypesMapping.set( distance );

			return messageTypesMapping;
		}
	}
}
