package org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.service.hungarianAlgorithm;

import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.names.NamesDistanceCalculator;
import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.service.DistanceCalculatorController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.service.MessagesDistanceCalculator;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessagesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.OperationsMapping;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.serviceRepresentation.functional.Operation;


public class OperationsDistanceCalculatorHungarianAlgorithm {


	public static OperationsMapping calculate( String namesDistanceCalculator, String schemaRepresentationModel, String abstractionDepth, Double similarityLintel, Operation op1, Operation op2 ){

		OperationsMapping operationsMapping = null;
		double distance = Double.MAX_VALUE;
		
		if(!abstractionDepth.equals("Operations")){
			MessagesMapping inputMappings = MessagesDistanceCalculator.calculate( DistanceCalculatorController.getHungarianAlgorithm(), namesDistanceCalculator, schemaRepresentationModel, abstractionDepth, similarityLintel, op1.getInMessage(), op2.getInMessage() );
			MessagesMapping outputMappings = MessagesDistanceCalculator.calculate( DistanceCalculatorController.getHungarianAlgorithm(), namesDistanceCalculator, schemaRepresentationModel, abstractionDepth, similarityLintel, op1.getOutMessage(), op2.getOutMessage() );
	
	
			if( inputMappings == null || outputMappings == null ) return null;//It means that the operations do not match!
	
	
			//After this point, it is sure that the distance will be < 1!
	
			double inputDistance = inputMappings.getDistance();
			double outputDistance = outputMappings.getDistance();
	
			double NED = NamesDistanceCalculator.calculate( namesDistanceCalculator, op1.getName(), op2.getName() ); PrintMessages.print( PrintMessages.mappingPrint, "Operation distance: NED (" + op1.getName() + ", " + op2.getName() + ") = " + NED );
	
			double dIO = ( inputDistance + outputDistance ) / 2; PrintMessages.print( PrintMessages.mappingPrint, "Operation distance: dIO (" + op1.getName() + ", " + op2.getName() + ") = " + dIO );
	
			distance = ( NED + dIO ) / 2; 
			
			PrintMessages.print( PrintMessages.mappingPrint, "Operation distance: d (" + op1.getName() + ", " + op2.getName() + ") = " + distance );
	
			operationsMapping = new OperationsMapping();
			operationsMapping.add( op1 );
			operationsMapping.add( op2 );
			operationsMapping.set( distance );
			operationsMapping.setInputMappings( inputMappings );
			operationsMapping.setOutputMappings( outputMappings );
		}
		else{
			distance = NamesDistanceCalculator.calculate( namesDistanceCalculator, op1.getName(), op2.getName() ); 
			
			PrintMessages.print( PrintMessages.mappingPrint, "Operation distance: NED (" + op1.getName() + ", " + op2.getName() + ") = " + distance );
		
			operationsMapping = new OperationsMapping();
			operationsMapping.add( op1 );
			operationsMapping.add( op2 );
			operationsMapping.set( distance );
		}

		if(distance >= similarityLintel) return null;
		else return operationsMapping;
	}
}
