package org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.schema;

import java.util.ArrayList;
import java.util.List;

import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.measurements.number.DecimalPrecision;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


public class ComponentsAndStructuresMapping implements java.io.Serializable {


	//Variables.
	private static final long serialVersionUID = 7934118010113038122L;

	private double distance;

	private List<Object> componentsAndStructures;//It is not null! The objects are either components or structures.

	private List<ComponentsAndStructuresMapping> componentsAndStructuresMappings;


	//Empty constructor used for xml transformation
	public ComponentsAndStructuresMapping(){
				
	}
	
	//Setters.
	public void add( Object object ){

		if( componentsAndStructures == null ) componentsAndStructures = new ArrayList<Object>();

		componentsAndStructures.add( object );
	}

	public void set( double cDistance ){

		distance = cDistance;
	}

	public void set( List<ComponentsAndStructuresMapping> cComponentsAndStructuresMappings ){

		componentsAndStructuresMappings = cComponentsAndStructuresMappings;
	}


	//Getters.
	public double getDistance(){

		return distance;
	}

	public List<Object> getComponentsAndStructureMapping(){

		return componentsAndStructures;
	}

	public List<ComponentsAndStructuresMapping> getComponentsAndStructuresMappings(){

		return componentsAndStructuresMappings;
	}

	public Object getComponentOrStructure( String[] classPath ){

		Object componentOrStructure = null;


		for( int i = 0; componentsAndStructures != null && i < componentsAndStructures.size(); ++i ){

			if( SchemaRepresentationController.equalClassPath( classPath, componentsAndStructures.get( i ) ) ){

				componentOrStructure = componentsAndStructures.get( i );

				break;
			}
		}


		return componentOrStructure;
	}

	public Object getMappedComponentOrStructure( String[] classPath ){

		Object componentOrStructure = null;

		List<Integer> candidateIndices = null;


		boolean exist = false;

		for( int i = 0; componentsAndStructures != null && i < componentsAndStructures.size(); ++i ){

			if( SchemaRepresentationController.equalClassPath( classPath, componentsAndStructures.get( i ) ) ) exist = true;

			else{

				if( candidateIndices == null ) candidateIndices = new ArrayList<Integer>();

				candidateIndices.add( i );
			}
		}


		if( exist ){

			int randomIndex = ListGetters.getElementRandomly( candidateIndices );

			componentOrStructure = componentsAndStructures.get( randomIndex ) ;
		}


		return componentOrStructure;
	}


	//Visualization.
	public DefaultMutableTreeNode visualize( boolean root, DefaultMutableTreeNode node, String targetSchemaRepresentationModel ){

		String msg = "";

		if( root ) msg = " in '" + SchemaRepresentationController.getSchemaRepresentationModel( componentsAndStructures.get( 0 ) ) + "' calculated in '" + targetSchemaRepresentationModel + "':";


		DefaultMutableTreeNode child1 = new DefaultMutableTreeNode( "Components and structures mapping" + msg );

		node.add( child1 );


		DefaultMutableTreeNode child12 = new DefaultMutableTreeNode( "Distance = " + DecimalPrecision.setFourDecimalsPrecisionHalfDown( distance ) );

		child1.add( child12 );


		for( int i = 0; componentsAndStructures != null && i < componentsAndStructures.size(); ++i ){

			int label = i + 1;


			msg = null;

			if( XMLSchemaRepresentationController.isComponentKind( componentsAndStructures.get( i ) ) ) msg = "Component (" + label + "): ";

			else msg = "Structure (" + label + "): ";


			DefaultMutableTreeNode child13 = new DefaultMutableTreeNode( msg );

			child13.add( SchemaRepresentationController.visualize( componentsAndStructures.get( i ) ) );

			child1.add( child13 );
		}

		for( int i = 0; componentsAndStructuresMappings != null && i < componentsAndStructuresMappings.size(); ++i ) child1 = componentsAndStructuresMappings.get( i ).visualize( false, child1, targetSchemaRepresentationModel );


    	return node;
	}
	
	//Setters used for xml transformation
	
	public void setxDistance( double cDistance ){
		distance = cDistance;
	}
			
	public void setxComponentsAndStructures( List<Object> cComponentsAndStructures ){
		componentsAndStructures = cComponentsAndStructures;
	}
			
	public void setxComponentsAndStructuresMappings( List<ComponentsAndStructuresMapping> cComponentsAndStructuresMappings ){
		componentsAndStructuresMappings = cComponentsAndStructuresMappings;
	}
	
	//Getters used for xml transformation
	
	public double getxDistance(){
		return distance;
	}
			
	public List<Object> getxComponentsAndStructures(){
		return componentsAndStructures;
	}
			
	public List<ComponentsAndStructuresMapping> getxComponentsAndStructuresMappings(){
		return componentsAndStructuresMappings;
	}
}
