package org.ow2.choreos.abstractionGenerator;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import javax.jws.WebMethod;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.InterfacesMapping;
import org.ow2.choreos.serviceRepresentation.functional.Operation;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;


public class BaseAbstractionImplService implements BaseAbstractionService{

	public InterfacesMapping interfaceMapping=null;
	private String serviceInstance=null;
	private String abstractionInterface=null;
	private String serviceInterface=null;
	protected String abstractionName;
	int calledInterfacePosition;
	public BaseAbstractionImplService(String abstractionName)
	{
		this.abstractionName = abstractionName;
	}
	
	
	public void setCurrentMapping(String directoryName, String fileName)
	{
		System.out.println("Function SetInterfacesMapping called");
		
		interfaceMapping= (InterfacesMapping) Serialiazer.readFromFile(directoryName, fileName);
	}
	
	@WebMethod
	public void setServiceInstance(String serviceInstance)
	{
		System.out.println("Function SetServiceInstance called");
		 this.serviceInstance=serviceInstance;
		 ClassCreation.createClassesFromWsdl (abstractionName, serviceInstance, false );
			
		 try {
			Thread.sleep(20000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		ClassCreation.correctPackage(abstractionName, false);
	
		 Serialiazer.WriteToFile(this.serviceInstance,abstractionName,abstractionName+"ServiceInstance");
	}
	
	@WebMethod
	public void setServiceInterface(String serviceInterface)
	{
		System.out.println("Function SetServiceInterface called");
		this.serviceInterface=serviceInterface;
		Serialiazer.WriteToFile(this.serviceInterface,abstractionName,abstractionName+"ServiceInterface");
	}
	
	public void setAbstractionInterface ( String abstractionInterface )
	{
		this.abstractionInterface = abstractionInterface;
	}
	
	
	public String getServiceInstance()
	{
		return serviceInstance;
	}
	
	public String getServiceInterface() {
		return serviceInterface;
	}
	
	
	
	public String getAbstractionInterface()
	{
		return abstractionInterface;
		
	}
	

	public void LoadVariables()
	{
		setCurrentMapping(abstractionName,abstractionName);

		serviceInstance=(String) Serialiazer.readFromFile(abstractionName,abstractionName+"ServiceInstance");

		serviceInterface=((String) Serialiazer.readFromFile(abstractionName,abstractionName+"ServiceInterface"));
	}
	
	
	public ServiceInstance findServiceInstance ( ServiceInterface serviceInterface )
	{
		
		for ( int i = 0 ; serviceInterface !=null && i < serviceInterface.getServiceInstances().size() ; i ++ )
		{
			if ( serviceInterface.getServiceInstances().get(i).getURI().toLowerCase().equals( getServiceInstance().toLowerCase() ) )
				return serviceInterface.getServiceInstances().get(i) ;
		}
		return null;
	}
	
	public Object invoke( int operationIndexFromAbstraction , int indexFromInterface, InputOutputDataTranslator inputOutputDataTranslator )
	{
		System.out.println("Function invoke called for abstraction:"+abstractionName);		
		
		Operation operation = MappingsManipulation.getMappedOperation(interfaceMapping.getOperationsMappings(),operationIndexFromAbstraction, indexFromInterface);
		
		ServiceInterface serviceInterfaceCalled =interfaceMapping.getServiceInterfaces().get(MappingsManipulation.getInterfacePosition(interfaceMapping, getServiceInterface().toLowerCase()));
		calledInterfacePosition=MappingsManipulation.getInterfacePosition(interfaceMapping, getServiceInterface().toLowerCase());
		ServiceInstance serviceInstance = findServiceInstance( serviceInterfaceCalled );
		
		
		try 
		{
			//ClassLoader myClassLoader = ClassLoader.getSystemClassLoader();
			// Class service = myClassLoader.loadClass("org.ow2.choreos.abstractionGenerator.abstractionImpl."+abstractionName.toLowerCase()+".Classes." + serviceInterfaceCalled.getServiceTypeName());
			Class<?> service = Class.forName("org.ow2.choreos.abstractionGenerator.abstractionImpl."+abstractionName.toLowerCase()+".Classes." + serviceInterfaceCalled.getServiceTypeName() );
			
			Object methodObject = service.newInstance();
			
			Method servicePort = service.getMethod("get"+ serviceInstance.getName() );
			
			Object retobj  = servicePort.invoke(methodObject);
			
			Class<?> serviceImpl = Class.forName("org.ow2.choreos.abstractionGenerator.abstractionImpl."+abstractionName.toLowerCase()+".Classes."+serviceInterfaceCalled.getName());
			
			
			HashTableCreator hashTable =  new HashTableCreator ( ) ;
		//	System.out.println(MappingsManipulation.getInterfacePosition(interfaceMapping, abstractionName.toLowerCase()));
			Object [] obj = hashTable.traverseForEachPart( interfaceMapping, inputOutputDataTranslator, "In" , abstractionName , operationIndexFromAbstraction , 
					indexFromInterface,MappingsManipulation.getInterfacePosition(interfaceMapping, abstractionName.toLowerCase()) );
			System.out.println();

			Object [] object = getActualParameters( obj );
			
			Class<?> parametersTypesImpl[] = FunctionParameters.createParameters(obj);
			
			
		    Method function=serviceImpl.getMethod( operation.getName() , parametersTypesImpl );
			
	
			Object returnObj = function.invoke(retobj, object);
			
			System.out.print("\nreach end here!!\n-------------------------------------------------------------\n");
			
			return setReturnObject(operation.getName()  ,  returnObj );
			
		}
		catch (Throwable e) 
		{
			System.err.println(e);
		}
		return null;
	}
	
	
	public String firstCharacterToUpperCase(String name)
	{
		char[] temp = name.toCharArray();
		temp[0] = Character.toUpperCase(temp[0]);
		name = new String(temp);
		return name;
	}

	public Object setReturnObject(String operationName , Object returnValue)
	{
		
		try {
			
			Class < ? > returnClass =Class.forName("org.ow2.choreos.abstractionGenerator.abstractionImpl."+abstractionName.toLowerCase()+".Classes."+
			
					firstCharacterToUpperCase(operationName)+"Response");
			
			Object returnObject=returnClass.newInstance();
			
			
			Field [] fld = returnObject.getClass().getDeclaredFields();
		
			for ( int i=0 ; fld !=null && i < fld.length ; i++ )
			{
				fld[i].setAccessible(true);
				
				fld[i].set(returnObject, returnValue);
			}
			return returnObject;
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	
	
	
	
	public Object [] getActualParameters(Object []  operationArguments) 
	{   List<Object> operationParameters = null ;
		
	
		if ( operationArguments != null )
		{
			operationParameters = new ArrayList<Object>();	
			
		
			for ( int i = 0 ; i < operationArguments.length; i ++ )
			{
				Field [] fld = operationArguments[i].getClass().getDeclaredFields();
				
				for ( int j = 0 ; j < fld.length ; j ++)
				{fld[j].setAccessible(true);
					try {
						operationParameters.add(fld[j].get(operationArguments[i]));
					} catch (IllegalArgumentException e) {
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						e.printStackTrace();
					}
				}
			}
		}
		
		return operationParameters.toArray();
	}
	
	
	
	
	
	
	

	
	public void setOutPut(Object output, ServiceInterface abstractionServiceInterface, String operationName, Object result) {
		
		InputOutputDataTranslator inputOutPutTranslator = new InputOutputDataTranslator();
	
		inputOutPutTranslator .translate(output,"Out");
		long start =System.nanoTime();
		HashTableCreator outputHashTable = new HashTableCreator();
		long end = System.nanoTime();
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
		    out.print((end-start)+"  ");
		    out.close();
		} catch (IOException e) {}
		
		Operation operation = search(abstractionServiceInterface , operationName );
		
		Object [] obj = outputHashTable.traverseForEachOutPutPart(interfaceMapping, inputOutPutTranslator, operation, abstractionName, 
				MappingsManipulation.getOperationIndexFromAbstraction( abstractionServiceInterface , operationName ), 
				MappingsManipulation.getInterfacePosition( interfaceMapping , abstractionServiceInterface.getName().toLowerCase()), "Out", calledInterfacePosition);
	
		Field [] fld = result.getClass().getDeclaredFields();
		
		for ( int i=0; i<fld.length ; i++ )
		{
			fld[i].setAccessible(true);
			try {
				fld[i].set(result, obj[i] );
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public Object invokeConcreteService(Object input, String operationName, ServiceInterface abstractionServiceInterface) {
	
		InputOutputDataTranslator inputOutPutTranslator = new InputOutputDataTranslator();
		long start = System.nanoTime();
		
		inputOutPutTranslator.translate(input , "In");
		
		long end =System.nanoTime();
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
		    out.print((end-start)+ "  ");
		    out.close();
		} catch (IOException e) {}
		
		System.out.println("Time elapsed for translation:     " +(end-start));
		Object output = invoke( MappingsManipulation.getOperationIndexFromAbstraction( abstractionServiceInterface , operationName ) ,
				MappingsManipulation.getInterfacePosition( interfaceMapping , getServiceInterface().toLowerCase() ) , inputOutPutTranslator);
		
		
		return output;
	}
	
	public Operation search(ServiceInterface abstractionServiceInterface,
			String operationName) {
		for( int i=0 ; i< abstractionServiceInterface.getOperations().size() ; i++ )
			
			if(abstractionServiceInterface.getOperations().get(i).getName().equals(operationName))
				return abstractionServiceInterface.getOperations().get(i);
		return null;
				
	}
	
	
	////adaptation Methods
	
	
	@SuppressWarnings("unchecked")
	@WebMethod
	public void register ( String URI )
	{
		File f =  new File("src/main/java/org/ow2/choreos/abstractionGenerator/abstractionImpl/"+abstractionName.toLowerCase()+"/observedServices.ser");
		
		ArrayList< String > choreographyAffected = null ;
		
		if ( f.exists() ) choreographyAffected = (ArrayList<String>) Serialiazer.readFromFile(abstractionName.toLowerCase(), "observedServices");
		
		else choreographyAffected = new ArrayList < String > ();
		
		choreographyAffected.add(URI);
		
		Serialiazer.WriteToFile(choreographyAffected, abstractionName.toLowerCase(), "observedServices");
	}
	
	@SuppressWarnings("unchecked")
	@WebMethod
	public void unregister ( String URI )
	{	
		File file =  new File("src/main/java/org/ow2/choreos/abstractionGenerator/abstractionImpl/"+abstractionName.toLowerCase()+"/observedServices.ser");
		
		ArrayList< String > choreographyAffected = null ;
		
		if ( file.exists() ) choreographyAffected = (ArrayList<String>) Serialiazer.readFromFile(abstractionName.toLowerCase(), "observedServices");
		
		else choreographyAffected = new ArrayList < String > ();
		
		for ( int i = 0 ; choreographyAffected != null && i < choreographyAffected.size() ; i++ )
			if( choreographyAffected.get(i).equals(URI) )
			{ 
				choreographyAffected.remove(i);
				break;
			}
		
		Serialiazer.WriteToFile(choreographyAffected, abstractionName.toLowerCase(), "observedServices");
		
	}
	
	@SuppressWarnings("unchecked")
	@WebMethod
	public void adapt ( String adaptedServiceInterface , String adaptedServiceInstance )
	{
		long overall;
		long start;
		long end;
		overall=start=System.nanoTime();
		ArrayList < String > observedServices = ( ArrayList < String > ) Serialiazer.readFromFile(abstractionName, "observedServices");
		
		for ( int i =0  ; observedServices !=null && i < observedServices.size() ; i++ )
		{
		
			
		}
		end = System.nanoTime();
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\adaptphase1-700.txt", true)));
		    out.println((end-start)+"  ");
		   // out.println("\n");
		    out.close();
		} catch (IOException e) {}
		
		start=System.nanoTime();
		setServiceInstance(adaptedServiceInstance);
		
		setServiceInterface(adaptedServiceInterface);
		end=System.nanoTime();
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\adaptphase2-700.txt", true)));
		    out.println((end-start)+"  ");
		    //out.println("\n");
		    out.close();
		} catch (IOException e) {}
		
		start=System.nanoTime();
		for ( int i =0  ;observedServices !=null&& i < observedServices.size() ; i++ )
		{
			
		}	
		
		//end = System.nanoTime();
		long overend=end=System.nanoTime();
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\adaptphase3-700.txt", true)));
		    out.println((end-start)+"  ");
		    //out.println("\n");
		    out.close();
		} catch (IOException e) {}
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\adaptoverALL700.txt", true)));
		    out.println((overend-overall)+"  ");
		   // out.println("\n");
		    out.close();
		} catch (IOException e) {}
	}
	
	
	
	
}
