package org.ow2.choreos.abstractionGenerator;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.ParameterizedType;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.Random;


public class FunctionParameterValues 
{
		@SuppressWarnings("unchecked")
		public static Object instantiateTargetObject(Object part , Node rootOfTargetPart , Hashtable < Integer , CombinedKey > combinedKeyList) throws Throwable 
		{
			
			Object classInstance =null;
			
			CombinedKey combinedKey = getRandomCombinedKey(rootOfTargetPart,rootOfTargetPart.root.size(), combinedKeyList);
			
			//System.out.println("Level size   "+rootOfTargetPart.root.size());
			@SuppressWarnings("unused")
			Class [] imp=part.getClass().getInterfaces();
			
			if(isBuiltInType(part.getClass())==true)///part basic type
			{
				
				classInstance = createObject(part.getClass(), createValue(combinedKey));
			}
			
			else//Complex Type
			{	
				
				Constructor[] constructors = part.getClass().getDeclaredConstructors();
						
					classInstance = constructors[0].newInstance(null);
					Field [] fld=classInstance.getClass().getDeclaredFields();
					
					String [] valuesOfBultInTypes= combinedKey.combinedKeyValues.split(",");
					
					int currentValueForBuiltInTypes=0;
					int complexTypesAndLists=0;
					
					for(int i=0; i<fld.length;i++)
					{
						fld[i].setAccessible(true);
						Class [] implementedInterfaces=getImplementedInterfaces(fld[i]);
						
						if(fld[i].getType().isPrimitive() || fld[i].getType().isInstance("java.lang.String") //if field is primitive,string,BigInteger or BigDemical
								|| fld[i].getType()== java.math.BigInteger.class || fld[i].getType()==java.math.BigDecimal.class)
						{
							currentValueForBuiltInTypes = fillBuiltInTypes(fld[i], classInstance, valuesOfBultInTypes, currentValueForBuiltInTypes);
						}
						else if (implementedInterfaces[0] == java.util.List.class || implementedInterfaces[0] == java.util.Collection.class)
						{
							
							Object arrayInstance = new ArrayList<Object >();
						
														
							complexTypesAndLists = fillTargetLists(fld[i], classInstance, combinedKey,arrayInstance,rootOfTargetPart.root.get(combinedKey.getId()).childNodes.get(complexTypesAndLists), combinedKeyList, complexTypesAndLists,rootOfTargetPart.root.size());
							
							fld[i].set(classInstance,arrayInstance);
						}
						else
						{
							Node subTree=rootOfTargetPart.root.get(combinedKey.getId()).childNodes.get(complexTypesAndLists);
							
							Class<?> cls = Class.forName(fld[i].getType().getCanonicalName()); 
							Object t=instantiateTargetObject(cls.newInstance(),subTree, combinedKeyList);
							fld[i].set(classInstance, t);
							complexTypesAndLists++;
						}
						
					}
			
			//System.out.println("\ttraverse end!!!!! for: "+part.getClass().getSimpleName());
			}
			return classInstance;
}
		
		@SuppressWarnings("unchecked")
		private static int fillTargetLists(Field fld,Object part,CombinedKey combinedKey,Object arrayInstance, Node rootOfTargetPart, 
					Hashtable<Integer,CombinedKey> combinedKeyList, int index,int previousLevelSize) throws Throwable
		
		{
			Class<?> listClass=getListClass(fld);

			Method m=arrayInstance.getClass().getDeclaredMethod("add",Object.class);
			
			if(listClass.getGenericSuperclass()==java.lang.Number.class || listClass == java.lang.Boolean.class 
					|| listClass ==java.lang.Character.class || listClass.isInstance("java.util.String"))
			{
				CombinedKey combinedKeyOfList=getRandomCombinedKey(rootOfTargetPart.root.get(combinedKey.getId()).childNodes.get(index)
						,rootOfTargetPart.root.get(combinedKey.getId()).childNodes.get(index).root.size(), combinedKeyList);

				String [] valuesForList= combinedKeyOfList.combinedKeyValues.split(",");
				
				for(int j=0;j<valuesForList.length;j++)
					m.invoke(arrayInstance,createObject(listClass, valuesForList[j]));
				
				index++;
			}
			else
			{
				System.out.println("ArrayList with complex Type");
				Constructor [] ctors = listClass.getDeclaredConstructors();
				Object l= ctors[0].newInstance(null);
			
				
				System.out.println("--->"+rootOfTargetPart.root.size());
				for(int j=0;j<rootOfTargetPart.root.size();j++)
				{
					@SuppressWarnings("unused")
					CombinedKey combinedKeyOfList=getRandomCombinedKey(rootOfTargetPart
							,rootOfTargetPart.root.size(), combinedKeyList);
					
					m.invoke(arrayInstance,instantiateTargetObject(l, rootOfTargetPart, combinedKeyList));
				}
				
				index=index++;
			}
			return index;
			
			
		}

		@SuppressWarnings("unused")
		private static int findListSize(int numOfFields,Node node,int index,int numOfBuiltInTypes,int id) {
			int numOfRemainingFields=numOfFields-1-index-numOfBuiltInTypes; 
			
			int numOfChildNodes=node.root.size();
						
			return numOfChildNodes-numOfRemainingFields;
		}

		private static int fillBuiltInTypes(Field fld,Object classInstance,String [] valuesOfBultInTypes,int currentValuePositionForBuiltIn) throws Throwable
		{
			if(valuesOfBultInTypes[currentValuePositionForBuiltIn].startsWith("[") && valuesOfBultInTypes[currentValuePositionForBuiltIn].endsWith("]"))
			{
				valuesOfBultInTypes[currentValuePositionForBuiltIn] = valuesOfBultInTypes[currentValuePositionForBuiltIn].replace("[", "").replace("]","");
			}
			
			if(fld.getGenericType().toString().equals("int"))
				fld.set(classInstance, new Integer(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("class java.lang.String"))
				fld.set(classInstance,valuesOfBultInTypes[currentValuePositionForBuiltIn]);
			else if(fld.getGenericType().toString().equals("class java.math.BigInteger"))
				fld.set(classInstance,new BigInteger(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("float"))
				fld.set(classInstance,new Float(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("short"))
				fld.set(classInstance,new Short(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("double"))
				fld.set(classInstance,new Double(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("long"))
				fld.set(classInstance,new Long(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("boolean"))
				fld.set(classInstance,new Boolean(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("byte"))
				fld.set(classInstance,new Byte(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			else if(fld.getGenericType().toString().equals("class java.math.BigDecimal"))
				fld.set(classInstance,new BigDecimal(valuesOfBultInTypes[currentValuePositionForBuiltIn]));
			
			currentValuePositionForBuiltIn++;
			
			return currentValuePositionForBuiltIn;
			
		}
		
		private static Object createObject(Object part,String value)
		{
			Object obj =null;
			if(part.toString().equals("class java.lang.Integer"))
				obj = new Integer(value);
			else if(part.toString().equals("class java.lang.Float"))
				obj = new Float(value);
			else if(part.toString().equals("class java.lang.Double"))
				obj = new Double(value);
			else if(part.toString().equals("class java.lang.Byte"))
				obj = new Byte(value);
			else if(part.toString().equals("class java.lang.Long"))
				obj = new Long(value);
			else if(part.toString().equals("class java.lang.String"))
			{if(value !=null)
				obj = new String(value);
				else obj= null;
			}
			else if(part.toString().equals("class java.math.BigInteger"))
				obj = new BigInteger(value);
			else if(part.toString().equals("class java.math.BigDecimal"))
				obj = new BigDecimal(value);
			return obj;
		}
		
		private static int randomChoice(int numOfCombinedKeys) 
		{
			Random rand = new Random();
			
			return rand.nextInt(numOfCombinedKeys);
		}
		
		private static CombinedKey getRandomCombinedKey(Node node,int NumOfRowsInHashTable, Hashtable<Integer,CombinedKey> combinedKeyList)
		{
			
			int randomChoice = randomChoice(NumOfRowsInHashTable);
			
			Object [] keys = getHashTableKeys(node);
			
			CombinedKey combinedKey= new CombinedKey();
			
			return combinedKey.searchId(combinedKeyList,Integer.parseInt(keys[randomChoice].toString()));
		}
		
		private static Object [] getHashTableKeys(Node rootOfTargetPart)
		{
			Object [] keys = rootOfTargetPart.root.keySet().toArray();
			
			Arrays.sort(keys);
			
			return keys;
		}
		
		private static String createValue(CombinedKey combinedKey)
		{
			String value=null;
			if(combinedKey.combinedKeyValues.endsWith(","))
				value=combinedKey.combinedKeyValues.replace(",","");
			return value;
		}
		
		
		private static boolean isBuiltInType(Class<?> cls)
		{

			if(cls.toString().equals("class java.lang.Integer") || cls.toString().equals("class java.lang.Float")
			  ||cls.toString().equals("class java.lang.Double") || cls.toString().equals("class java.lang.Byte")
			  ||cls.toString().equals("class java.lang.Short")  || cls.toString().equals("class java.lang.Long")
			  ||cls.toString().equals("class java.lang.String") || cls.toString().equals("class java.math.BigInteger")
			  ||cls.toString().equals("class java.math.BigDecimal"))
				
			{
				return true;
			}
				return false;
		}
		
		
		@SuppressWarnings("unchecked")
		private static Class getListClass(Field fld)
		{
			ParameterizedType type = (ParameterizedType) fld.getGenericType();
			Class<?> listClass = (Class<?>) type.getActualTypeArguments()[0];
			return listClass;
		}
		
		@SuppressWarnings("unchecked")
		private static Class [] getImplementedInterfaces(Field fld)
		{
			Class [] implementedInterfaces=fld.getType().getInterfaces(); 
			
			if(implementedInterfaces.length==0)//if class doesn't implement any interface
			{
				implementedInterfaces= new Class[1];
				implementedInterfaces[0]=null;
			}
			return implementedInterfaces;
			
		}


}
