package org.ow2.choreos.abstractionGenerator;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Field;
import java.lang.reflect.ParameterizedType;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;

import javax.swing.JOptionPane;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.InterfacesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessageTypesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessagesMapping;
import org.ow2.choreos.dataStructures.list.listManipulation.ListTransformations;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;
import org.ow2.choreos.serviceRepresentation.functional.Operation;


@SuppressWarnings("serial")
public class HashTableCreator extends javax.swing.JFrame{


	//Variables.
	private static final long serialVersionUID = -2696198308632417591L;


	private Hashtable<String,Object> typeInstances=new Hashtable<String,Object>()
			{{
				put("int",new Integer("0"));
				put("long",new Long("0"));
				put("short",new Short("0"));
				put("float",new Float("0"));
				put("double",new Double("0"));
				put("byte",new Byte("0"));
				put("string",new String ("dummy info"));
				put("integer",new BigInteger("0"));
				put("decimal",new BigDecimal("0"));
				put("boolean",new Boolean("true"));	  
			}};
	
	private ArrayList<Node> targetPartTrees;
	private Hashtable<Integer, CombinedKey> combinedKeys;
	
	public HashTableCreator()
	{
		targetPartTrees=new ArrayList<Node>();
		combinedKeys=new Hashtable<Integer,CombinedKey>();
	}
		
	public List<MessageType> getInOrOutMessageTypes ( Operation operation , String inOrOut )
	{
		if ( operation !=null  &&  inOrOut != null )
		{
			if ( inOrOut.equals ( "In" ) && operation.getInMessage() != null ) return operation.getInMessage().getMessageTypes();
		
			else if (inOrOut.equals( "Out" ) && operation.getOutMessage() != null ) return operation.getOutMessage().getMessageTypes();
	
		}
		return null;
	}
	
	public Object[] traverseForEachPart(InterfacesMapping interfaceMapping,InputOutputDataTranslator inputOutputTables,String inOrOut, 
			String abstractionName, int operationIndexFromAbstraction, int indexFromInterface, int calledInterfacePosition)
	{
		List<Object> operationArguments = null;
		
		
		List<MessageType> msgTypesForTargetOPeration=getInOrOutMessageTypes(MappingsManipulation.getMappedOperation(interfaceMapping.getOperationsMappings()
				,operationIndexFromAbstraction, indexFromInterface), inOrOut);
		
		
		MessagesMapping messageMappings = MappingsManipulation.getMessageMappings(interfaceMapping.getOperationsMappings(), operationIndexFromAbstraction, inOrOut);
		
		if(msgTypesForTargetOPeration!=null) operationArguments = new ArrayList<Object>();
		
		for ( int i=0; msgTypesForTargetOPeration != null && i < msgTypesForTargetOPeration.size(); i++ )
		{
		   Object obj=null;
		   obj=createObject(msgTypesForTargetOPeration.get(i),abstractionName,"Classes");
		   try {
			   
			  long start=System.nanoTime();
			  targetPartTrees.add(traverseTargetPart(obj, inputOutputTables, new ArrayList<String>(),messageMappings, msgTypesForTargetOPeration.get(i),i,indexFromInterface, -1, -1, calledInterfacePosition));
			  long end =System.nanoTime();
				
			  try {
				    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
				    out.print((end-start)+"  ");
				    //out.println("--------------------------");
				    out.close();
				} catch (IOException e) {}
				
				System.out.println("Time elapsed for hashMaps: "+(end-start));
				long startOfInstansiation=System.nanoTime();
			  operationArguments.add(FunctionParameterValues.instantiateTargetObject(obj,targetPartTrees.get(targetPartTrees.size()-1),combinedKeys));
			  long endforinstansiation =System.nanoTime();				
			  try {
				    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
				    out.print((endforinstansiation-startOfInstansiation)+" ");
				    
				    out.close();
				} catch (IOException e) {}
				
				
				System.out.println("Time elapsed for instansiation: "+(endforinstansiation-startOfInstansiation));
		   } 
		   catch (Exception e) {  e.printStackTrace();} 
		   catch (Throwable e) { e.printStackTrace(); }
		 
		}

		return operationArguments != null ? operationArguments.toArray() : null; 
	}
	
	
	public Object [] traverseForEachOutPutPart( InterfacesMapping interfaceMapping,InputOutputDataTranslator inputOutputTables , 
			Operation operation, String abstractionName , int operationIndexFromAbstraction, int indexFromInterface, String inOrOut, int calledInterfacePosition )
	{
		List<Object> operationResults = null;
		
		MessagesMapping messageMappings = MappingsManipulation.getMessageMappings(interfaceMapping.getOperationsMappings(), operationIndexFromAbstraction, inOrOut);
		
		for ( int i=0; i < operation.getOutMessage().getMessageTypes().size() ; i ++ )
		{
			if(operationResults == null ) operationResults = new ArrayList<Object>();
			
			
			
			
			Object obj=null;
			obj=createObject(operation.getOutMessage().getMessageTypes().get(i),abstractionName,abstractionName.toLowerCase());
			
			
			try {
				long start = System.nanoTime();
				targetPartTrees.add(traverseTargetPart(obj, inputOutputTables, new ArrayList < String > (),
						messageMappings,operation.getOutMessage().getMessageTypes().get(i), i, indexFromInterface, -1, -1, calledInterfacePosition));
				long end =System.nanoTime();
				
				  try {
					    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
					    out.print((end-start)+"  ");
					    //out.println("--------------------------");
					    out.close();
					} catch (IOException e) {}
				  long start1=System.nanoTime();
				operationResults.add(FunctionParameterValues.instantiateTargetObject(obj,targetPartTrees.get(targetPartTrees.size()-1),combinedKeys));
				long end1 =System.nanoTime();
				
				  try {
					    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\ok\\Desktop\\out.txt", true)));
					    out.print((end1-start1)+"  ");
					    //out.println("--------------------------");
					    out.close();
					} catch (IOException e) {}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Throwable e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		return operationResults != null ? operationResults.toArray() : null;
		
		
	}
	
	
	@SuppressWarnings("unchecked")
	public Node traverseTargetPart(Object part , InputOutputDataTranslator inputOutputTables , ArrayList<String> path ,
		MessagesMapping messageMappings , MessageType msgType , int partNum ,int indexFromInterface , int  from , int to , int calledInterfacePosition ) throws Exception 
	{
		//System.out.println("traverse called!!!!!!!!!!!!: "+path);
		
		Node root = new Node ();
		
		if(isBuiltInType(part.getClass())==true)
			return createHashTableForBuiltInType(msgType.getName(), inputOutputTables, messageMappings, partNum, indexFromInterface);
		else
		{
			
			createPath ( path , StringManager.firstCharacterToLowerCase ( part.getClass().getSimpleName() ) , "" );
			
			ArrayList<CombinedKey> cmbKeyList = createCombinedKeys ( part , inputOutputTables , messageMappings , path , from , to, partNum, indexFromInterface ,calledInterfacePosition);
			
			if(cmbKeyList!=null)
			{
				for(int j=0; j< cmbKeyList.size();j++)
				{
					
					SubTree subTree= new SubTree();
					
					Field [] fld = part.getClass().getDeclaredFields();
					
					
					for(int i=0; i< fld.length;i++)
					{
						
						Class [] implementedInterfaces=getImplementedInterfaces(fld[i]);
						
						if ((implementedInterfaces[0] == java.util.List.class || 
							 implementedInterfaces[0] == java.util.Collection.class) && isBasicType(fld[i])==false)
						{
							createHashTableForList(fld[i] , messageMappings , inputOutputTables, path, subTree, cmbKeyList.get(j).from,cmbKeyList.get(j).to , partNum , indexFromInterface, calledInterfacePosition );
						}
						else if(isBasicType(fld[i])==false)
						{
							
							Class<?> cls =Class.forName(fld[i].getType().getCanonicalName());
							
							subTree.addElement(traverseTargetPart(cls.newInstance(), inputOutputTables, new ArrayList<String>() , messageMappings, msgType, partNum , indexFromInterface , cmbKeyList.get(j).from,  cmbKeyList.get(j).to, calledInterfacePosition ));
							
						}
					}
					root.addElementToHashTable(cmbKeyList.get(j).getId(), subTree);
				}
			}

		}
		return root;
	}
	
	
	
	
	
	

	private void createPath(ArrayList<String> path, String name,String type) 
	{
		if(type.equals(""))
			path.add(name);
		else if(name.startsWith("_"))
			path.add(name.replace("_", "")+","+type);
		else
			path.add(name+","+type);
	}


	private void createHashTableForList(Field fld, MessagesMapping messageMappings, 
			InputOutputDataTranslator inputOutputTables, ArrayList<String> path,SubTree subTree,int from,int to, int partNum, int indexFromInterface, int calledInterfacePosition) throws Exception
	{
		///Lists!!!!
		Class<?> listClass=getListClass(fld);
		
		if(listClass.getGenericSuperclass()==java.lang.Number.class || listClass == java.lang.Boolean.class 
			||listClass ==java.lang.Character.class || listClass.isInstance("java.util.String"))
		{
			createPath(path,fld.getName(),listClass.getSimpleName().toLowerCase());
		    
			subTree.addElement ( createBuiltInListHashTable ( fld , messageMappings , inputOutputTables , path , from , to , partNum , indexFromInterface, calledInterfacePosition ));
		    
		}
		else
		{	///List with Complex Type!!
			path.add(listClass.getSimpleName());
			
			Class<?> cls =Class.forName(listClass.getCanonicalName());
			
			subTree.addElement(traverseTargetPart(cls.newInstance(), inputOutputTables, new ArrayList<String>() , messageMappings, null , partNum , indexFromInterface , from ,  to, calledInterfacePosition ));
			
		}
		
	}


	public Node createHashTableForBuiltInType(Object part,InputOutputDataTranslator inputOutputTables,MessagesMapping messageMappings, int partNum, int indexFromInterface)
	{
		
		Node root = new Node();
		
		ArrayList<Index> indexs=new ArrayList<Index>();
		
		String [] argumentName = null; 
		
		MessageTypesMapping messageTypesMapping=MappingsManipulation.getMessageTypes( messageMappings.getMessageTypesMapping() , partNum );
		
		String msg = MappingsManipulation.searchMappingsForBuiltInTypes(messageTypesMapping,part,indexFromInterface);
		
		if(msg != null)
		{
			argumentName = new String [1];
			argumentName [0] = msg; 
		}
		
	
		indexs.add ( findIndex ( argumentName , inputOutputTables.Header ) );
		
		ArrayList<List<Object>> columnsFromTable = copy ( inputOutputTables.Tables , indexs );
		
		Hashtable<String, String> combinedKeyValues = removeDuplicates ( columnsFromTable , indexs , -1 , -1 );
		
		getValuesFromHashTable ( combinedKeyValues , columnsFromTable , root);
		
		return root;
	}
	
	public Node createBuiltInListHashTable( Field fld , MessagesMapping messageMappings , InputOutputDataTranslator inputOutputTables , ArrayList<String> path , int from , int to , int partNum , int indexFromInterface, int calledInterfacePosition )
	{ 
		System.out.println("List !!!!");
		Node node = new Node ();
		
		 String [] argumentName = MappingsManipulation.searchMappingsForComponentOrStructure(MappingsManipulation.getMessageTypes( messageMappings.getMessageTypesMapping() , partNum )
				,ListTransformations.convert2Array(path), indexFromInterface, calledInterfacePosition); 
			
		ArrayList<Index> indexs =new ArrayList<Index>();
			
		indexs.add(findIndex(argumentName,inputOutputTables.Header));
			
		ArrayList<List<Object>> columnsFromTable=copy(inputOutputTables.Tables, indexs);

		Hashtable<String, String> combinedKeyValues=removeDuplicates(columnsFromTable, indexs,from,to);
			
		Enumeration<String> e = combinedKeyValues.elements();

		String listValues ="";
		while(e.hasMoreElements())
		    listValues=listValues.concat(e.nextElement().toString());
			
		CombinedKey cmbKey=new CombinedKey(listValues);
		combinedKeys.put(cmbKey.getId(),cmbKey);
		  
		node.addElementToHashTable(cmbKey.getId(), new SubTree());
		
		path.remove(fld.getName());   
		
		return node;
	}
	
	
	
	private ArrayList<CombinedKey> createCombinedKeys ( Object targetPart , InputOutputDataTranslator inputOutputTables , 
					 MessagesMapping messageMappings,ArrayList<String> path,int from,int to, int partNum , int indexFromInterface, int calledInterfacePosition) 
	{
		
		ArrayList<CombinedKey> combinedKeyList = null;
		
		ArrayList<Index> indexs = createIndexs(targetPart, inputOutputTables, messageMappings,path, partNum, indexFromInterface , calledInterfacePosition);
		
		ArrayList<List<Object>> columnsFromTable = copy(inputOutputTables.Tables, indexs);
		
		Hashtable<String,String> combinedKeyValues=removeDuplicates(columnsFromTable, indexs,from , to);
		
		Enumeration<String> e = combinedKeyValues.elements();
		
		
		if(e!=null) combinedKeyList = new ArrayList<CombinedKey>();
	    while(e.hasMoreElements())
	    {
	    	String s=e.nextElement().toString();
	 
	    	CombinedKey cmbKey=new CombinedKey(columnsFromTable,s);
	  
	    	combinedKeyList.add(cmbKey);
	    	combinedKeys.put(cmbKey.getId(),cmbKey);
	    	
	    }
	    
		return combinedKeyList;
	}
	
	public ArrayList<Index> createIndexs(Object targetPart,InputOutputDataTranslator inputOutputTables,MessagesMapping messageMappings,ArrayList<String> path, int partNum, int indexFromInterface, int calledInterfacePosition)
	{
		ArrayList<Index> indexs = new ArrayList<Index>();	
		
		Field [] fld= targetPart.getClass().getDeclaredFields(); //Get fields of target CLASS
		
		Boolean builtInExist  = false;
		Boolean dummyClassBuiltInClass = false;
		for(int i=0; i<fld.length;i++)
		{
			if(fld[i].getType().isPrimitive() || fld[i].getType().isInstance("java.lang.String")
					|| fld[i].getType()== java.math.BigInteger.class || fld[i].getType()==java.math.BigDecimal.class)
			{
				dummyClassBuiltInClass = true;
			}
		}
		
		Field fields[] = fld;
		
		if ( dummyClassBuiltInClass == false && fields.length == 1 ) 
		{
			fld =fld[0].getClass().getDeclaredFields(); 
			path.remove(path.size()-1);
		}
		
		for(int i=0; i<fld.length;i++)
		{
			
			if(fld[i].getType().isPrimitive() || fld[i].getType().isInstance("java.lang.String")
					|| fld[i].getType()== java.math.BigInteger.class 
					|| fld[i].getType()==java.math.BigDecimal.class)
			{
				builtInExist = true ;
				createPath(path, fld[i].getName(),fld[i].getType().getSimpleName());
				
				String [] argumentName = MappingsManipulation.searchMappingsForComponentOrStructure(MappingsManipulation.getMessageTypes( messageMappings.getMessageTypesMapping() , partNum )
						,ListTransformations.convert2Array(path), indexFromInterface , calledInterfacePosition);
				
				Index ind = findIndex ( argumentName , inputOutputTables.Header );
				
				if(ind!=null)
					indexs.add(ind);
				path.remove(path.size()-1);
			}
		}
		
		if(builtInExist.equals(false)) 
		{
			JOptionPane.showMessageDialog(null,"Built In Type Does't Exist !! Exiting!");
			System.out.println("Built In Type Does't Exist Call Aborted");
			System.exit(ABORT);
		}

		return indexs;
	}
	
	
	public void getValuesFromHashTable(Hashtable<String, String> combinedKeyValues,ArrayList<List<Object>> columnsFromTable,Node levelNode)
	{
		Enumeration<String> e = combinedKeyValues.elements();
	    while(e.hasMoreElements())
	    {
	    	String s=e.nextElement().toString();
	    	CombinedKey cmbKey=new CombinedKey(columnsFromTable,s);
	    	combinedKeys.put(cmbKey.getId(),cmbKey);
	  
	    	levelNode.root.put(cmbKey.getId(), new SubTree());
	    }
	}
	
	public Index findIndex(String [] argumentName,ArrayList<ArrayList<String[]>> header)
	{
		if(argumentName!=null)
		{
			for(int i=0;i<header.size();i++)
			{
				for(int j=0;j<header.get(i).size();j++)
				{
					if( Arrays.equals( StringManager.convertArrayToLowerCase( header.get(i).get(j) ) , StringManager.convertArrayToLowerCase(argumentName) ))
					{
						Index index =new Index();
						index.setPartNum(i);
						index.setArgumentNum(j);
						return index;
				
					}
				}
			}
		}
		return null;
	}
	
	
	
	
	public Hashtable<String, String> removeDuplicates(ArrayList<List<Object>> columnsFromTable,ArrayList<Index> indexs,int from ,int to)
	{
		Hashtable<String, String> combinedKeyValues= new Hashtable<String,String>();
		
		if(columnsFromTable.size()!=0)
		{
			if( from==-1 && to==-1)
			{
				from=0;
				to=columnsFromTable.get(0).size();
			}
			
			for(int i=from;i<to;i++)
			{
				String tableLine="";
				for(int j=0;j<columnsFromTable.size();j++)
				{
					if( columnsFromTable.get(j).get(i) !=null)
					tableLine=tableLine.concat(columnsFromTable.get(j).get(i).toString()+",");
				}
				
				combinedKeyValues.put(tableLine, tableLine);
			}
			
		}
		
		return combinedKeyValues;
		
	}
	
	public ArrayList<List<Object>> copy(ArrayList<ArrayList<List<Object>>>tables,ArrayList<Index> indexs)
	{
		if(indexs!=null)
		{
			ArrayList<List<Object>> columsFromTable = new ArrayList<List<Object>>();
		
			for(int i=0;i<indexs.size();i++)
			{
				if(indexs.get(i)!=null)
				{
					int partNum=indexs.get(i).getPartNum();
					int argument=indexs.get(i).getArgumentNum();
					if(partNum!=-1 && argument!=-1)
						columsFromTable.add(tables.get(partNum).get(argument));
				}
			}
		return columsFromTable;
		}
		return null;
	}
	
	
	
	/**
	 * 
	 * @param cls  any class
	 * @return true if class is built in type 
	 */
	public boolean isBuiltInType(Class<?> cls)
	{

		if(cls.toString().equals("class java.lang.Integer") || cls.toString().equals("class java.lang.Float")
		  ||cls.toString().equals("class java.lang.Double") || cls.toString().equals("class java.lang.Byte")
		  ||cls.toString().equals("class java.lang.Short")  || cls.toString().equals("class java.lang.Long")
		  ||cls.toString().equals("class java.lang.String") || cls.toString().equals("class java.math.BigInteger")
		  ||cls.toString().equals("class java.math.BigDecimal") ||cls.toString().equals("class java.lang.Boolean"))
			
		{
			return true;
		}
			return false;
	}
	
	
	@SuppressWarnings("unchecked")
	private Class getListClass(Field fld)
	{
		ParameterizedType type = (ParameterizedType) fld.getGenericType();
		Class<?> listClass = (Class<?>) type.getActualTypeArguments()[0];
		return listClass;
	}
	
	@SuppressWarnings("unchecked")
	private Class [] getImplementedInterfaces(Field fld)
	{
		Class [] implementedInterfaces=fld.getType().getInterfaces(); 
		
		if(implementedInterfaces.length==0)//if class doesn't implement any interface
		{
			implementedInterfaces= new Class[1];
			implementedInterfaces[0]=null;
		}
		return implementedInterfaces;
		
	}
	
	private boolean isBasicType(Field fld)
	{
		
		return (fld.getType().isPrimitive() || fld.getType().isInstance("java.lang.String") 
				|| fld.getType()== java.math.BigInteger.class || fld.getType()==java.math.BigDecimal.class) ?true:false;
	}
	
	
	public Object createObject(MessageType msgType,String abstractionName,String inOrOut)
	{
		Object obj=typeInstances.get(msgType.getReferencedComponent().getType());
		if(obj==null)
		{
			try {
				Class <?> cls=Class.forName("org.ow2.choreos.abstractionGenerator.abstractionImpl."+abstractionName.toLowerCase()+"."+inOrOut+"."+StringManager.firstCharacterToUpperCase(msgType.getReferencedComponent().getType()));
				obj=cls.newInstance();
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return obj;
	}
}
