package org.ow2.choreos.abstractionGenerator;

import java.util.List;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.schema.ComponentsAndStructuresMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.InterfacesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessageTypesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.MessagesMapping;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.OperationsMapping;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;
import org.ow2.choreos.serviceRepresentation.functional.Operation;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;

public class MappingsManipulation 
{
	
	public static int getOperationIndexFromAbstraction(ServiceInterface serviceInterface,String operationName)
	{

		List<Operation> operations = null ;
		
		if ( serviceInterface != null ) operations=serviceInterface.getOperations();
		
		for( int operationIndexFromAbstraction = 0 ; operations != null && operationName != null && operationIndexFromAbstraction < operations.size(); operationIndexFromAbstraction ++ )
		{
			if(operations.get(operationIndexFromAbstraction).getName().equals(operationName))
			{
				return operationIndexFromAbstraction;
			}
		}
		return -1;
	}
	
	public static int getInterfacePosition (InterfacesMapping interfacesMapping , String serviceInterface )
	{
		
		List<ServiceInterface>  serviceInterfaces = interfacesMapping.getServiceInterfaces();

		for(int position = 0; serviceInterfaces !=null && serviceInterface != null && position < serviceInterfaces.size(); position++ )
		{
			if(serviceInterfaces.get(position).getName().toLowerCase().equals(serviceInterface))
			{
				return position;
			}
		}
		return -1;
	}
	
	
	
	
	
	public static Operation getMappedOperation(List<OperationsMapping> operationMapping,int indexFromAbstraction,int indexFromInterface)
	{
		System.out.println("www: "+operationMapping.size());

		return indexFromAbstraction!=-1 && indexFromInterface!=-1 ? operationMapping.get(indexFromAbstraction).getOperations().get(indexFromInterface): null;
	
	}
	
	public static MessagesMapping getMessageMappings(List<OperationsMapping> operationMapping,int operationIndexFromAbstraction,String inOrOut)
	{
		if(inOrOut.equals("In"))
		
			return operationMapping !=null && operationIndexFromAbstraction !=-1 ? operationMapping.get(operationIndexFromAbstraction).getInputMappings() : null;
		
		else if (inOrOut.equals("Out"))
			
			return operationMapping !=null && operationIndexFromAbstraction !=-1 ? operationMapping.get(operationIndexFromAbstraction).getOutputMappings() : null;
		
		return null;
	}
	
	public static MessageType getMappedMessage ( MessageTypesMapping messageTypesMapping , int indexFromInterface )
	{
		
		return messageTypesMapping !=null && indexFromInterface !=-1 ? messageTypesMapping.getMessageTypes().get(indexFromInterface) : null;
		
	}
	
	
	public static MessageTypesMapping getMessageTypes(List<MessageTypesMapping> messageTypesMapping,int partNumber)
	{
		return messageTypesMapping != null ? messageTypesMapping.get(partNumber) : null;
		
	}
	
	
	public static Object getComponentOrStructure(ComponentsAndStructuresMapping componentAndStructureMapping , int indexFromInterface , String[] path, int calledInterfacePosition)
	{
		if(componentAndStructureMapping.getComponentsAndStructuresMappings()==null)
			return componentAndStructureMapping.getComponentsAndStructureMapping().get(indexFromInterface);
		else
		{
			for ( int currentComponent=0; currentComponent < componentAndStructureMapping.getComponentsAndStructuresMappings().size(); currentComponent ++)
			{
				if(SchemaRepresentationController.equalClassPath(path,componentAndStructureMapping.getComponentsAndStructuresMappings().get(currentComponent).getComponentsAndStructureMapping().get(indexFromInterface)))
				{
					return componentAndStructureMapping.getComponentsAndStructuresMappings().get(currentComponent).getComponentsAndStructureMapping().get(calledInterfacePosition);
					//return indexFromInterface==0 ? componentAndStructureMapping.getComponentsAndStructuresMappings().get(currentComponent).getComponentsAndStructureMapping().get(indexFromInterface) : 
						//componentAndStructureMapping.getComponentsAndStructuresMappings().get(currentComponent).getComponentsAndStructureMapping().get(indexFromInterface-1);
			}}
		}
		return null;
	
	}
	
	public static String searchMappingsForBuiltInTypes(MessageTypesMapping messageTypesMapping, Object part, int indexFromInterface)
	{
		MessageType msg = getMappedMessage(messageTypesMapping, indexFromInterface);
		
		
		if (msg.getName().equals(part.toString()) && indexFromInterface ==0 )
			return msg.getName();
		else 
		
			return getMappedMessage(messageTypesMapping, indexFromInterface-1).getName();
		
	}
	
	
	public static String [] searchMappingsForComponentOrStructure(MessageTypesMapping messageTypesMapping,String [] path,int indexFromInterface, int calledInterfacePosition)
	{
		Object obj = getComponentOrStructure(messageTypesMapping.getComponentsAndStructuresMapping(), indexFromInterface, path,calledInterfacePosition);
	
		if ( XMLSchemaRepresentationController.isComponentKind(obj)) return ( ( Component ) obj ).getClassPath();
		if (XMLSchemaRepresentationController.isStructureKind(obj))	 return ( ( Structure ) obj ).getClassPath();
		
		return null;
	}
	
	
	
}