package org.ow2.choreos.clusteringAlgorithms.partitionalClustering.kMeans;

public class DataPoint {

	//Variables.
	private double mX,mY;
	private String mObjName;
	private Cluster mCluster;
	private double mEuDt;

	//Constructor.
	protected DataPoint(double x, double y, String name) {
	    this.mX = x;
	    this.mY = y;
	    this.mObjName = name;
	    this.mCluster = null;
	}
	
	void setCluster(Cluster cluster) {
	    this.mCluster = cluster;
	    calcEuclideanDistance();
	}
	
	void calcEuclideanDistance() { 
	
	//called when DP is added to a cluster or when a Centroid is recalculated.
	    mEuDt = Math.sqrt(Math.pow((mX - mCluster.getCentroid().getCx()),
	2) + Math.pow((mY - mCluster.getCentroid().getCy()), 2));
	}
	
	double testEuclideanDistance(Centroid c) {
	    return Math.sqrt(Math.pow((mX - c.getCx()), 2) + Math.pow((mY - c.getCy()), 2));
	}
	
	public double getX() {
	    return mX;
	}
	
	double getY() {
	    return mY;
	}
	
	Cluster getCluster() {
	    return mCluster;
	}
	
	double getCurrentEuDt() {
	    return mEuDt;
	}
	
	String getObjName() {
	    return mObjName;
	}
}
