package org.ow2.choreos.dataStructures.array.arrayManipulation;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.array.arrayInstantiation.ArrayInstantiation;
import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.parser.freeTextDocuments.Tokenizer;


public class ArrayTransformations {


	public static boolean belongsTo( String value, String[] values ){

		for( int i = 0; values != null && i < values.length; ++i ) if( values[ i ].equals( value ) ) return true; 


		return false;
	}

	public static String[] concat( String[] array1, String[] array2 ) {

		if( array1 != null && array2 == null ) return array1;

		if( array1 == null && array2 != null ) return array2;

		if( array1 == null && array2 == null ) return null;


		String[] array = new String[ array1.length + array2.length ];

		System.arraycopy( array1, 0, array, 0, array1.length );

		System.arraycopy( array2, 0, array, array1.length, array2.length );

		return array;
	}

	public static String[] concat( String[] array1, String string2 ) {

		String[] array2 = null;

		if( string2 != null ) array2 = new String[] { string2 };


		return concat( array1, array2 );
	}

	public static String[] concat( String string1, String[] array2 ) {

		String[] array1 = null;

		if( string1 != null ) array2 = new String[] { string1 };


		return concat( array1, array2 );
	}

	public static Object[] concat( Object[] array1, Object[] array2 ) {

		if( array1 != null && array2 == null ) return array1;

		if( array1 == null && array2 != null ) return array2;

		if( array1 == null && array2 == null ) return null;


		Object[] array = new Object[ array1.length + array2.length ];

		System.arraycopy( array1, 0, array, 0, array1.length );

		System.arraycopy( array2, 0, array, array1.length, array2.length );


		return array;
	}

	public static Object[] concat( Object[] array1, Object object2 ) {

		Object[] array2 = null;

		if( object2 != null ) array2 = new Object[] { object2 };


		return concat( array1, array2 );
	}

	public static String[] concat( String[] array1, String[] array2, String[] array3, String[] array4 ) {

		if( array1 == null || array2 == null || array3 == null || array4 == null ) return null;

		String[] array12 = concat( array1, array2 );

		String[] array34 = concat( array3, array4 );

		return concat( array12, array34 );
	}

	public static List<Object> convert( Object[] array ) {

		List<Object> list = null;


		for( int i = 0; array != null && i < array.length; ++i ) list = ListInsertion.add( array[ i ], list );


		return list;
	}


	public static Object[] convert2ArrayOfSuffixes( Object[] array, String character ) {

		Object[] newArray = ArrayInstantiation.newArray( array );


		for( int i = 0; array != null && i < array.length; ++i ) newArray[ i ] = Tokenizer.getSuffix( (String) array[ i ], character );


		return newArray;
	}

	public static Object[] convert2ArrayOfSuffixes( Object object, String character ) {

		Object[] array = object != null ? ArrayInstantiation.newArray( 1 ) : null;


		if( object != null ) array[ 0 ] = Tokenizer.getSuffix( (String) object, character );


		return array;
	}


	public static String[] convert2OneDimensionArray( String[][] array ) {

		String[] newArray = null;


		if( array != null ){

			newArray = new String[ array.length ];

			for( int i = 0; i < array.length; ++i ) newArray[ i ] = new String( Arrays.toString( array[ i ] ) );
		}


		return newArray;
	}


	public static int[] copyOfRange( int[] array, int from, int to ){

		if( array == null || ( array != null && ( from < 0 || from > array.length -1 || to < 0 || to > array.length -1 ) ) ) return null;


		if( from == to ) return new int[]{ array[ from ] };

		else{

			int[] newArray = new int[ to - from + 1 ];

			for( int i = from, j = 0; i <= to; i++, j++ ) newArray[ j ] = array[ i ];


			return newArray;

		}
	}


	public static Object[] removeRepetitions( Object[] objects ){

    	Map<Object, Object> map = null;


    	for( int i = 0; objects != null && i < objects.length; ++i ) map = MapInsertion.put( objects[ i ], objects[ i ], map, false );


    	Object[] array = ArrayInstantiation.newArray( map );


    	int i = -1;

    	Iterator<Object> iterator = map != null && map.keySet() != null ? map.keySet().iterator() : null;

		while( iterator != null && iterator.hasNext() ) array[ ++i ] = map.get( iterator.next() );


    	return array; 
    }


	public static int[] removeRepetitions( int[] objects ){

    	Map<Object, Object> map = null;


    	for( int i = 0; objects != null && i < objects.length; ++i ) map = MapInsertion.put( objects[ i ], objects[ i ], map, false );


    	int[] array = ArrayInstantiation.newIntArray( map );


    	int i = -1;

    	Iterator<Object> iterator = map != null && map.keySet() != null ? map.keySet().iterator() : null;

		while( iterator != null && iterator.hasNext() ) array[ ++i ] = (Integer) map.get( iterator.next() );


    	return array; 
    }
}
