package org.ow2.choreos.dataStructures.list.listInsertion;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listInstantiation.ListInstantiation;


/**
 * 
 * @author dathanas
 *
 */
public class ListInsertion {


	static public void addSorted( Double key, Object value, List<Double> keys, List<Object> values ){

		if( key != null && value != null && keys != null && values != null ){

			int position = Math.abs( Collections.binarySearch( keys, (Double) key ) + 1 );

			ListInsertion.add( key, position, keys );

			ListInsertion.add( value, position, values );
		}
	}

	private static void add( Double item, int position, List<Double> list ){

		if( position < 0 ) list.add( 0, item );

		else if( position >= list.size() ) list.add( list.size(), item );

		else list.add( position, item );
	}


	static public List<Object> add( Object item, List<Object> list ){

		if( item != null ){

			list = ListInstantiation.newList( list );

			list.add( item );
		}


		return list;
	}

	public static List<Object> add( Object item, int position, List<Object> list ){

		if( item != null ){

			list = ListInstantiation.newList( list );


			if( position < 0 ) list.add( 0, item );

			else if( position >= list.size() ) list.add( list.size(), item );

			else list.add( position, item );
		}


		return list;
	}

	public static List<Object> addAll( List<Object> items, List<Object> list ){

		if( items != null ){

			list = ListInstantiation.newList( list );

			list.addAll( items );
		}


		return list;
	}

	public static List<ArrayList<Object>> addInListOfArrayLists( List<Object> item, List<ArrayList<Object>> list ){

		if( list == null && item != null ) list = ListInstantiation.newListOfArrayLists();

		if( item != null ) list.add( (ArrayList<Object>) item );


		return list;
	}

	public static List<Object[]> addInListOfArrays( Object[] item, List<Object[]> list ){

		if( list == null && item != null ) list = ListInstantiation.newListOfArrays();

		if( item != null ) list.add( item );


		return list;
	}

	public static List<List<Object>> addInListOfLists( List<Object> item, List<List<Object>> list ){

		if( list == null && item != null ) list = ListInstantiation.newListOfLists();

		if( item != null ) list.add( (ArrayList<Object>) item );


		return list;
	}

	public static List<Map<String, String>> addMap( Map<String, String> map, List<Map<String, String>> listOfMaps ){
	
		if( listOfMaps == null && map != null) listOfMaps = new ArrayList<Map<String, String>>();
	
		if( map != null ) listOfMaps.add( map );
	
	
		return listOfMaps;
	}
}
