package org.ow2.choreos.dataStructures.map.mapManipulation;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
public class MapPrinting {


	public static String printCommaSeparated( Map<String, String> map ){

		if( map == null ) return "";


		int i = 0;

		String enumeratedValue = "[";

		for( Enumeration<String> e = ( (Hashtable<String, String>) map ).keys(); e.hasMoreElements(); ){

			String key = e.nextElement();

			enumeratedValue += map.get( key );

			if( i < map.size() - 1 ) enumeratedValue += ", ";

			i++;
		}

		return enumeratedValue += "]";
	}

	public static String printSpaceSeparated( Map<String, String> exceptedKeys, Map<String, ?> map ){

		if( map == null ) return "";

		if( exceptedKeys != null ) exceptedKeys = MapTransfomation.toLowerCase( exceptedKeys );


		String enumeratedValue = " ";

		for ( Enumeration<String> e = ( (Hashtable<String, ?>) map ).keys(); e.hasMoreElements(); ){

			String key = e.nextElement();


			if( ! MapGetter.keyToLowerCaseBelongsToMapStrings( key, exceptedKeys ) ){

				if( enumeratedValue == null ) enumeratedValue = "";


				if( key.equals( SchemaRepresentationController.getTagNameKey() ) ) enumeratedValue += map.get( key ) + " ";

				else enumeratedValue += key + " = '" + map.get( key ) + "' ";
			}
		}


		return enumeratedValue;
	}

	public static String printSpaceSeparated( Map<String, String> map ){

		Map<String, String> exceptedKeys = null;


		return printSpaceSeparated( exceptedKeys, map );
	}

	public static void stdPrintSpaceSeparated( Map<String, ?> map ){

		Map<String, String> exceptedKeys = null;


		System.out.println( printSpaceSeparated( exceptedKeys, map ) );
	}

	@SuppressWarnings("serial")
	public static String printSpaceSeparated( final String exceptedKey, Map<String, String> map ){

		Map<String, String> exceptedKeys = new Hashtable<String, String>() { { put( exceptedKey, exceptedKey ); } };

		return printSpaceSeparated( exceptedKeys, map );
	}


	public static void stdPrintObjectsIndex( String[] printKinds, Map<String, Object> index, String indexName ){

		if( index != null ){

			if( PrintMessages.print( printKinds ) ){

				PrintMessages.stdPrint( printKinds , "\n\nindex: " + indexName );

				for ( Enumeration<String> e = ( (Hashtable<String, Object>) index ).keys(); e.hasMoreElements(); ){
	
					String key = e.nextElement();

					PrintMessages.stdPrint( printKinds , "key= " + key + " - value= " + XMLSchemaRepresentationController.getTag( index.get( key ) ) );
				}
			}
		}

		else PrintMessages.stdPrint( printKinds , "index: " + indexName + " Empty" );
	}

	public static void stdPrintObjectsIndex( String printKind, Map<String, Object> index, String indexName ){

		if( index != null ){

			if( PrintMessages.toPrint( printKind ) ){

				PrintMessages.stdPrintLn( printKind , "\n\nindex: " + indexName );

				for ( Enumeration<String> e = ( (Hashtable<String, Object>) index ).keys(); e.hasMoreElements(); ){
	
					String key = e.nextElement();

					PrintMessages.stdPrintLn( printKind , "key= " + key + " - value= " + XMLSchemaRepresentationController.getTag( index.get( key ) ) );
				}
			}
		}

		else PrintMessages.stdPrintLn( printKind , "index: " + indexName + " is Empty" );
	}

	public static void stdPrintStringIndex( String[] printKinds, Map<String, String> index, String indexName ){

		if( index != null ){

			if( PrintMessages.print( printKinds ) ){

				PrintMessages.stdPrint( printKinds , "\n\nindex: " + indexName );

				for ( Enumeration<String> e = ( (Hashtable<String, String>) index ).keys(); e.hasMoreElements(); ){
	
					String key = e.nextElement();

					PrintMessages.stdPrint( printKinds , "key= " + key + " - value= " + index.get( key ) );
				}
			}
		}

		else PrintMessages.stdPrint( printKinds , "index: " + indexName + " is Empty" );
	}
}
