package org.ow2.choreos.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.gui.guiManipulation.JFrameManipulation;


public class DocumentVisualizer extends JFrame {


	//Variables.
	private static final long serialVersionUID = 6420077863372830895L;

    private JButton jButton1, jButton2, jButton3, jButton4, jButton5, jButton6;
    private JLabel jLabel1, jLabel2, jLabel3, jLabel4, jLabel5, jLabel6, jLabel7, jLabel8, jLabel9, jLabel10, jLabel11, jLabel12, jLabel13, jLabel14, jLabel15, jLabel16, jLabel17;
    private JTextField jTextField1, jTextField2;
    private JScrollPane jScrollPane1;

    private final static String titleForParsingDocument = "Retrieving documents by using the Plugin Manager and parsing the retrieved documents";

    private final static String titleForSchemaDocument = "Schema Documents Visualizer";

    private final static String titleForServiceDocument = "Functional and non-functional properties of the selected document";

    private final static String titleForAbstraction = "Details of the selected abstraction";

    private final DocumentVisualizer visualizer = this;


    //Constructor 1: It visualizes functional and/or non-functional abstractions. This is also for nested abstractions!
    public DocumentVisualizer( DefaultMutableTreeNode abstractionNode, String abstractionKind, Integer abstractionID ){

    	super( titleForAbstraction );


    	initComponents();

    	initComponents1( abstractionNode, abstractionID, abstractionKind );

    	JFrameManipulation.setJScrollPane( jScrollPane1, abstractionNode, 2 );

    	locateComponents();

        setVisible( true );
    }

    private void initComponents1( DefaultMutableTreeNode abstractionNode, Integer abstractionID, String abstractionKind ){

        jButton5.setText( "Details" ); jButton5.setVisible( true );

        jButton5.addActionListener( visualizeAbstractionDetails( abstractionNode ) );

    	jLabel1.setText( "Selected:" );

    	jTextField1.setText( abstractionKind + " (" + abstractionID.toString() + ")" );
    }

    private ActionListener visualizeAbstractionDetails( final DefaultMutableTreeNode abstractionNode ){

        return new ActionListener(){

			public void actionPerformed( ActionEvent e ){

				if( jButton5.getText().equals( "Details" ) ){

					jButton5.setText( "Hide details" );

					JFrameManipulation.setJScrollPane( jScrollPane1, abstractionNode );
				}

				else{

					jButton5.setText( "Details" );

					JFrameManipulation.setJScrollPane( jScrollPane1, abstractionNode, 2 );
				}
            }
        };
    }

    //Constructor 3: for visualization of a service collection.
    /*public DocumentVisualizer( ServiceRegistration serviceRegistration, Integer collectionID, String selection ){

    	super("Visualizer");


    	initComponents( 3, "", "", "", "", "", "" );//3 is the visualizer id.
    }*/

    //Constructor 4a: It is used for visualizing the a right service document!
    public DocumentVisualizer( String ref2Source, String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs, String duration, int size, int depth, String memory, DefaultMutableTreeNode root ){

    	super( titleForParsingDocument );


    	initComponents();

    	initComponents4( ref2Source );

    	setTextOfComponentsForFunctionalDocuments( ref2DocOfFuncProperties, numOfDocs, numOfFuncDocs, parsedFuncDocs, numOfServiceTypes, numOfInterfaces, numOfInstances, numOfNonFuncDocs, parsedNonFuncDocs, duration, size, depth, memory, root );

    	locateComponents();

        setVisible( true );
    }

    //Constructor 4b: It is used for visualizing the an error service document!
    public DocumentVisualizer( String ref2Source, String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs, String errorMessage ){

    	super( titleForParsingDocument );


    	initComponents();

    	initComponents4( ref2Source );

    	setTextOfComponentsForFunctionalDocuments( ref2DocOfFuncProperties, numOfDocs, numOfFuncDocs, parsedFuncDocs, numOfServiceTypes, numOfInterfaces, numOfInstances, numOfNonFuncDocs, parsedNonFuncDocs, errorMessage );

    	locateComponents();

        setVisible( true );
    }

    private void initComponents4( String ref2Source ){

    	jLabel1.setText( "Service source:" );					jLabel1.setVisible( true );
    	jLabel4.setVisible( true );
    	jLabel8.setVisible( true );
    	jLabel9.setText( "Parsed document:" );					jLabel9.setVisible( true );
    	jLabel10.setText( "Non-Functional documents:" );		jLabel10.setVisible( true );
    	jLabel11.setVisible( true );
    	jLabel12.setVisible( true );
    	jLabel13.setText( "Current Document Statistics" );
    	jLabel14.setVisible( true );

    	jTextField1.setText( ref2Source );
		jTextField2.setVisible( true ); jTextField2.setEditable( false );
    }

    public void setTextOfComponentsForFunctionalDocuments( String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs, String errorMessage ){//It is used for error functional documents and not behavioral.

    	JTextArea jTextArea = new JTextArea( errorMessage );

    	jTextArea.setForeground( Color.RED );

    	jScrollPane1.setViewportView( new JScrollPane( jTextArea ) );


    	setTextOfComponentsForFunctionalDocuments( ref2DocOfFuncProperties, numOfDocs, numOfFuncDocs, parsedFuncDocs, numOfServiceTypes, numOfInterfaces, numOfInstances, numOfNonFuncDocs, parsedNonFuncDocs );
    }

    public void setTextOfComponentsForFunctionalDocuments( String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs, String duration, int size, int depth, String memory, DefaultMutableTreeNode root ){//It is used for right functional documents and not behavioral.

    	JFrameManipulation.setJScrollPane( jScrollPane1, root, 4 );


		jLabel13.setVisible( true );
    	jLabel14.setText( "1. Parsing duration: " + duration );          jLabel14.setVisible( true );

    	jLabel15.setText( "2. Document size (#components): " + size ); 	 jLabel15.setVisible( true );
    	if( size == 0 ) jLabel15.setVisible( false );

    	jLabel16.setText( "3. Avg depth of components: " + depth );		 jLabel16.setVisible( true );
    	if( depth == 0 ) jLabel16.setVisible( false );

    	if( size == 0 || depth == 0 ) jLabel17.setText( "2. Memory footprint for schema store: " + memory );
    	else jLabel17.setText( "4. Memory footprint for schema store: " + memory );
    	jLabel17.setVisible( true );


    	setTextOfComponentsForFunctionalDocuments( ref2DocOfFuncProperties, numOfDocs, numOfFuncDocs, parsedFuncDocs, numOfServiceTypes, numOfInterfaces, numOfInstances, numOfNonFuncDocs, parsedNonFuncDocs );
    }

    public void setTextOfComponentsForFunctionalDocuments( String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs, String duration, String memory ){//It is used for behavioral documents and not functional.

    	jLabel14.setText( "1. Parsing duration:" + duration );          	  jLabel14.setVisible( true );
    	jLabel17.setText( "2. Memory footprint for schema store:" + memory ); jLabel17.setVisible( true );
    }

    private void setTextOfComponentsForFunctionalDocuments( String ref2DocOfFuncProperties, int numOfDocs, int numOfFuncDocs, int parsedFuncDocs, int numOfServiceTypes, int numOfInterfaces, int numOfInstances, int numOfNonFuncDocs, int parsedNonFuncDocs ){

		jLabel2.setVisible( true );
    	jLabel3.setText( "Functional/Behavioral documents: " + numOfFuncDocs ); jLabel3.setVisible( true );

    	if( numOfFuncDocs > 0 ){

    		jLabel4.setText( "Parsed documents: " + parsedFuncDocs );
    		jLabel8.setText( "Unparsed documents: " + String.valueOf( numOfFuncDocs - parsedFuncDocs ) );
    	}

    	else{
    		jLabel4.setText( "Parsed documents: -" );
    		jLabel8.setText( "Unparsed documents: -" );
    	}

    	jLabel5.setText( "Service types: " + numOfServiceTypes ); 			 jLabel5.setVisible( true );
    	jLabel6.setText( "Interfaces: " + numOfInterfaces ); 	  			 jLabel6.setVisible( true );
    	jLabel7.setText( "Instances: " + numOfInstances );        			 jLabel7.setVisible( true );
    	jLabel10.setText( "Non-Functional documents: " + numOfNonFuncDocs ); jLabel10.setVisible( true );


    	if( numOfNonFuncDocs > 0 ){

    		jLabel11.setText( "Parsed documents: " + parsedNonFuncDocs );
    		jLabel12.setText( "Unparsed documents: " + String.valueOf( numOfNonFuncDocs - parsedNonFuncDocs ) );
    	}

    	else{

    		jLabel11.setText( "Parsed documents: -" );
    		jLabel12.setText( "Unparsed documents: -" );
    	}


    	jTextField2.setText( ref2DocOfFuncProperties );
    }


    //Constructor 5: It visualizes a service document (functional and non-functional properties)!
    public DocumentVisualizer( String ref2Source, String ref2DocOfFuncProperties, DefaultMutableTreeNode serviceTypesNode, DefaultMutableTreeNode interfacesNode, DefaultMutableTreeNode instancesNode, DefaultMutableTreeNode operationsNode, DefaultMutableTreeNode messagesNode, DefaultMutableTreeNode schemasNode ){

    	super( titleForServiceDocument );


    	initComponents();

    	initComponents5( ref2Source, interfacesNode, instancesNode, operationsNode, messagesNode, schemasNode );

    	setTextOfComponentsForServiceDocuments( ref2DocOfFuncProperties, serviceTypesNode );

    	locateComponents();

        setVisible( true );
    }

    private void initComponents5( String ref2Source, DefaultMutableTreeNode interfacesNode, DefaultMutableTreeNode instancesNode, DefaultMutableTreeNode operationsNode, DefaultMutableTreeNode messagesNode, DefaultMutableTreeNode schemasNode ){

    	jLabel1.setText( "Service source:" );
    	jLabel4.setVisible( true );
    	jLabel8.setVisible( true );
    	jLabel9.setText( "Service document:" );   jLabel9.setVisible( true );

    	jTextField1.setText( ref2Source );
		jTextField2.setVisible( true ); 		  jTextField2.setEditable( false );


    	jButton2.setText( "Service Interfaces" ); jButton2.setVisible( true ); jButton2.addActionListener( expandServiceDocument( interfacesNode, Integer.MAX_VALUE ) );
    	jButton3.setText( "Service Operations" ); jButton3.setVisible( true ); jButton3.addActionListener( expandServiceDocument( operationsNode, Integer.MAX_VALUE ) );
    	jButton4.setText( "Service Messages" );   jButton4.setVisible( true ); jButton4.addActionListener( expandServiceDocument( messagesNode, Integer.MAX_VALUE ) );
    	jButton5.setText( "Service Instances" );  jButton5.setVisible( true ); jButton5.addActionListener( expandServiceDocument( instancesNode, Integer.MAX_VALUE ) );
        jButton6.setText( "Schemas" ); 			  jButton6.setVisible( true ); jButton6.addActionListener( expandServiceDocument( schemasNode, 4 ) );
    }

    private ActionListener expandServiceDocument( final DefaultMutableTreeNode root, final int level ){

        return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				JFrameManipulation.setJScrollPane( jScrollPane1, root, level );
            }
        };
    }

    private void setTextOfComponentsForServiceDocuments( String ref2DocOfFuncProperties, DefaultMutableTreeNode serviceTypesNode ){

    	jTextField2.setText( ref2DocOfFuncProperties );

    	if( serviceTypesNode != null ) jScrollPane1.setViewportView( new JTree( serviceTypesNode ) );
    }


    //Constructor 6a.1: It visualizes a right schema document! (It is used by the parser).
    public DocumentVisualizer( String ref2Source, String ref2DocOfSchema, int totalNumOfDocOfSchemaDocs, int currentNumOfDocOfSchemaDocs, int numOfParsedDocOfSchemaDocs, String duration, String size, String depth, String memory, DefaultMutableTreeNode root ){

    	super( titleForSchemaDocument );

    	initComponents();

    	initComponents6( ref2Source );

    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, totalNumOfDocOfSchemaDocs, currentNumOfDocOfSchemaDocs, numOfParsedDocOfSchemaDocs, duration, size, depth, memory, root );

    	locateComponents();

        setVisible( true );
    }

    //Constructor 6a.2: It visualizes a right schema document! (It is used by the SchemaRegistrationVisualizer).
    public DocumentVisualizer( String ref2Source, String ref2DocOfSchema, String duration, String size, String depth, String memory, DefaultMutableTreeNode root, int visualizationLevel ){

    	super( titleForSchemaDocument );

    	initComponents();

    	initComponents6( ref2Source );

    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, duration, size, depth, memory, root, visualizationLevel );

    	locateComponents();

        setVisible( true );
    }

    //Constructor 6b.1: It visualizes an error schema document! It visualizes a right schema document! (It is used by the parser).
    public DocumentVisualizer( String ref2Source, String ref2DocOfSchema, String errorMessage ){

    	super( titleForSchemaDocument );

    	initComponents();

    	initComponents6( ref2Source );

    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, errorMessage );

    	locateComponents();

        setVisible( true );
    }

    //Constructor 6b.2: It visualizes an error schema document! (It is used by the SchemaRegistrationVisualizer).
    public DocumentVisualizer( String ref2Source, String ref2DocOfSchema, int totalNumOfDocOfSchemaDocs, int currentNumOfDocOfSchemaDocs, int numOfParsedDocOfSchemaDocs, String errorMessage ){

    	super( titleForSchemaDocument );

    	initComponents();

    	initComponents6( ref2Source );

    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, totalNumOfDocOfSchemaDocs, currentNumOfDocOfSchemaDocs, numOfParsedDocOfSchemaDocs, errorMessage );

    	locateComponents();

        setVisible( true );
    }

    private void initComponents6( String ref2Source ){

    	jLabel1.setText( "Schema source:" );
    	jLabel4.setVisible( true );
    	jLabel8.setVisible( true );
    	jLabel9.setText( "Parsing document:" ); jLabel9.setVisible( true );

    	jTextField1.setText( ref2Source );
		jTextField2.setVisible( true ); jTextField2.setEditable( false );
    }

    public void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema, int totalNumOfDocOfSchemaDocs, int currentNumOfDocOfSchemaDocs, int numOfParsedDocOfSchemaDocs, String duration, String size, String depth, String memory, DefaultMutableTreeNode root ){//It is used for right schema documents.

    	JFrameManipulation.setJScrollPane( jScrollPane1, root, 4 );


		jLabel13.setVisible( true );
    	jLabel14.setText( "1. Parsing duration: " + duration );          	   jLabel14.setVisible( true );
    	jLabel15.setText( "2. Document size (#building blocks): " + size );    jLabel15.setVisible( true );
    	jLabel16.setText( "3. Avg depth of components: " + depth );		 	   jLabel16.setVisible( true );
    	jLabel17.setText( "4. Memory footprint: " + memory ); 				   jLabel17.setVisible( true );


    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, totalNumOfDocOfSchemaDocs, currentNumOfDocOfSchemaDocs, numOfParsedDocOfSchemaDocs );
    }

    public void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema, String duration, String size, String depth, String memory, DefaultMutableTreeNode root, int visualizationLevel ){//It is used for right schema documents.

    	JFrameManipulation.setJScrollPane( jScrollPane1, root, visualizationLevel );


		jLabel13.setVisible( true );
    	jLabel14.setText( "1. Parsing duration: " + duration );          	   jLabel14.setVisible( true );
    	jLabel15.setText( "2. Document size (#building blocks): " + size );    jLabel15.setVisible( true );
    	jLabel16.setText( "3. Avg depth of components: " + depth );		 	   jLabel16.setVisible( true );
    	jLabel17.setText( "4. Memory footprint: " + memory ); 				   jLabel17.setVisible( true );


    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema );

    	setVisible( true );

    	toFront();
    }

    public void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema, int totalNumOfDocOfSchemaDocs, int currentNumOfDocOfSchemaDocs, int numOfParsedDocOfSchemaDocs, String errorMessage ){//It is used for error schema documents.

    	JTextArea jTextArea = new JTextArea( errorMessage );

    	jTextArea.setForeground( Color.RED );

    	jScrollPane1.setViewportView( new JScrollPane( jTextArea ) );


    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema, totalNumOfDocOfSchemaDocs, currentNumOfDocOfSchemaDocs, numOfParsedDocOfSchemaDocs );
    }

    public void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema, String errorMessage ){//It is used for error schema documents.

    	JTextArea jTextArea = new JTextArea( errorMessage );

    	jTextArea.setForeground( Color.RED );

    	jScrollPane1.setViewportView( new JScrollPane( jTextArea ) );


    	setTextOfComponentsForSchemaDocuments( ref2DocOfSchema );

    	toFront();
    }

    private void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema, int totalNumOfDocOfSchemaDocs, int currentNumOfDocOfSchemaDocs, int numOfParsedDocOfSchemaDocs ){

		jLabel2.setVisible( true );
    	jLabel3.setText( "Parsed schema documents: " + currentNumOfDocOfSchemaDocs + " / " + totalNumOfDocOfSchemaDocs ); jLabel3.setVisible( true );

    	if( currentNumOfDocOfSchemaDocs > 0 ){

    		jLabel4.setText( "Parsable documents: " + numOfParsedDocOfSchemaDocs );
    		jLabel8.setText( "Unparsable documents: " + String.valueOf( currentNumOfDocOfSchemaDocs - numOfParsedDocOfSchemaDocs ) );
    	}

    	else{

    		jLabel4.setText( "Parsable documents: -" );
    		jLabel8.setText( "Unparsable documents: -" );
    	}


    	jTextField2.setText( ref2DocOfSchema );
    }

    private void setTextOfComponentsForSchemaDocuments( String ref2DocOfSchema ){

    	jTextField2.setText( ref2DocOfSchema );
    }


    //Functions used by all constructors.
    private void initComponents(){

    	jScrollPane1 = new JScrollPane();
    	jScrollPane1.setEnabled(false);

    	jButton1 = new JButton( "Back" ); jButton1.addActionListener( new ActionListener(){ public void actionPerformed( ActionEvent e ){ visualizer.setVisible( false ); } } );
        jButton2 = new JButton(); 		  jButton2.setVisible( false );
    	jButton3 = new JButton(); 		  jButton3.setVisible( false );
    	jButton4 = new JButton();   	  jButton4.setVisible( false );
    	jButton5 = new JButton();  		  jButton5.setVisible( false );
        jButton6 = new JButton(); 		  jButton6.setVisible( false );


        jLabel1 = new JLabel();  							    jLabel1.setFont( new Font( "Tahoma", Font.BOLD, 14 ) );
        jLabel2 = new JLabel( "Overall Parsing Statistics" );   jLabel2.setVisible( false ); jLabel2.setFont( new Font( "Tahoma", Font.BOLD, 14 ) );
        jLabel3 = new JLabel();  jLabel3.setVisible( false );
        jLabel4 = new JLabel();  jLabel4.setVisible( false );   jLabel4.setForeground( new Color( 0, 200, 80 ) );
    	jLabel5 = new JLabel();  jLabel5.setVisible( false );   jLabel5.setForeground( new Color( 0, 200, 80 ) );
    	jLabel6 = new JLabel();  jLabel6.setVisible( false );   jLabel6.setForeground( new Color( 0, 200, 80 ) );
    	jLabel7 = new JLabel();  jLabel7.setVisible( false );   jLabel7.setForeground( new Color( 0, 200, 80 ) );
    	jLabel8 = new JLabel();  jLabel8.setVisible( false );   jLabel8.setForeground( new Color( 200, 0, 40 ) );
    	jLabel9 = new JLabel();  jLabel9.setVisible( false );   jLabel9.setFont( new Font( "Tahoma", Font.BOLD, 14 ) );
    	jLabel10 = new JLabel(); jLabel10.setVisible( false );
    	jLabel11 = new JLabel(); jLabel11.setVisible( false );  jLabel11.setForeground( new Color( 0, 200, 80 ) );
    	jLabel12 = new JLabel(); jLabel12.setVisible( false );  jLabel12.setForeground( new Color( 200, 0, 40) );
    	jLabel13 = new JLabel( "Current Document Statistics" ); jLabel13.setVisible( false ); jLabel13.setFont( new Font( "Tahoma", Font.BOLD, 14 ) );
    	jLabel14 = new JLabel(); jLabel14.setVisible( false );
    	jLabel15 = new JLabel(); jLabel15.setVisible( false );
    	jLabel16 = new JLabel(); jLabel16.setVisible( false );
    	jLabel17 = new JLabel(); jLabel17.setVisible( false );


    	jTextField1 = new JTextField(); jTextField1.setEditable( false );
    	jTextField2 = new JTextField(); jTextField2.setVisible( false );
    }

    private void locateComponents() {

    	javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 159, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTextField2)
                            .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 776, Short.MAX_VALUE))
                        .addContainerGap(352, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 943, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton2)
                            .addComponent(jButton5)
                            .addComponent(jButton3)
                            .addComponent(jButton4)
                            .addComponent(jLabel2)
                            .addComponent(jButton6)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addGap(76, 76, 76))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel3)
                                            .addComponent(jLabel10)
                                            .addGroup(layout.createSequentialGroup()
                                                .addGap(10, 10, 10)
                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                    .addComponent(jLabel4)
                                                    .addComponent(jLabel8)
                                                    .addGroup(layout.createSequentialGroup()
                                                        .addGap(10, 10, 10)
                                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                            .addComponent(jLabel5)
                                                            .addGroup(layout.createSequentialGroup()
                                                                .addGap(10, 10, 10)
                                                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                                                    .addComponent(jLabel7)
                                                                    .addComponent(jLabel6)))))
                                                    .addComponent(jLabel11)
                                                    .addComponent(jLabel12)))
                                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                                .addComponent(jLabel16, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 256, Short.MAX_VALUE)
                                                .addComponent(jLabel15, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                                .addComponent(jLabel14, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                        .addGap(0, 0, Short.MAX_VALUE))))
                            .addComponent(jLabel13, javax.swing.GroupLayout.PREFERRED_SIZE, 274, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGap(0, 0, Short.MAX_VALUE)
                                .addComponent(jButton1)
                                .addGap(31, 31, 31))))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton6)
                        .addGap(47, 47, 47)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7)
                        .addGap(11, 11, 11)
                        .addComponent(jLabel8)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel11)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel12)
                        .addGap(40, 40, 40)
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel15)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 684, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }
}
