package org.ow2.choreos.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.abstractionBase.AbstractionBaseController;
import org.ow2.choreos.abstractionBase.FunctionalAbstraction;
import org.ow2.choreos.abstractionBase.Hierarchy;
import org.ow2.choreos.abstractionDrivenServiceOrganization.ServiceOrganizationController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.names.NamesDistanceController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.distanceCalculator.serviceRepresentation.functional.service.DistanceCalculatorController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.functionalOrganization.FunctionalOrganizationController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.interfaceMappingsToJTrees.InterfaceMappingsToJTreesController;
import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.interfaceMappingsToJTrees.InterfaceMappingsToJTreesControllerImplV1;
import org.ow2.choreos.abstractionDrivenServiceOrganization.nonFunctionalOrganization.NonFunctionalOrganizationController;
import org.ow2.choreos.abstractionGenerator.AbstractionGenerator;
import org.ow2.choreos.abstractionGenerator.Serialiazer;
import org.ow2.choreos.measurements.number.ValueScaling;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.serviceBase.ServiceBaseController;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;
import org.ow2.choreos.userAuthentication.UserAuthenticationChecker;


public class ServiceOrganizationVisualizer extends JFrame {


	//Variables.
	private static final long serialVersionUID = 4765633733904166869L;

	private int initialFrameWidth = 1582, initialFrameHeight = 884;
	private int screenWidth = Toolkit.getDefaultToolkit().getScreenSize().width, screenHeight = Toolkit.getDefaultToolkit().getScreenSize().height;

    private JButton jButton1, jButton2, jButton3, jButton4, jButton5, jButton6, jButton7;
    private JLabel jLabel1, jLabel2, jLabel3, jLabel4, jLabel5, jLabel6, jLabel7, jLabel8, jLabel9, jLabel10, jLabel11, jLabel12, jLabel13, jLabel14, jLabel15, jLabel16, jLabel17, jLabel18, jLabel19, jLabel20, jLabel21, jLabel22, jLabel23, jLabel24, jLabel25;
    private JLabel jLabel6_1;
    private JLabel jLabel21_1;
    private JScrollPane jScrollPane1, jScrollPane2;
    private JTree jTree1, jTree2;
    private JTextField jTextField1, jTextField2;
    private JRadioButton jRadioButton1, jRadioButton2, jRadioButton3, jRadioButton4;
    private JCheckBox jCheckBox1, jCheckBox2;

    private ServiceRegistration serviceRegistration;
    private AbstractionBaseController abstractionBase;
    private ServiceOrganizationController serviceOrganization;
    private UserSettings userSettings;

    private Thread thread;

    private TreePath path1, path2;


    //Constructor.
    public ServiceOrganizationVisualizer( ServiceRegistration cServiceRegistration, AbstractionBaseController cAbstractionBase, ServiceOrganizationController cServiceOrganization, UserSettings cUserSettings ){

        super( "Abstraction-oriented Service Organization" );


        serviceRegistration = cServiceRegistration;
        abstractionBase = cAbstractionBase;
        serviceOrganization = cServiceOrganization;

        userSettings = cUserSettings;
        userSettings.setExistingNonFuncDocs( cServiceRegistration.existNonFuncDescriptions( cUserSettings.getCollectionID() ) );


        initComponents();

        locateComponents();

        pack();


        resizeFrame();

        setVisible( true );
    }

    private int getNumOfInstances( List<ServiceInterface> allInterfaces ){//TODO: To calculate it through service registration object!

    	int numOfInstances = 0;

    	for( int i = 0; allInterfaces != null && i < allInterfaces.size(); ++i ) numOfInstances += allInterfaces.get(i).getServiceInstances().size();

    	return numOfInstances;
    }

    private void initComponents() {

    	int label = userSettings.getCollectionID().intValue() + 1;

    	jTextField1 = new JTextField( "Collection " + label );
    	jTextField1.setEditable( false );

    	jLabel1 = new JLabel( "Hierarchy of Functional Abstractions" );
        jLabel1.setFont( new java.awt.Font("Tahoma", 1, 12) );

        jLabel2 = new JLabel("");
        jLabel2.setFont( new java.awt.Font("Tahoma", 1, 11));jLabel2.setVisible( true );

        jButton5 = new JButton("Visualize collection");
        //jButton5.addActionListener( visualizeCollectionActionListener() );
        jButton5.setEnabled( false );jButton5.setVisible( false );

        jLabel16 = new JLabel("");//jLabel16.setText("Calculating the distance ...");
        jLabel16.setFont(new java.awt.Font("Tahoma", 0, 10));//It is used only in the functional hierarchy (mode = 1 or 2 or 3)!
        jLabel16.setVisible( true );

        jLabel21 = new JLabel("");
        jLabel21.setFont( new java.awt.Font("Tahoma", 1, 10) );jLabel21.setVisible( true );

        jLabel22 = new JLabel("");
        jLabel22.setFont( new java.awt.Font("Tahoma", 1, 10) );jLabel22.setVisible( true );

        jLabel23 = new JLabel("");//jLabel23.setText("#nested non-functional abstractions: ");
        jLabel23.setFont(new java.awt.Font("Tahoma", 1, 10));jLabel23.setVisible( true );

        jLabel24 = new JLabel("");//jLabel24.setText("Algorithm execution");
        jLabel24.setFont(new java.awt.Font("Tahoma", 1, 11));jLabel24.setVisible( true );

        jCheckBox1 = new JCheckBox( "Print datails during the production of the abstractions" );
        jCheckBox1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jCheckBox1.addActionListener( setDelayActionListener() );jCheckBox1.setVisible( true );

        jCheckBox2 = new JCheckBox();
        jCheckBox2.addActionListener( selectHierarchyLevelsActionListener() );
        jCheckBox2.setSelected( true );jCheckBox2.setVisible( true );

        jButton4 = new JButton( "Produce Hierarchies" );
        jButton4.addActionListener( new ActionListener(){ public void actionPerformed( ActionEvent e ){ produce( userSettings.getMode(), false ); } } );
        jButton4.addActionListener( selectThresholdActionListener() );
        jButton4.addActionListener( selectHierarchyLevelsActionListener() );

        List<ServiceInterface> allInterfaces = serviceRegistration.getAllInterfaces( userSettings.getCollectionID() );

        int numOfInterfaces = allInterfaces != null ? allInterfaces.size() : 0;

        int numOfInstances = getNumOfInstances( allInterfaces );

    	jButton1 = new JButton("Store Hierarchies");
    	jButton1.setEnabled(false);
    	jButton1.addActionListener( storeAbstractionsActionListener() );

    	jLabel2.setText("Initial number of service interfaces: " + numOfInterfaces );
        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 12));

        jLabel6 = new JLabel("");//jLabel6.setText("Algorithm execution");
        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 11));jLabel6.setVisible( true );

        jLabel7 = new JLabel("Initial number of service instances: " + numOfInstances );
        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 12));jLabel7.setVisible( true );

        jLabel8 = new JLabel("");////jLabel8.setText("1.Initialization");
        jLabel8.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel8.setVisible( true );

        jLabel19 = new JLabel("");//jLabel19.setText("The non-functional abstraction that describes all the service instances have been produced.");
        jLabel19.setFont(new java.awt.Font("Tahoma", 0, 11));
        jLabel19.setForeground( new Color(0, 200, 80) );jLabel19.setVisible( true );

        jLabel20 = new JLabel("Hierarchy of Non-functional Abstractions");
        jLabel20.setFont( new java.awt.Font("Tahoma", 1, 12) );

        jLabel21_1 = new JLabel("");
        jLabel21_1.setFont( new java.awt.Font("Tahoma", 0, 11) );jLabel21_1.setVisible( true );

        jButton6 = new JButton( "Visualize selected functional abstraction" );
        jButton6.addActionListener( visualizeFunctionalAbstraction() );
        jButton6.setEnabled( false );//jButton6.setVisible( false );//TODO

        jButton7 = new JButton("Generate Abstractions Implementation");
        jButton7.addActionListener(generateAbstractionsImplementationActionListener());
        jButton7.setEnabled( true );

        jButton3 = new JButton( "Visualize selected Non-functional Abstraction" );
        jButton3.addActionListener(visualizeNonFunctionalAbstractionActionListener());
        jButton3.setEnabled( false );//jButton3.setVisible( false );//TODO

    	jTextField2 = new JTextField( "1" );
    	jTextField2.setEditable( false );jTextField2.setVisible( true );

        jButton2 = new JButton("Back");
        jButton2.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){ setVisible( false );}});

        jLabel3 = new JLabel(" ");//jLabel3.setText("2. Producing functional abstractions");
        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel3.setVisible( true );

        jLabel9 = new JLabel("Options for calculating interface distance");
        jLabel9.setFont(new java.awt.Font("Tahoma", 1, 11));jLabel9.setVisible( true );

        jLabel5 = new JLabel("1. Names distance");
        jLabel5.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel5.setVisible( true );

        jRadioButton1 = new JRadioButton( "String edit distance" );
        jRadioButton1.setFont( new java.awt.Font("Tahoma", 0, 10) );
        jRadioButton1.addActionListener( selectNamingDistanceActionListener() );
        jRadioButton1.setSelected( true );
        jRadioButton1.setEnabled( false );jRadioButton1.setVisible( true );

        jRadioButton2 = new JRadioButton( "Conceptual distance" );
        jRadioButton2.setFont( new java.awt.Font("Tahoma", 0, 10) );
        jRadioButton2.addActionListener( selectNamingDistanceActionListener() );
        jRadioButton2.setEnabled( false );jRadioButton2.setVisible( true );

        jLabel14 = new JLabel("2. Messages distance");
        jLabel14.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel14.setVisible( true );

        jRadioButton3 = new JRadioButton( "Unstructured XML data types" );
        jRadioButton3.setFont( new java.awt.Font("Tahoma", 0, 10) );
        jRadioButton3.addActionListener( selectDatatypeDistanceActionListener() );
        jRadioButton3.setSelected( true );
        jRadioButton3.setEnabled( false );jRadioButton3.setVisible( true );

        jRadioButton4 = new JRadioButton( "Structured XML data types" );
        jRadioButton4.setFont( new java.awt.Font("Tahoma", 0, 10) );
        jRadioButton4.addActionListener( selectDatatypeDistanceActionListener() );
        jRadioButton4.setEnabled( false );jRadioButton4.setVisible( true );

        jLabel15 = new JLabel( "Options for extracting non-functional abstractions" );
        jLabel15.setFont(new java.awt.Font("Tahoma", 1, 11));jLabel15.setVisible( true );

        jLabel13 = new JLabel("");//jLabel11.setText("Algorithm execution");
        jLabel13.setFont(new java.awt.Font("Tahoma", 1, 11));jLabel13.setVisible( true );

        jLabel10 = new JLabel("");//jLabel10.setText("1. Initialization");
        jLabel10.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel10.setVisible( true );

        jLabel11 = new JLabel("");//jLabel11.setText("Calculating interface distances...");
        jLabel11.setFont(new java.awt.Font("Tahoma", 0, 11));jLabel11.setVisible( true );

        jLabel12 = new JLabel("");//jLabel11.setText("()");
        jLabel12.setFont(new java.awt.Font("Tahoma", 1, 10));jLabel12.setVisible( true );

        jLabel4 = new JLabel("");//jLabel4.setText("#functional abstractions: ");
        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 10));jLabel4.setVisible( true );

        jLabel17 = new JLabel("");//jLabel16.setText("The distance of the abstraction is ...");
        jLabel17.setFont(new java.awt.Font("Tahoma", 1, 10));jLabel17.setVisible( true );

        jLabel18 = new JLabel( "1. Max number of represented service instances:" );
        jLabel18.setFont( new java.awt.Font("Tahoma", 0, 11) );jLabel18.setVisible( true );

        jLabel25 = new JLabel( "2. Production of hierarchy with one level:" );
        jLabel25.setFont( new java.awt.Font("Tahoma", 0, 11) );jLabel25.setVisible( true );

        jLabel6_1 = new JLabel(" ");//jLabel6.setText("#non-functional abstractions: "); and jLabel6.setText("distance of abstraction with other interfaces"); 
        jLabel6_1.setFont(new java.awt.Font("Tahoma", 1, 10));jLabel6_1.setVisible( true );

        jScrollPane1 = new JScrollPane();
        jScrollPane1.setViewportView(jTree1);

        jScrollPane2 = new JScrollPane();
        jScrollPane2.setViewportView(jTree2);


        setDefaultCloseOperation( javax.swing.WindowConstants.EXIT_ON_CLOSE );
    }

    private void locateComponents(){

    	javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    	layout.setHorizontalGroup(
    		layout.createParallelGroup(Alignment.LEADING)
    			.addGroup(layout.createSequentialGroup()
    				.addContainerGap()
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addGroup(layout.createParallelGroup(Alignment.LEADING)
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jButton6)
    								.addPreferredGap(ComponentPlacement.RELATED, 201, Short.MAX_VALUE)
    								.addComponent(jButton7)
    								.addGap(53)
    								.addComponent(jCheckBox1))
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jLabel1)
    								.addGap(42)
    								.addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, 118, GroupLayout.PREFERRED_SIZE)
    								.addGap(18)
    								.addComponent(jButton5)
    								.addGap(0, 555, Short.MAX_VALUE))
    							.addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 1095, Short.MAX_VALUE)
    							.addComponent(jScrollPane2, GroupLayout.DEFAULT_SIZE, 1095, Short.MAX_VALUE)
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jButton3)
    								.addPreferredGap(ComponentPlacement.RELATED, 808, Short.MAX_VALUE)))
    						.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    							.addGroup(layout.createSequentialGroup()
    								.addPreferredGap(ComponentPlacement.RELATED, 28, Short.MAX_VALUE)
    								.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    									.addGroup(layout.createParallelGroup(Alignment.LEADING)
    										.addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, 413, GroupLayout.PREFERRED_SIZE)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel10, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, 413, GroupLayout.PREFERRED_SIZE)
    											.addComponent(jLabel11, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, 403, GroupLayout.PREFERRED_SIZE)
    											.addComponent(jLabel12, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, 403, GroupLayout.PREFERRED_SIZE)))
    									.addGroup(layout.createParallelGroup(Alignment.LEADING)
    										.addComponent(jLabel4, GroupLayout.PREFERRED_SIZE, 403, GroupLayout.PREFERRED_SIZE)
    										.addGroup(layout.createSequentialGroup()
    											.addGap(10)
    											.addGroup(layout.createParallelGroup(Alignment.LEADING, false)
    												.addComponent(jLabel16, GroupLayout.DEFAULT_SIZE, 393, Short.MAX_VALUE)
    												.addComponent(jLabel17, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))))
    							.addGroup(layout.createSequentialGroup()
    								.addGroup(layout.createParallelGroup(Alignment.LEADING, false)
    									.addGroup(layout.createSequentialGroup()
    										.addGap(8)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel2)
    											.addGroup(layout.createSequentialGroup()
    												.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    													.addGroup(layout.createSequentialGroup()
    														.addGap(4)
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jLabel18)
    															.addComponent(jLabel25))
    														.addPreferredGap(ComponentPlacement.UNRELATED)
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jCheckBox2)
    															.addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, 29, GroupLayout.PREFERRED_SIZE))
    														.addPreferredGap(ComponentPlacement.RELATED, 24, Short.MAX_VALUE))
    													.addGroup(layout.createSequentialGroup()
    														.addComponent(jButton4)
    														.addPreferredGap(ComponentPlacement.RELATED)
    														.addComponent(jButton1)
    														.addGap(7)))
    												.addComponent(jButton2)
    												.addGap(15))))
    									.addGroup(layout.createSequentialGroup()
    										.addPreferredGap(ComponentPlacement.UNRELATED)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addGroup(layout.createSequentialGroup()
    												.addGap(28)
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jRadioButton1)
    													.addComponent(jRadioButton2)))
    											.addGroup(layout.createSequentialGroup()
    												.addGap(10)
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jLabel9)
    													.addGroup(layout.createSequentialGroup()
    														.addComponent(jLabel5)
    														.addGap(43)
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jLabel14)
    															.addGroup(layout.createSequentialGroup()
    																.addGap(10)
    																.addGroup(layout.createParallelGroup(Alignment.LEADING)
    																	.addComponent(jRadioButton4)
    																	.addComponent(jRadioButton3)))))
    													.addComponent(jLabel7)
    													.addComponent(jLabel15)))))
    									.addGroup(layout.createSequentialGroup()
    										.addPreferredGap(ComponentPlacement.RELATED)
    										.addComponent(jLabel13))
    									.addGroup(layout.createSequentialGroup()
    										.addGap(28)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel21_1)
    											.addGroup(layout.createSequentialGroup()
    												.addGap(10)
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jLabel19)
    													.addComponent(jLabel22)
    													.addComponent(jLabel23)
    													.addComponent(jLabel6_1)))))
    									.addGroup(layout.createSequentialGroup()
    										.addGap(18)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addGroup(layout.createSequentialGroup()
    												.addGap(10)
    												.addComponent(jLabel8))
    											.addComponent(jLabel24))))
    								.addGap(0, 54, Short.MAX_VALUE))))
    					.addComponent(jLabel20))
    				.addContainerGap())
    	);
    	layout.setVerticalGroup(
    		layout.createParallelGroup(Alignment.LEADING)
    			.addGroup(layout.createSequentialGroup()
    				.addContainerGap()
    				.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    					.addComponent(jLabel1)
    					.addComponent(jButton5)
    					.addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
    				.addPreferredGap(ComponentPlacement.RELATED)
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addComponent(jLabel2)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel9)
    						.addGap(7)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jLabel5)
    							.addComponent(jLabel14))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jRadioButton1)
    							.addComponent(jRadioButton3))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jRadioButton2)
    							.addComponent(jRadioButton4))
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel13)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel10)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel11)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel12)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel3)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel4)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel16)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel17))
    					.addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, 343, GroupLayout.PREFERRED_SIZE))
    				.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
    				.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    					.addComponent(jButton6)
    					.addComponent(jCheckBox1)
    					.addComponent(jButton7))
    				.addGap(18)
    				.addComponent(jLabel20)
    				.addGap(9)
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addComponent(jLabel7)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel15)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
    							.addComponent(jLabel18))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.LEADING)
    							.addComponent(jCheckBox2)
    							.addComponent(jLabel25))
    						.addGap(18)
    						.addComponent(jLabel24)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel8)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel19)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel21_1, GroupLayout.PREFERRED_SIZE, 16, GroupLayout.PREFERRED_SIZE)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel22)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel23)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel6_1))
    					.addComponent(jScrollPane2, GroupLayout.PREFERRED_SIZE, 298, GroupLayout.PREFERRED_SIZE))
    				.addGap(32)
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    						.addComponent(jButton2)
    						.addComponent(jButton1)
    						.addComponent(jButton4))
    					.addComponent(jButton3))
    				.addGap(21))
    	);
        getContentPane().setLayout(layout);
    }

    private void resizeFrame() {

    	screenHeight -= screenHeight / 20;

        PrintMessages.stdPrintLn( PrintMessages.guiPrint, "initialFrameWidth X initialFrameHeight = " + initialFrameWidth + " X " + initialFrameHeight );

        PrintMessages.stdPrintLn( PrintMessages.guiPrint, "screenWidth X screenHeight = " + screenWidth + " X " + screenHeight );


        locateScaledComponents();

        resizeFonts();

    	setSize( screenWidth, screenHeight );
    }

    private void locateScaledComponents(){

    	javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    	layout.setHorizontalGroup(
    		layout.createParallelGroup(Alignment.LEADING)
    			.addGroup(layout.createSequentialGroup()
    				.addContainerGap()
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addGroup(layout.createParallelGroup(Alignment.LEADING)
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jButton6)
    								.addPreferredGap(ComponentPlacement.RELATED, ValueScaling.scale( 201, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)
    								.addComponent(jButton7)
    								.addGap( ValueScaling.scale( 53, initialFrameWidth, screenWidth, screenWidth ) )
    								.addComponent(jCheckBox1))
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jLabel1)
    								.addGap( ValueScaling.scale( 42, initialFrameWidth, screenWidth, screenWidth ) )
    								.addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 118, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)
    								.addGap( ValueScaling.scale( 18, initialFrameWidth, screenWidth, screenWidth ) )
    								.addComponent(jButton5)
    								.addGap(0, ValueScaling.scale( 555, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE))
    							.addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, ValueScaling.scale( 1095, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)
    							.addComponent(jScrollPane2, GroupLayout.DEFAULT_SIZE, ValueScaling.scale( 1095, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)
    							.addGroup(layout.createSequentialGroup()
    								.addComponent(jButton3)
    								.addPreferredGap(ComponentPlacement.RELATED, ValueScaling.scale( 808, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)))
    						.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    							.addGroup(layout.createSequentialGroup()
    								.addPreferredGap(ComponentPlacement.RELATED, ValueScaling.scale( 28, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)
    								.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    									.addGroup(layout.createParallelGroup(Alignment.LEADING)
    										.addComponent(jLabel3, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 413, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel10, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 413, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)
    											.addComponent(jLabel11, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 403, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)
    											.addComponent(jLabel12, Alignment.TRAILING, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 403, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)))
    									.addGroup(layout.createParallelGroup(Alignment.LEADING)
    										.addComponent(jLabel4, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 403, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE)
    										.addGroup(layout.createSequentialGroup()
    											.addGap( ValueScaling.scale( 10, initialFrameWidth, screenWidth, screenWidth ) )
    											.addGroup(layout.createParallelGroup(Alignment.LEADING, false)
    												.addComponent(jLabel16, GroupLayout.DEFAULT_SIZE, ValueScaling.scale( 393, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE)
    												.addComponent(jLabel17, GroupLayout.DEFAULT_SIZE, ValueScaling.scale( GroupLayout.DEFAULT_SIZE, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE))))))
    							.addGroup(layout.createSequentialGroup()
    								.addGroup(layout.createParallelGroup(Alignment.LEADING, false)
    									.addGroup(layout.createSequentialGroup()
    										.addGap(8)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel2)
    											.addGroup(layout.createSequentialGroup()
    												.addGroup(layout.createParallelGroup(Alignment.TRAILING)
    													.addGroup(layout.createSequentialGroup()
    														.addGap( ValueScaling.scale( 4, initialFrameWidth, screenWidth, screenWidth ) )
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jLabel18)
    															.addComponent(jLabel25))
    														.addPreferredGap(ComponentPlacement.UNRELATED)
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jCheckBox2)
    															.addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 29, initialFrameWidth, screenWidth, screenWidth ), GroupLayout.PREFERRED_SIZE))
    														.addPreferredGap(ComponentPlacement.RELATED, ValueScaling.scale( 24, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE))
    													.addGroup(layout.createSequentialGroup()
    														.addComponent(jButton4)
    														.addPreferredGap(ComponentPlacement.RELATED)
    														.addComponent(jButton1)
    														.addGap( ValueScaling.scale( 7, initialFrameWidth, screenWidth, screenWidth ) )))
    												.addComponent(jButton2)
    												.addGap( ValueScaling.scale( 15, initialFrameWidth, screenWidth, screenWidth ) ))))
    									.addGroup(layout.createSequentialGroup()
    										.addPreferredGap(ComponentPlacement.UNRELATED)
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addGroup(layout.createSequentialGroup()
    												.addGap( ValueScaling.scale( 28, initialFrameWidth, screenWidth, screenWidth ) )
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jRadioButton1)
    													.addComponent(jRadioButton2)))
    											.addGroup(layout.createSequentialGroup()
    												.addGap( ValueScaling.scale( 10, initialFrameWidth, screenWidth, screenWidth ) )
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jLabel9)
    													.addGroup(layout.createSequentialGroup()
    														.addComponent(jLabel5)
    														.addGap( ValueScaling.scale( 43, initialFrameWidth, screenWidth, screenWidth ) )
    														.addGroup(layout.createParallelGroup(Alignment.LEADING)
    															.addComponent(jLabel14)
    															.addGroup(layout.createSequentialGroup()
    																.addGap( ValueScaling.scale( 10, initialFrameWidth, screenWidth, screenWidth ) )
    																.addGroup(layout.createParallelGroup(Alignment.LEADING)
    																	.addComponent(jRadioButton4)
    																	.addComponent(jRadioButton3)))))
    													.addComponent(jLabel7)
    													.addComponent(jLabel15)))))
    									.addGroup(layout.createSequentialGroup()
    										.addPreferredGap(ComponentPlacement.RELATED)
    										.addComponent(jLabel13))
    									.addGroup(layout.createSequentialGroup()
    										.addGap( ValueScaling.scale( 28, initialFrameWidth, screenWidth, screenWidth ) )
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addComponent(jLabel21_1)
    											.addGroup(layout.createSequentialGroup()
    												.addGap( ValueScaling.scale( 10, initialFrameWidth, screenWidth, screenWidth ) )
    												.addGroup(layout.createParallelGroup(Alignment.LEADING)
    													.addComponent(jLabel19)
    													.addComponent(jLabel22)
    													.addComponent(jLabel23)
    													.addComponent(jLabel6_1)))))
    									.addGroup(layout.createSequentialGroup()
    										.addGap( ValueScaling.scale( 18, initialFrameWidth, screenWidth, screenWidth ) )
    										.addGroup(layout.createParallelGroup(Alignment.LEADING)
    											.addGroup(layout.createSequentialGroup()
    												.addGap( ValueScaling.scale( 10, initialFrameWidth, screenWidth, screenWidth ) )
    												.addComponent(jLabel8))
    											.addComponent(jLabel24))))
    								.addGap(0, ValueScaling.scale( 54, initialFrameWidth, screenWidth, screenWidth ), Short.MAX_VALUE))))
    					.addComponent(jLabel20))
    				.addContainerGap())
    	);
    	layout.setVerticalGroup(
    		layout.createParallelGroup(Alignment.LEADING)
    			.addGroup(layout.createSequentialGroup()
    				.addContainerGap()
    				.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    					.addComponent(jLabel1)
    					.addComponent(jButton5)
    					.addComponent(jTextField1, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( javax.swing.GroupLayout.DEFAULT_SIZE, initialFrameHeight, screenHeight, screenHeight ), GroupLayout.PREFERRED_SIZE))
    				.addPreferredGap(ComponentPlacement.RELATED)
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addComponent(jLabel2)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel9)
    						.addGap( ValueScaling.scale( 7, initialFrameHeight, screenHeight, screenHeight ) )
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jLabel5)
    							.addComponent(jLabel14))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jRadioButton1)
    							.addComponent(jRadioButton3))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jRadioButton2)
    							.addComponent(jRadioButton4))
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel13)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel10)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel11)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel12)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel3)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel4)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel16)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel17))
    					.addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 343, initialFrameHeight, screenHeight, screenHeight ), GroupLayout.PREFERRED_SIZE))
    				.addPreferredGap(ComponentPlacement.RELATED, ValueScaling.scale( javax.swing.GroupLayout.DEFAULT_SIZE, initialFrameHeight, screenHeight, screenHeight ), Short.MAX_VALUE)
    				.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    					.addComponent(jButton6)
    					.addComponent(jCheckBox1)
    					.addComponent(jButton7))
    				.addGap( ValueScaling.scale( 18, initialFrameHeight, screenHeight, screenHeight ) )
    				.addComponent(jLabel20)
    				.addGap( ValueScaling.scale( 9, initialFrameHeight, screenHeight, screenHeight ) )
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createSequentialGroup()
    						.addComponent(jLabel7)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(jLabel15)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(jTextField2, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( javax.swing.GroupLayout.DEFAULT_SIZE, initialFrameHeight, screenHeight, screenHeight ), GroupLayout.PREFERRED_SIZE)
    							.addComponent(jLabel18))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(layout.createParallelGroup(Alignment.LEADING)
    							.addComponent(jCheckBox2)
    							.addComponent(jLabel25))
    						.addGap( ValueScaling.scale( 18, initialFrameHeight, screenHeight, screenHeight ) )
    						.addComponent(jLabel24)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel8)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel19)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel21_1, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 16, initialFrameHeight, screenHeight, screenHeight ), GroupLayout.PREFERRED_SIZE)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel22)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel23)
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(jLabel6_1))
    					.addComponent(jScrollPane2, GroupLayout.PREFERRED_SIZE, ValueScaling.scale( 298, initialFrameHeight, screenHeight, screenHeight ), GroupLayout.PREFERRED_SIZE))
    				.addGap( ValueScaling.scale( 32, initialFrameHeight, screenHeight, screenHeight ) )
    				.addGroup(layout.createParallelGroup(Alignment.LEADING)
    					.addGroup(layout.createParallelGroup(Alignment.BASELINE)
    						.addComponent(jButton2)
    						.addComponent(jButton1)
    						.addComponent(jButton4))
    					.addComponent(jButton3))
    				.addGap( ValueScaling.scale( 21, initialFrameHeight, screenHeight, screenHeight ) ))
    	);
        getContentPane().setLayout(layout);
    }

    private void resizeFonts() {

    	jTextField1.setFont( new Font( jTextField1.getFont().getFontName(), jTextField1.getFont().getStyle(), ValueScaling.scale( jTextField1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jTextField2.setFont( new Font( jTextField2.getFont().getFontName(), jTextField2.getFont().getStyle(), ValueScaling.scale( jTextField2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );

    	jLabel1.setFont( new Font( jLabel1.getFont().getFontName(), jLabel1.getFont().getStyle(), ValueScaling.scale( jLabel1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel2.setFont( new Font( jLabel2.getFont().getFontName(), jLabel2.getFont().getStyle(), ValueScaling.scale( jLabel2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel3.setFont( new Font( jLabel3.getFont().getFontName(), jLabel3.getFont().getStyle(), ValueScaling.scale( jLabel3.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel4.setFont( new Font( jLabel4.getFont().getFontName(), jLabel4.getFont().getStyle(), ValueScaling.scale( jLabel4.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel5.setFont( new Font( jLabel5.getFont().getFontName(), jLabel5.getFont().getStyle(), ValueScaling.scale( jLabel5.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel6_1.setFont( new Font( jLabel6_1.getFont().getFontName(), jLabel6_1.getFont().getStyle(), ValueScaling.scale( jLabel6_1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel7.setFont( new Font( jLabel7.getFont().getFontName(), jLabel7.getFont().getStyle(), ValueScaling.scale( jLabel7.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel8.setFont( new Font( jLabel8.getFont().getFontName(), jLabel8.getFont().getStyle(), ValueScaling.scale( jLabel8.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel9.setFont( new Font( jLabel9.getFont().getFontName(), jLabel9.getFont().getStyle(), ValueScaling.scale( jLabel9.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel10.setFont( new Font( jLabel10.getFont().getFontName(), jLabel10.getFont().getStyle(), ValueScaling.scale( jLabel10.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel11.setFont( new Font( jLabel11.getFont().getFontName(), jLabel11.getFont().getStyle(), ValueScaling.scale( jLabel11.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel12.setFont( new Font( jLabel12.getFont().getFontName(), jLabel12.getFont().getStyle(), ValueScaling.scale( jLabel12.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel13.setFont( new Font( jLabel13.getFont().getFontName(), jLabel13.getFont().getStyle(), ValueScaling.scale( jLabel13.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel14.setFont( new Font( jLabel14.getFont().getFontName(), jLabel14.getFont().getStyle(), ValueScaling.scale( jLabel14.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel15.setFont( new Font( jLabel15.getFont().getFontName(), jLabel15.getFont().getStyle(), ValueScaling.scale( jLabel15.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel16.setFont( new Font( jLabel16.getFont().getFontName(), jLabel16.getFont().getStyle(), ValueScaling.scale( jLabel16.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel17.setFont( new Font( jLabel17.getFont().getFontName(), jLabel17.getFont().getStyle(), ValueScaling.scale( jLabel17.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel18.setFont( new Font( jLabel18.getFont().getFontName(), jLabel18.getFont().getStyle(), ValueScaling.scale( jLabel18.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel19.setFont( new Font( jLabel19.getFont().getFontName(), jLabel19.getFont().getStyle(), ValueScaling.scale( jLabel19.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel20.setFont( new Font( jLabel20.getFont().getFontName(), jLabel20.getFont().getStyle(), ValueScaling.scale( jLabel20.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel21_1.setFont( new Font( jLabel21_1.getFont().getFontName(), jLabel21_1.getFont().getStyle(), ValueScaling.scale( jLabel21_1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel22.setFont( new Font( jLabel22.getFont().getFontName(), jLabel22.getFont().getStyle(), ValueScaling.scale( jLabel22.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel23.setFont( new Font( jLabel23.getFont().getFontName(), jLabel23.getFont().getStyle(), ValueScaling.scale( jLabel23.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel24.setFont( new Font( jLabel24.getFont().getFontName(), jLabel24.getFont().getStyle(), ValueScaling.scale( jLabel24.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jLabel25.setFont( new Font( jLabel25.getFont().getFontName(), jLabel25.getFont().getStyle(), ValueScaling.scale( jLabel25.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );

    	jButton1.setFont( new Font( jButton1.getFont().getFontName(), jButton1.getFont().getStyle(), ValueScaling.scale( jButton1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton2.setFont( new Font( jButton2.getFont().getFontName(), jButton2.getFont().getStyle(), ValueScaling.scale( jButton2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton3.setFont( new Font( jButton3.getFont().getFontName(), jButton3.getFont().getStyle(), ValueScaling.scale( jButton3.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton4.setFont( new Font( jButton4.getFont().getFontName(), jButton4.getFont().getStyle(), ValueScaling.scale( jButton4.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton5.setFont( new Font( jButton5.getFont().getFontName(), jButton5.getFont().getStyle(), ValueScaling.scale( jButton5.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton6.setFont( new Font( jButton6.getFont().getFontName(), jButton6.getFont().getStyle(), ValueScaling.scale( jButton6.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jButton7.setFont( new Font( jButton7.getFont().getFontName(), jButton7.getFont().getStyle(), ValueScaling.scale( jButton7.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );

    	jCheckBox1.setFont( new Font( jCheckBox1.getFont().getFontName(), jCheckBox1.getFont().getStyle(), ValueScaling.scale( jCheckBox1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jCheckBox2.setFont( new Font( jCheckBox2.getFont().getFontName(), jCheckBox2.getFont().getStyle(), ValueScaling.scale( jCheckBox2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );

    	jRadioButton1.setFont( new Font( jRadioButton1.getFont().getFontName(), jRadioButton1.getFont().getStyle(), ValueScaling.scale( jRadioButton1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jRadioButton2.setFont( new Font( jRadioButton2.getFont().getFontName(), jRadioButton2.getFont().getStyle(), ValueScaling.scale( jRadioButton2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jRadioButton3.setFont( new Font( jRadioButton3.getFont().getFontName(), jRadioButton3.getFont().getStyle(), ValueScaling.scale( jRadioButton3.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	jRadioButton4.setFont( new Font( jRadioButton4.getFont().getFontName(), jRadioButton4.getFont().getStyle(), ValueScaling.scale( jRadioButton4.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    }

    public JScrollPane getScrollPanelOfHierarchy(){

    	return jScrollPane1;
    }

    public JScrollPane getScrollPanelOfNonFunctionalHierarchy(){

    	return jScrollPane2;
    }

    public void setTreeOfHierarchy( DefaultMutableTreeNode root ){

    	if( root != null ){

    		jTree1 = new JTree( root );

    		jTree1.setFont( new java.awt.Font( jTree1.getFont().getFontName(), jTree1.getFont().getStyle(), ValueScaling.scale( jTree1.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	}

    	else jTree1 = null;
    }

    public JTree getTreeOfHierarchy(){

    	return jTree1;
    }

    public JTree getTreeOfNonFunctionalHierarchy(){

    	return jTree2;
    }

    public void setTreeOfNonFunctionalHierarchy( DefaultMutableTreeNode root ){

    	if( root != null ){

    		jTree2 = new JTree( root );

    		jTree2.setFont( new java.awt.Font( jTree2.getFont().getFontName(), jTree2.getFont().getStyle(), ValueScaling.scale( jTree2.getFont().getSize(), initialFrameHeight, screenHeight, initialFrameWidth, screenWidth ) ) );
    	}

    	else jTree2 = null;
    }

    public JLabel getLabelOfAlgorithmExecution(){
    	return jLabel13;
    }

    public JLabel getLabelOfInitialization(){
    	return jLabel10;
    }

    public JLabel getLabelOfCalculatingDistances(){
    	return jLabel11;
    }

    public JLabel getLabelOfPairOfInterfaces(){
    	return jLabel12;
    }

    public JLabel getLabelOfProducing1stAbstractions(){
    	return jLabel3;
    }

    public JLabel get1stLevelOfProducingAbstractions1(){
    	return jLabel4;
    }

    public JLabel get2ndLevelOfProducingAbstractions2(){
    	return jLabel6_1;
    }

    public JLabel getLabelOfInitializationOfNonFunctionalAlgorithm(){
    	return jLabel8;
    }

    public JLabel getLabelOfInitialNonFunctionalAbstraction(){
    	return jLabel19;
    }

    public JButton getButtonOfConstructingHierarchy(){
    	return jButton4;
    }

    public JButton getButtonOfVisualizingNonFunctional(){
    	return jButton3;
    }

    public JButton getButtonOfVisualizingFunctional(){
    	return jButton6;
    }

    public JButton getButtonOfStoringHierarchy(){
    	return jButton1;
    }

    public JLabel get2ndLevelOfProducingAbstractions1(){
    	return jLabel16;
    }

    public JLabel get3rdLevelOfProducingAbstractions(){
    	return jLabel17;
    }

    public JLabel getLabelOfProducingNonFunctionalAbstractions(){
    	return jLabel21_1;
    }

    public JLabel getLabelOfPropertyGroups(){
    	return jLabel22;
    }

    public JLabel getLabelOfJointGroups(){
    	return jLabel23;
    }

    public JLabel getLabelOfExecutionOfNonFunctionalAlgorithm(){

    	return jLabel24;
    }

    private ActionListener setDelayActionListener() {

        return new ActionListener(){

			public void actionPerformed(ActionEvent e){

				userSettings.setDelay( jCheckBox1.isSelected() );
    	   	}
        };
    }

    private ActionListener selectThresholdActionListener() {

        return new ActionListener(){

			public void actionPerformed(ActionEvent e){

				if( jTextField2.getText() != null && ! jTextField2.getText().equals("") ) userSettings.setThreshold( Integer.parseInt( jTextField2.getText().toString() ) );
    	   	}
        };
    }

    private ActionListener selectHierarchyLevelsActionListener() {

        return new ActionListener(){

			public void actionPerformed(ActionEvent e){

				userSettings.setOneHierarchyLevel( jCheckBox2.isSelected() );
    	   	}
        };
    }

    //Select naming distance metric.
    private ActionListener selectNamingDistanceActionListener() {

        return new ActionListener(){

			public void actionPerformed(ActionEvent e){

				/*if((e.getSource() == jRadioButton1 && !jRadioButton1.isSelected()) || (e.getSource() == jRadioButton2 && !jRadioButton2.isSelected()))
					options.setInterfacesDistanceCalculatorAlgorithm(0);

				else if(e.getSource() == jRadioButton1 && jRadioButton1.isSelected()){
					options.setInterfacesDistanceCalculatorAlgorithm(1);
					jRadioButton2.setSelected(false);
				}

				else if(e.getSource() == jRadioButton2 && jRadioButton2.isSelected()){
					options.setInterfacesDistanceCalculatorAlgorithm(2);
    	    		jRadioButton1.setSelected(false);
    	    	}*/
    	   	}
        };
    }

    private ActionListener selectDatatypeDistanceActionListener() {

        return new ActionListener(){

			public void actionPerformed(ActionEvent e){

				/*if((e.getSource() == jRadioButton3 && !jRadioButton3.isSelected()) || (e.getSource() == jRadioButton4 && !jRadioButton4.isSelected()))
					options.setSchemaRepresentationModel(null);

				else if(e.getSource() == jRadioButton3 && jRadioButton3.isSelected()){
					options.setSchemaRepresentationModel(false);
					jRadioButton4.setSelected(false);
				}

				else if(e.getSource() == jRadioButton4 && jRadioButton4.isSelected()){
					options.setSchemaRepresentationModel(true);
    	    		jRadioButton3.setSelected(false);
    	    	}*/
    	   	}
        };
    }

    private ActionListener storeAbstractionsActionListener(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent e ){
				
				if( ! UserAuthenticationChecker.isCurator( userSettings.getUserCategory() ) ) PrintMessages.print( PrintMessages.guiPrint, "You do not have the priviledge to use the store functionality." );

				else ServiceBaseController.storeAbstractions( abstractionBase, "" );
            }
        };
    }


    public Hierarchy produce( int mode, boolean waitProductionThreads ){

    	Hierarchy hierarchy = null;

    	if( mode == 3 ) return produceIndependentHierarchies( waitProductionThreads );


    	return hierarchy;
    }


    @SuppressWarnings("deprecation")
	private Hierarchy produceIndependentHierarchies( boolean waitProductionThreads ) {

    	Hierarchy hierarchy = null;


    	if( thread != null && thread.isAlive() ) thread.stop();

    	//if( options.getNamesDistanceCalculatorAlgorithm() == null || ( options.getNamesDistanceCalculatorAlgorithm() != null && options.getNamesDistanceCalculatorAlgorithm() == 0 ) ) JOptionPane.showMessageDialog(null, "You have to select the type of the naming distance metric!");

    	//else if( options.getSchemaRepresentationModel() == null ) JOptionPane.showMessageDialog(null, "You have to select whether the type of the messages distance!");

    	if( userSettings.getThreshold() == null && userSettings.existNonFuncDescriptions() ) JOptionPane.showMessageDialog(null, "You have to select the maximum number of instances contained in a non-functional abstraction!");

    	else{

    		if( ! userSettings.existNonFuncDescriptions() ){

    			JTextArea jTextArea = new JTextArea( "The service instances are not characterized by non-functional descriptions!" );

				jTextArea.setForeground( Color.RED );

				jScrollPane2.setViewportView( new JScrollPane( jTextArea ) );

    	    	jTextField2.setEditable( false );
    		}


    		if( userSettings.getDelay() == null ) userSettings.setDelay( false );

    		userSettings.setFunctionalOrganizationAlgorithm( FunctionalOrganizationController.getHierarchicalAlgorithm() );

			userSettings.setInterfacesDistanceCalculatorAlgorithm( DistanceCalculatorController.getHungarianAlgorithm() );

			userSettings.setNonFunctionalOrganizationAlgorithm( NonFunctionalOrganizationController.getKmeans() );

			userSettings.setSchemaRepresentationModel( XMLSchemaRepresentationController.getCompletelyUnstructuredSchemaRepresentation() );

			userSettings.setNamesDistanceCalculatorAlgorithm( NamesDistanceController.getEditDistanceCalculator() );


			serviceRegistration.transform( userSettings.getSchemaRepresentationModel() );


			if( ! serviceRegistration.hasTransformedCollections( userSettings.getSchemaRepresentationModel() ) ){

				String constraintViolation = serviceRegistration.getFinalConstraintViolation();

				JTextArea jTextArea = new JTextArea( constraintViolation );

				jTextArea.setForeground( Color.RED );

				jScrollPane1.setViewportView( new JScrollPane( jTextArea ) );
			}

			else{

				List<ServiceInterface> allInterfaces = serviceRegistration.getAllInterfaces( userSettings.getCollectionID() );

				PrintMessages.print( PrintMessages.organizationPrint, "The transformation of the message types of the services in this collection to the schema representation model '" + userSettings.getSchemaRepresentationModel() + "' has been completed.");


				hierarchy = serviceOrganization.produce( waitProductionThreads, serviceRegistration, abstractionBase, allInterfaces, userSettings, this );


				if( hierarchy != null && hierarchy.hasFinalConstraintViolation() ){

					String constraintViolation = hierarchy.getFinalConstraintViolation();

					JTextArea jTextArea = new JTextArea( constraintViolation );

					jTextArea.setForeground( Color.RED );

					jScrollPane1.setViewportView( new JScrollPane( jTextArea ) );
				}
			}
    	}


    	return hierarchy;
    }

    public void setPath1( TreePath path1 ){

    	this.path1 = path1;
    }

    //Generate abstractions implementation.
    private ActionListener generateAbstractionsImplementationActionListener(){

        return new ActionListener(){

            @SuppressWarnings("static-access")
			public void actionPerformed(ActionEvent e){

            	Map<Integer, FunctionalAbstraction> functionalAbstractions = abstractionBase.get( userSettings.getCollectionID() );

            	if( functionalAbstractions == null )

            		JOptionPane.showMessageDialog(null, "There are no produced functional abstractions.");

            	else
            	{
            		AbstractionGenerator abstractinterface= new AbstractionGenerator();//create class
            		for (Enumeration<Integer> en = ( (Hashtable<Integer, FunctionalAbstraction>) functionalAbstractions).keys(); en.hasMoreElements();)
            		{

        				Integer i = en.nextElement();
        				FunctionalAbstraction fa = functionalAbstractions.get( i );
                        fa.setInterface( fa.getRepresentedInterfaces().get(1) );
        				ServiceInterface serviceInterface=functionalAbstractions.get( i ).getInterface();
        				JOptionPane.showMessageDialog(null, "Function abstraction= " + serviceInterface.getName());
        				
        				
        				System.out.println(serviceInterface.getName());
        				//generate abstraction and implement
        				
        				String URL = "http://localhost:8083/"+serviceInterface.getName();
        				System.out.println("Abstraction Published At: "+URL);
						abstractinterface.createAbstraction(serviceInterface, URL);	
						
					    new Serialiazer().WriteToFile(fa.getInterfacesMapping(),serviceInterface.getName(), serviceInterface.getName());
					    
					    //Endpoint.publish("http://localhost:8081/WS/Greeting",new help.getName()+"Impl()");
        			}
            	}
            }
        };
    }


    //Functional visualizer.
    private ActionListener visualizeFunctionalAbstraction(){

        return new ActionListener(){

            public void actionPerformed( ActionEvent e ){

            	int pathCount = path1.getPathCount();

            	String selection = path1.getPathComponent( pathCount - 1 ).toString();


            	if( selection != null && selection.contains( "Functional abstraction" ) && ! selection.contains( "Functional abstractions" )){

            		Integer functionalAbstractionID = findID( selection );

            		DefaultMutableTreeNode abstractionNode = abstractionBase.visualizeFA( userSettings.getCollectionID(), functionalAbstractionID );

            		new DocumentVisualizer( abstractionNode, "Functional abstraction", functionalAbstractionID );


            		List<ServiceInterface> allInterfaces = serviceRegistration.getAllInterfaces( userSettings.getCollectionID() );

            		int size = 0;

            		if( allInterfaces != null ) size = allInterfaces.size();


            		InterfaceMappingsToJTreesController visualizerControler = new InterfaceMappingsToJTreesControllerImplV1(null,true, abstractionBase,userSettings.getCollectionID(),functionalAbstractionID, size );
            		visualizerControler.transform();
            	}

            	else JOptionPane.showMessageDialog(null, "You have to select a functional abstraction!");
            }
        };
    }

    //Non-functional visualizer.
    public void setPath2( TreePath path2 ){

    	this.path2 = path2;
    }

    private ActionListener visualizeNonFunctionalAbstractionActionListener(){

        return new ActionListener(){

            public void actionPerformed( ActionEvent e ){

            	if( path2 != null ){

            		int pathCount = path2.getPathCount();

            		String selection = path2.getPathComponent( pathCount - 1 ).toString();

            		if( selection != null && selection.contains( "Non-functional abstraction" ) && ! selection.contains( "Non-functional abstractions" )){

            			Integer nonFunctionalAbstractionID = findID( selection );

            			DefaultMutableTreeNode root = abstractionBase.visualizeNFA( userSettings.getCollectionID(), nonFunctionalAbstractionID );

                		new DocumentVisualizer( root, "Non-functional abstraction", nonFunctionalAbstractionID );
            		}

            		else JOptionPane.showMessageDialog(null, "You have to select a non-functional abstraction!");
            	}
            }
        };
    }

    private Integer findID( String selection ){

    	int pos1 = selection.indexOf( "(" );
		int pos2 = selection.lastIndexOf( ")" );

		return Integer.parseInt( selection.substring( pos1 + 1, pos2 ) );
    }
}
