package org.ow2.choreos.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.abstractionBase.AbstractionBaseController;
import org.ow2.choreos.abstractionBase.FunctionalAbstraction;
import org.ow2.choreos.abstractionBase.NonFunctionalAbstraction;
import org.ow2.choreos.abstractionDrivenServiceOrganization.ServiceOrganizationController;
import org.ow2.choreos.gui.guiManipulation.JTreeManipulation;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.ParameterizedServiceOrganizationVisualizer;
import org.ow2.choreos.queryEngine.QueryEngineController;
import org.ow2.choreos.serviceBase.ServiceBaseController;
import org.ow2.choreos.serviceRegistration.ServiceRegistration;
import org.ow2.choreos.serviceRepresentation.functional.DocOfFuncProperties;
import org.ow2.choreos.userAuthentication.UserAuthenticationChecker;


/**
 * 
 * @author dathanas
 *
 */
public class ServiceRegistrationVisualizer extends javax.swing.JFrame {


	//Variables.
	private static final long serialVersionUID = 1L;

	private JButton jButton1, jButton2, jButton3, jButton4, jButton5, jButton6, jButton7, jButton8, jButton9, jButton10, jButton12, jButton13, jButton14, jButton15;
	private JLabel jLabel1, jLabel2, jLabel3, jLabel4, jLabel5, jLabel6, jLabel7, jLabel8, jLabel9, jLabel10, jLabel11, jLabel12, jLabel13, jLabel14, jLabel15, jLabel16, jLabel17, jLabel18, jLabel19, jLabel20, jLabel21, jLabel22, jLabel23, jLabel24;
	private JPanel jPanel1, jPanel2, jPanel3, jPanel4, jPanel5;
	private JPasswordField jPasswordField1;
	private JRadioButton jRadioButton1, jRadioButton2, jRadioButton3, jRadioButton4, jRadioButton5;
	private JScrollPane jScrollPane1, jScrollPane2, jScrollPane3, jScrollPane4, jScrollPane5;
	private JTabbedPane jTabbedPane1;
	private JTree jTree1, jTree2;
	private TreePath path1, path2;

	private JFileChooser sourceChooser;

	private Integer selectedCollectionID;

	private String selectedRef2Source;
	private String selectedRef2DocOfFuncProperties;

	private ServiceRegistration serviceRegistration;
	private AbstractionBaseController abstractionBase;
	private ServiceOrganizationController serviceOrganization;
	private UserSettings userSettings;

	private boolean expand = false;

	private ServiceRegistrationVisualizer AoSBM = this;

	private String fileContent = new String("");
	
	private DefaultMutableTreeNode root3 = null;

	private String userCategory, curatorPassword;


	//Constructor.
    ServiceRegistrationVisualizer(){

        super( "Abstraction-oriented Service Base Management (AoSBM)" );


        designFrame();


        setVisible( true );
    }


    //Methods.
    private void designFrame(){

    	initializeComponents();

        locateZeroTabComponents();

        locateFirstTabComponents();

        locateSecondTabComponents();

        locateThirdTabComponents();

        loadServiceCollections();

        pack();
    }

    private void initializeComponents(){

    	serviceRegistration = new ServiceRegistration();

        jLabel1 = new JLabel();
        jLabel2 = new JLabel();
        jLabel3 = new JLabel();

        jLabel4 = new JLabel( "a. Do you want to select one of the existing sources?" );
        jLabel4.setFont(new java.awt.Font("Tahoma", 0, 11));

        jLabel5 = new JLabel("b. Do you want to provide a new source?");
        jLabel5.setFont(new java.awt.Font("Tahoma", 0, 11));

        jLabel6 = new JLabel("Organization of Services by Reverse-engineering Abstractions");
        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 12));

        jLabel7 = new JLabel();
        jLabel7.setText("1. Select Service Collection");
        jLabel7.setFont(new java.awt.Font("Tahoma", 1, 11));

        jLabel8 = new JLabel();
        jLabel8.setText("2. Select Organization Mode");
        jLabel8.setFont(new java.awt.Font("Tahoma", 1, 11));

        jLabel9 = new JLabel("");
        jLabel9.setFont(new java.awt.Font("Garamond", 1, 16));

        jLabel10 = new JLabel("");
        jLabel10.setFont(new java.awt.Font("Garamond", 1, 14));

        jLabel11 = new JLabel("");
        jLabel11.setFont(new java.awt.Font("Garamond", 0, 14));

        jLabel12 = new JLabel("");
        jLabel12.setFont(new java.awt.Font("Garamond", 0, 14));

        jLabel13 = new JLabel("");
        jLabel13.setFont(new java.awt.Font("Garamond", 1, 14));

        jLabel14 = new JLabel("");
        jLabel14.setFont(new java.awt.Font("Garamond", 1, 13));

        jLabel15 = new JLabel("");
        jLabel15.setFont(new java.awt.Font("Garamond", 1, 13));

        jLabel16 = new JLabel("");

        jLabel17 = new JLabel("");

        jLabel18 = new JLabel("");
        
        jLabel19 = new JLabel("");

        jLabel23 = new JLabel( "Select the category of end-user in which you belong to:" );

        jLabel24 = new JLabel( "password:" );
        jLabel24.setFont( new java.awt.Font("Tahoma", 0, 11) );
        jLabel24.setEnabled( false );

        jPasswordField1 = new JPasswordField( 15 );
        jPasswordField1.setEnabled( false );

		//------------------------------
		jLabel20 = new JLabel("");
		jLabel21 = new JLabel("");
		jLabel22 = new JLabel("");
		jLabel20.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel20.setText("Functional Abstractions");

        jLabel21.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel21.setText("Non - Functional Abstractions");
        
        jLabel22.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel22.setText("SBQL statement to be executed");
		//------------------------------

        jScrollPane1 = new JScrollPane();
        jScrollPane2 = new JScrollPane();
        jScrollPane3 = new JScrollPane();

        //------------------------------
        jScrollPane4 = new JScrollPane();
        jScrollPane5 = new JScrollPane();
        //------------------------------

        jButton1 = new JButton( "New Collection" );
        jButton1.addActionListener( newCollectionActionListener() );
        jButton1.setEnabled(false);

        jButton2 = new JButton("Exit");
        jButton2.addActionListener( new ActionListener(){ public void actionPerformed( ActionEvent e ){ System.exit(0); } } );

        jButton3 = new JButton( "Select Source" );
        jButton3.addActionListener( selectSourceActionListener() );
        jButton3.setFont(new java.awt.Font("Tahoma", 0, 10));
        jButton3.setMaximumSize(new java.awt.Dimension(73, 13));
        jButton3.setMinimumSize(new java.awt.Dimension(73, 13));
        
        //------------------------------
        jButton12 = new JButton("Select file");
        jButton12.addActionListener( selectFileActionListener() );
        /*jButton12.setFont(new java.awt.Font("Tahoma", 0, 10));
        jButton12.setMaximumSize(new java.awt.Dimension(73, 13));
        jButton12.setMinimumSize(new java.awt.Dimension(73, 13));*/
		
		jButton13 = new JButton("Execute Query");
        jButton13.addActionListener( executeQueryActionListener() );
        
        jButton14 = new JButton("Show Represented Info");
        jButton14.addActionListener( showRepresentedInfoActionListener() );
        /*jButton13.setFont(new java.awt.Font("Tahoma", 0, 10));
        jButton13.setMaximumSize(new java.awt.Dimension(73, 13));
        jButton13.setMinimumSize(new java.awt.Dimension(73, 13));*/
        //------------------------------

        sourceChooser = new JFileChooser();
        sourceChooser.setCurrentDirectory( new File( "src/main/resources" ) );
        sourceChooser.setDialogTitle( "Select the folder name that corresonds to a source" );
        sourceChooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        sourceChooser.setAcceptAllFileFilterUsed(false);

        jButton4 = new JButton("Provide Source");
        jButton4.setFont(new java.awt.Font("Tahoma", 0, 10));
        jButton4.addActionListener( provideSourceActionListener() );
        jButton4.setEnabled( false );//TODO

        jButton5 = new JButton("Store Collection");
        jButton5.setEnabled( false );
        jButton5.addActionListener( storeCollectionActionListener() );

        jButton6 = new JButton( "Organize Services" );
        jButton6.addActionListener(organizeServices());

        if(serviceRegistration.getCollections().isEmpty()) jButton6.setEnabled(false);
        else jButton6.setEnabled(true);

        jButton7 = new JButton( "Exit" );
        jButton7.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){System.exit(0);}});

        jButton8 = new JButton( "Visualize Document" );
        jButton8.addActionListener( visualizeSelectedDocumentActionListener() );
        jButton8.setEnabled(false);

        jButton9 = new JButton( "Expand Documents" );
        jButton9.setVisible(false);
        jButton9.addActionListener( expandDocumentsActionListener() );

        jButton10 = new JButton( "Login" );
        jButton10.addActionListener( setPasswordActionListener() );

        jButton15 = new JButton( "Exit" );
        jButton15.addActionListener( new ActionListener(){ public void actionPerformed( ActionEvent e ){ System.exit(0); } } );


        jRadioButton1 = new JRadioButton("Non-functional abstractions nested into functional ones");
        jRadioButton1.addActionListener(selectModeActionListener());
        jRadioButton1.setFont(new java.awt.Font("Tahoma", 0, 13));
        jRadioButton1.setEnabled(false);

        jRadioButton2 = new JRadioButton("Functional abstractions nested into non-functional ones");
        jRadioButton2.addActionListener(selectModeActionListener());
        jRadioButton2.setFont(new java.awt.Font("Tahoma", 0, 13));
        jRadioButton2.setEnabled(false);

        jRadioButton3 = new JRadioButton("Functional and non-functional are independently developed");
        jRadioButton3.addActionListener(selectModeActionListener());
        jRadioButton3.setFont(new java.awt.Font("Tahoma", 0, 13));
        jRadioButton3.setEnabled(false);

        jRadioButton4 = new JRadioButton( "Curator of AoSBM" );
        jRadioButton4.addActionListener( selectUserCatergoryActionListener() );
        jRadioButton4.setFont( new java.awt.Font("Tahoma", 0, 13) );

        jRadioButton5 = new JRadioButton( "Choreography Designer - Developer" );
        jRadioButton5.addActionListener( selectUserCatergoryActionListener() );
        jRadioButton5.setFont( new java.awt.Font("Tahoma", 0, 13) );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setText("Create Service Collection");

        jLabel2.setText("1. Form target set of sources");

        jLabel3.setText("2. Retrieved functional documents whose included service instances are potentially described by values in non-functional properties");


        jTabbedPane1 = new JTabbedPane();

        jTabbedPane1.setFont( new java.awt.Font( "Tahoma", 1, 12 ) );

        jPanel1 = new JPanel();
        jPanel2 = new JPanel();
        jPanel3 = new JPanel();
        jPanel4 = new JPanel();
        jPanel5 = new JPanel();
        jPanel5.setBorder( BorderFactory.createBevelBorder( 1 ) );

        jTabbedPane1.addTab( "User Login - Authentication", jPanel4 );
        jTabbedPane1.addTab( "Service Registration", jPanel1 ); 
        jTabbedPane1.addTab( "Abstraction-oriented Service Organization", jPanel2 );
    }


    //****************** Zero Tab ******************
    private void locateZeroTabComponents(){

    	javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addGroup(jPanel5Layout.createSequentialGroup()
                                    .addGap(21, 21, 21)
                                    .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jRadioButton4)
                                        .addComponent(jRadioButton5)))
                                .addComponent(jLabel23))
                            .addGap(187, 187, 187))
                        .addGroup(jPanel5Layout.createSequentialGroup()
                            .addGap(74, 74, 74)
                            .addComponent(jLabel24)
                            .addGap(18, 18, 18)
                            .addComponent(jPasswordField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(179, 179, 179)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addComponent(jButton10)
                        .addGap(18, 18, 18)
                        .addComponent(jButton15)
                        .addGap(29, 29, 29))))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel23)
                .addGap(18, 18, 18)
                .addComponent(jRadioButton5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButton4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24)
                    .addComponent(jPasswordField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 103, Short.MAX_VALUE)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton10)
                    .addComponent(jButton15))
                .addContainerGap())
        );

    	 javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
         jPanel4.setLayout(jPanel4Layout);
         jPanel4Layout.setHorizontalGroup(
             jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
             .addGroup(jPanel4Layout.createSequentialGroup()
                 .addGap(273, 273, 273)
                 .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                 .addContainerGap(362, Short.MAX_VALUE))
         );
         jPanel4Layout.setVerticalGroup(
             jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
             .addGroup(jPanel4Layout.createSequentialGroup()
                 .addGap(148, 148, 148)
                 .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                 .addContainerGap(316, Short.MAX_VALUE))
         );
    }

    private ActionListener selectUserCatergoryActionListener() {

        return new ActionListener(){

			public void actionPerformed( ActionEvent e ){

				if( e.getSource() == jRadioButton4 && jRadioButton4.isSelected() ){

					userCategory = UserAuthenticationChecker.getCuratorCaterory();

					jRadioButton5.setSelected( false );

					jLabel24.setEnabled( true );

					jPasswordField1.setEnabled( true );
				}

				else if( e.getSource() == jRadioButton5 && jRadioButton5.isSelected() ){

					userCategory = UserAuthenticationChecker.getOtherCaterory();

					jRadioButton4.setSelected( false );

					jLabel24.setEnabled( false );

					jPasswordField1.setEnabled( false );
    	    	}
    	   	}
        };
    }

    private ActionListener setPasswordActionListener() {

        return new ActionListener(){

			@SuppressWarnings("deprecation")
			public void actionPerformed( ActionEvent e ){

				if( jPasswordField1.getText() != null && ! jPasswordField1.getText().toString().equals( "" ) ) curatorPassword = jPasswordField1.getText().toString();

				if( UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent(jPanel1 );
    	   	}
        };
    }


    //****************** First Tab ******************
    private void locateFirstTabComponents(){

    	javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel2)))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(48, 48, 48)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton4)
                            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(610, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 854, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton5)
                        .addGap(18, 18, 18)
                        .addComponent(jButton1)))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel9)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10)
                                    .addGroup(jPanel1Layout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jLabel11)
                                            .addComponent(jLabel17)
                                            .addComponent(jLabel18)
                                            .addComponent(jLabel14)
                                            .addComponent(jLabel15)
                                            .addComponent(jLabel12)))
                                    .addComponent(jLabel16)
                                    .addComponent(jLabel13)))
                            .addComponent(jButton9))
                        .addContainerGap(126, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton2)
                        .addContainerGap())))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(12, 12, 12)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(13, 13, 13)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jButton4))
                .addGap(18, 18, 18)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jButton9)
                        .addGap(42, 42, 42)
                        .addComponent(jLabel9)
                        .addGap(11, 11, 11)
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jLabel11)
                        .addGap(4, 4, 4)
                        .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jLabel13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel15)
                        .addGap(16, 16, 16)
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel18))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 507, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(jButton5)
                    .addComponent(jButton8))
                .addGap(23, 23, 23))
        );
    }

    private ActionListener selectSourceActionListener(){

        return new ActionListener(){

            public void actionPerformed(ActionEvent e){

            	Thread thread = new Thread( new Runnable(){

                    public void run(){

                    	if( ! UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent(jPanel4 );

                    	else{

			                int retval = sourceChooser.showOpenDialog( AoSBM );
			
			                if ( retval == JFileChooser.APPROVE_OPTION ) {
			
			                    File source = sourceChooser.getSelectedFile();
			
			                    String ref2Source = source.getAbsolutePath();
	
	
			                    serviceRegistration.register( "Local File System", ref2Source );
	
	
			                    loadParsingStatistics( ref2Source );
			
			                    visualizeCurrentCollection();//1st tab.
			
			                	loadServiceCollections();//2nd tab.
			
			                	disellectedModeRadioButton();//2nd tab.
			
			                	disableModeRadioButton();//2nd tab.
	
			                	jButton8.setEnabled( false );//Button 'Visualize document'.
	
			                	if( serviceRegistration.isCurrentCollectionEmpty() ){
	
			                		jButton1.setEnabled( false );//Button 'New collection'
			                		jButton9.setVisible( false );//Button 'Expand documents'.
			                	}
	
				        		else{
	
				        			jButton1.setEnabled( true );//Button 'New collection'
				        			jButton5.setEnabled( true );//Button 'New collection'
				        			jButton9.setVisible( true );//Button 'Expand documents'.
				        		}
			                }
                    	}
                    }
            	});


            	thread.setPriority( Thread.MAX_PRIORITY );  
                thread.start();
            }
        };
    }

    private ActionListener provideSourceActionListener(){

    	return new ActionListener(){

            public void actionPerformed(ActionEvent e){

            	Thread thread = new Thread( new Runnable(){

                    public void run(){

                    	if( ! UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent( jPanel4 );

                    	else{

			                String ref2Source = null;
	
			        		serviceRegistration.register( "UDDI", ref2Source );
			
			        		loadParsingStatistics( ref2Source );
			
			        		visualizeCurrentCollection();//1st tab.
			
			        		loadServiceCollections();//2nd tab.
			
			        		disellectedModeRadioButton();//2nd tab.
			
			        		disableModeRadioButton();//2nd tab.
	
			        		jButton8.setEnabled( false );//Button 'Visualize document'.
	
	
		                	if( serviceRegistration.isCurrentCollectionEmpty() ){
	
		                		jButton1.setEnabled( false );//Button 'New collection'
		                		jButton9.setVisible( false );//Button 'Expand documents'.
		                	}
	
			        		else{
	
			        			jButton1.setEnabled( true );//Button 'New collection'
			        			jButton9.setVisible( true );//Button 'Expand documents'.
			        		}
                    	}
                    }
            	});


            	thread.setPriority( Thread.MAX_PRIORITY ); thread.start();
            }
        };
    }

    private void loadParsingStatistics( String ref2Source ){

    	jLabel9.setText("Source statistics");

    	jLabel10.setText("Retrieved service types: " + serviceRegistration.getCurrentCollectionNumOfServiceTypes());

    	jLabel11.setText("Interfaces: " + serviceRegistration.getCurrentCollectionNumOfInterfaces() );

    	jLabel12.setText("Instances: "  + serviceRegistration.getCurrentCollectionNumOfInstances() );

    	jLabel13.setText("Non-funct. described instances: "  + serviceRegistration.getNumOfInstancesWithNonFunctionalDescription( ref2Source ) );
    }

    private void visualizeCurrentCollection(){

    	DefaultMutableTreeNode root = serviceRegistration.visualizeCurrentCollection();
    	
    	jTree1 = new JTree( root );

    	jTree1.addTreeSelectionListener( selectDocumentActionListener() );

    	jScrollPane1.setViewportView( jTree1 );

    	jTree1 = JTreeManipulation.expand( 3, jTree1, new TreePath( root ) );
    }

    private ActionListener expandDocumentsActionListener(){

        return new ActionListener(){

			public void actionPerformed( ActionEvent e ){

				if( expand ){

					jButton9.setText( "Expand documents" );

					expand = false;
				}

				else{

					jButton9.setText( "Collapse documents" );

					expand = true;
				}

				expandDocuments();
            }
        };
    }

    private void expandDocuments(){

		DefaultMutableTreeNode root = serviceRegistration.visualizeCurrentCollection();

		if( root == null ) return;

		jTree1 = new JTree(root);

		jTree1.addTreeSelectionListener( selectDocumentActionListener() );

		jScrollPane1.setViewportView(jTree1);

		if( expand ) jTree1 = JTreeManipulation.expand( jTree1, new TreePath( root ) );

		else jTree1 = JTreeManipulation.expand( 3, jTree1, new TreePath( root ) );


		jButton1.setEnabled(true);
		jButton8.setEnabled( false );
    }

    private TreeSelectionListener selectDocumentActionListener(){

        return new TreeSelectionListener(){

        	public void valueChanged( TreeSelectionEvent ew ){

        		path1 = ew.getPath();

        		if( jTree1 != null && path1 != null ){

        			int pathCount = path1.getPathCount();

            		if( pathCount != 1 && pathCount != 2 && pathCount != 3 ){

            			selectedRef2Source = path1.getPathComponent( 2 ).toString();

            			selectedRef2DocOfFuncProperties = path1.getPathComponent( 3 ).toString();

            			jButton8.setEnabled(true);
            		}

            		else jButton8.setEnabled( false );
        		}
        	}
        };
    }

    private ActionListener visualizeSelectedDocumentActionListener(){

        return new ActionListener(){

            public void actionPerformed(ActionEvent e){

            	if( serviceRegistration.getDocOfFuncProperties( selectedRef2Source, selectedRef2DocOfFuncProperties ) == null ) JOptionPane.showMessageDialog(null, "The object of the selected document was not found."); 
            		
            	else{

            		DocOfFuncProperties docOfFuncProperties = serviceRegistration.getDocOfFuncProperties( selectedRef2Source, selectedRef2DocOfFuncProperties );

            		DefaultMutableTreeNode serviceTypesNode = docOfFuncProperties.visualize( selectedRef2Source, "Service Types" );
            		DefaultMutableTreeNode interfacesNode = docOfFuncProperties.visualize( selectedRef2Source, "Service Interfaces" );
            		DefaultMutableTreeNode instancesNode = docOfFuncProperties.visualize( selectedRef2Source, "Service Instances" );
            		DefaultMutableTreeNode operationsNode = docOfFuncProperties.visualize( selectedRef2Source, "Service Operations" );
            		DefaultMutableTreeNode messagesNode = docOfFuncProperties.visualize( selectedRef2Source, "Service Messages" );
            		DefaultMutableTreeNode schemasNode = docOfFuncProperties.visualize( selectedRef2Source, "Schema" );

            		new DocumentVisualizer( selectedRef2Source, selectedRef2DocOfFuncProperties, serviceTypesNode, interfacesNode, instancesNode, operationsNode, messagesNode, schemasNode );
            	}
            }
        };
    }

    private ActionListener newCollectionActionListener(){

        return new ActionListener(){

            public void actionPerformed( ActionEvent e ){

            	serviceRegistration.createNewCollection();

            	jTree1 = null;
                jScrollPane1.setViewportView( jTree1 );

                jButton1.setEnabled( false );
                jButton8.setEnabled( false );
                jButton9.setVisible( false );
            }
        };
    }
    
    private ActionListener storeCollectionActionListener(){

    	return new ActionListener(){

			public void actionPerformed( ActionEvent e ){

				if( ! UserAuthenticationChecker.isCurator( userCategory ) ) PrintMessages.print( PrintMessages.guiPrint, "You do not have the priviledge to use the store functionality." );

				else ServiceBaseController.storeCollection( serviceRegistration.getCurrentCollection(), "" );
            }
        };
    }


	//****************** Second Tab ******************
    private void locateSecondTabComponents(){

    	javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel2Layout.createSequentialGroup()
                        .addGap(38, 38, 38)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 1054, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel8)
                                    .addGroup(jPanel2Layout.createSequentialGroup()
                                        .addGap(10, 10, 10)
                                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(jRadioButton2)
                                            .addComponent(jRadioButton1)
                                            .addComponent(jRadioButton3)))))
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 751, Short.MAX_VALUE)
                        .addComponent(jButton6)
                        .addGap(18, 18, 18)
                        .addComponent(jButton7)))
                .addGap(59, 59, 59))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 433, Short.MAX_VALUE)
                .addGap(11, 11, 11)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButton2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButton3)
                .addGap(23, 23, 23)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton7)
                    .addComponent(jButton6))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Abstraction-oriented Service Organization", jPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 1156, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addContainerGap())
        );
    }

    private void loadServiceCollections(){

    	DefaultMutableTreeNode root = serviceRegistration.visualize();
    	
    	jTree2 = new JTree(root);
       	jTree2.addTreeSelectionListener(selectCollection());

       	jTree2 = JTreeManipulation.expand( 2, jTree2, new TreePath(root));

        jScrollPane2.setViewportView(jTree2);

        jButton6.setEnabled(false);

        if( serviceRegistration.isParsed() ){

        	jRadioButton1.setEnabled(true);
        	jRadioButton2.setEnabled(true);
        	jRadioButton3.setEnabled(true);

        	jRadioButton1.setSelected(false);
        	jRadioButton2.setSelected(false);
			jRadioButton3.setSelected(false);
        }

        else{

        	jRadioButton1.setEnabled(false);
        	jRadioButton2.setEnabled(false);
        	jRadioButton3.setEnabled(false);
        }
    }

    private TreeSelectionListener selectCollection(){

        return new TreeSelectionListener(){

        	public void valueChanged( TreeSelectionEvent treeSelectionEvent ){

        		path2 = treeSelectionEvent.getPath();

        		if( path2 != null ){

		    		int pathCount = path2.getPathCount();

		    		if( pathCount == 2 ){

		    			String collectionName = path2.getPathComponent(1).toString();

	        			String collectionID = findExtensionAfterSpace( collectionName );

	        			selectedCollectionID = Integer.parseInt( collectionID ) - 1;

	        			/*if(serviceRegistration.getCollections().get(selectedCollectionID).getNumOfDocs() == 0 ){//TODO

	        				disableModeRadioButton();
	        				jButton11.setEnabled(false);//Parse button!
	        				jButton6.setEnabled(false);//Organize button!
	        				clearParsingStatistics();
	        				JOptionPane.showMessageDialog(null, "The selected collection does not contain any document!");
	        			}

	        			else*/ if( serviceRegistration.getCollections().get( selectedCollectionID ).isParsed() ){

	        				enableModeRadioButton();
	        				disellectedModeRadioButton();
	        	        	jButton6.setEnabled(false);//Organize button!
		        		}

	        			else{//Not parsed and at least one document!
	        				disableModeRadioButton();
	        				disellectedModeRadioButton();
	        				clearParsingStatistics();
	        	        	jButton6.setEnabled( false );//Organize button!
		        		}

	        			if( userSettings == null ){

	        				userSettings = new UserSettings( selectedCollectionID, userCategory, curatorPassword );

	        				//JOptionPane.showMessageDialog(null, "This is the first time that you select a collection");

	        				userSettings.setExistingNonFuncDocs( serviceRegistration.existNonFuncDescriptions( selectedCollectionID ) );
	        			}

	        			else if( selectedCollectionID.equals( userSettings.getCollectionID() )){
	        				//JOptionPane.showMessageDialog(null, "You have selected the same collection again!");
	        			}

	        			else{

	        				userSettings.setCollectionID( selectedCollectionID );
	        				//options.setMode(abstractionBase.getMode(selectedCollectionID));//TODO
	        				//options.setNamingDistanceType(abstractionBase.getNamingDistanceType(selectedCollectionID));
	        				//options.setStructured( abstractionBase.isStructured(selectedCollectionID) );

	        				//if( options.getMode() != null ) activateModeRadioButton(options.getMode().intValue());

	        				//JOptionPane.showMessageDialog(null, "You selected a different collection than before");
	        			}
		    		}

		    		else{
		    			disableModeRadioButton();

        	        	jButton6.setEnabled(false);
	        		}
		    	}

        		else{
        			disableModeRadioButton();

    	        	jButton6.setEnabled(false);
        		}
        	}
        };
    }

    private String findExtensionAfterSpace(String phrase){

		if( phrase == null ) return phrase;

		int pos = phrase.lastIndexOf(" ");

		if( pos > 0 ) return phrase.substring( pos + 1, phrase.length() );

		return phrase;
	}

    private void clearParsingStatistics(){

    	jLabel9.setText("");
		jLabel10.setText("");
		jLabel11.setText("");
		jLabel12.setText("");
		jLabel13.setText("");
		jLabel14.setText("");
		jLabel15.setText("");
		jLabel16.setText("");
    }

    private void disableModeRadioButton(){

    	jRadioButton1.setEnabled(false);
        jRadioButton2.setEnabled(false);
       	jRadioButton3.setEnabled(false);
    }

    private void enableModeRadioButton(){

    	jRadioButton1.setEnabled( false );
        jRadioButton2.setEnabled( false );
       	jRadioButton3.setEnabled( true );
    }

    private void disellectedModeRadioButton(){

    	jRadioButton1.setSelected(false);
        jRadioButton2.setSelected(false);
       	jRadioButton3.setSelected(false);
    }

    private ActionListener selectModeActionListener() {

        return new ActionListener(){

			public void actionPerformed( ActionEvent e ){

				if((e.getSource() == jRadioButton1 && !jRadioButton1.isSelected()) || (e.getSource() == jRadioButton2 && !jRadioButton2.isSelected()) || (e.getSource() == jRadioButton3 && !jRadioButton3.isSelected()))
					userSettings.setMode(0);

				else if(e.getSource() == jRadioButton1 && jRadioButton1.isSelected()){
					userSettings.setMode(1);
					jRadioButton2.setSelected(false);
					jRadioButton3.setSelected(false);

					jButton6.setEnabled( true );//Organize button!
				}

				else if(e.getSource() == jRadioButton2 && jRadioButton2.isSelected()){
					userSettings.setMode(2);
    	    		jRadioButton1.setSelected(false);
					jRadioButton3.setSelected(false);

					jButton6.setEnabled( true );//Organize button!
    	    	}

				else if(e.getSource() == jRadioButton3 && jRadioButton3.isSelected()){
					userSettings.setMode(3);
    	   			jRadioButton2.setSelected(false);
					jRadioButton1.setSelected(false);

					jButton6.setEnabled( true );//Organize button!
    	   		}
    	   	}
        };
    }

    private ActionListener organizeServices() {

        return new ActionListener(){

			public void actionPerformed( ActionEvent actionEvent ){

				if( userSettings.getMode() == null || ( userSettings.getMode() != null && userSettings.getMode() == 0 ) ) JOptionPane.showMessageDialog(null, "You have to select an organization mode!");

	        	else{

	        		if( abstractionBase == null ) abstractionBase = new AbstractionBaseController( serviceRegistration );

	        		if( serviceOrganization == null) serviceOrganization = new ServiceOrganizationController();


	        		new ServiceOrganizationVisualizer( serviceRegistration, abstractionBase, serviceOrganization, userSettings );
	        		new ParameterizedServiceOrganizationVisualizer( serviceRegistration, abstractionBase, serviceOrganization, userSettings );
	        	}
    	   	}
        };
    }


    //****************** Third Tab ******************
    private void locateThirdTabComponents(){

    	javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(38, 38, 38)
                                .addComponent(jButton12)
                                .addGap(59, 59, 59)
                                .addComponent(jButton13))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 621, Short.MAX_VALUE)
                                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 621, Short.MAX_VALUE)
                                    .addComponent(jLabel21)
                                    .addComponent(jLabel20))))
                        .addGap(18, 18, 18)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton14)
                            .addComponent(jLabel22)
                            .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 484, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel19)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel19)
                .addGap(14, 14, 14)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton12)
                    .addComponent(jButton13))
                .addGap(30, 30, 30)
                .addComponent(jLabel20)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addComponent(jButton14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 95, Short.MAX_VALUE)
                        .addComponent(jLabel22)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 283, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(164, 164, 164))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 248, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(37, 37, 37)
                        .addComponent(jLabel21)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 248, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(32, Short.MAX_VALUE))))
        );

        jTabbedPane1.addTab("Query Engine", jPanel3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 1156, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(46, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addContainerGap())
        );
    }


    private ActionListener selectFileActionListener(){

        return new ActionListener(){

            public void actionPerformed(ActionEvent e){

            	Thread thread = new Thread( new Runnable(){

                    public void run(){

                    	if( ! UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent(jPanel4 );

                    	else{

	                    	fileContent = "";
			                JFileChooser fileDialog = new JFileChooser();
			                fileDialog.setFileFilter(new FileNameExtensionFilter("Text Files", "txt", "rtf"));
			                int retval = fileDialog.showOpenDialog( AoSBM );
			                
			                jScrollPane5.setViewportView(null);
			                
			                if ( retval == JFileChooser.APPROVE_OPTION ) {
			
			                	File selectedFile = fileDialog.getSelectedFile();
			                	String filepath = selectedFile.getAbsolutePath();
			                	
			                	try{
			                		FileInputStream fstream = new FileInputStream(filepath);
			                		//get the object of DataInputStream
			                		DataInputStream in = new DataInputStream(fstream);
			                		BufferedReader br = new BufferedReader(new InputStreamReader(in));
			                		String strLine;
			                		while ((strLine = br.readLine()) != null){
			                			fileContent = fileContent.concat(strLine + "\n");
			                		}
			                		
			                		JTextArea queryToBeExecuted = new JTextArea(fileContent);
			                		queryToBeExecuted.setColumns(70);
			                		queryToBeExecuted.setRows(35);
			                		queryToBeExecuted.setEditable(false);
			                		jScrollPane5.setViewportView(queryToBeExecuted);
			                		
			                	}catch (Exception e){//Catch exception if any
			            			System.err.println("Error selectFile_ActionListener: " + e.getMessage());
			            		}
			                }
                    	}
                    }
            	});

            	thread.setPriority( Thread.MAX_PRIORITY );
                thread.start();
            }
            
        };
    }
	
	private ActionListener executeQueryActionListener(){

    	return new ActionListener(){

            public void actionPerformed( ActionEvent e ){

            	Thread thread = new Thread( new Runnable(){

                    public void run(){

                    	if( ! UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent(jPanel4 );

                    	else{

	                    	JTree jTree3, jTree4;
	                    	QueryEngineController qEngine = new QueryEngineController();
	                    	                    	
		                	qEngine.executeLookupQuery("", fileContent);
		                	fileContent = "";
		                		                	
		                	jScrollPane3.setViewportView(null);
		                	jScrollPane4.setViewportView(null);
		                		                	
		                	DefaultMutableTreeNode root1 = null;
		                	DefaultMutableTreeNode root2 = null;
		                	root3 = null;
		                	
		                	if (qEngine.getFunctionalHierarchyToVisualize() != null){
		                		root1 = qEngine.getFunctionalHierarchyToVisualize().visualize();
		                		root3 = qEngine.getFunctionalHierarchyToVisualize().visualize();
		                	}
		                	if (qEngine.getNonFunctionalHierarchyToVisualize() != null){
		                		root2 = qEngine.getNonFunctionalHierarchyToVisualize().visualize();
		                	}
		                	
		                	ArrayList <FunctionalAbstraction> functionalAbstractionsToVisualize = qEngine.getRetrievedFunctionalAbstractions();
		                	ArrayList <NonFunctionalAbstraction> nonFunctionalAbstractionsToVisualize = qEngine.getRetrievedNonFunctionalAbstractions();
		                	
		                	if (functionalAbstractionsToVisualize.size() == 0){
		                		JOptionPane.showMessageDialog(null, "There are not functional abstractions that match your criteria!", "alert", JOptionPane.INFORMATION_MESSAGE);
		                	}
		                	if (nonFunctionalAbstractionsToVisualize.size() == 0){
		                		JOptionPane.showMessageDialog(null, "There are not non functional abstractions that match your criteria!", "alert", JOptionPane.INFORMATION_MESSAGE);
		                	}
		                	
		                	ArrayList <Integer> functionalRoots = qEngine.getFunctionalRoots();
		                	for (int i = 0; i < functionalRoots.size(); i++){
		                		
		                		if (qEngine.getResultSetType() == 0){	//show only representative info
		                			functionalAbstractionsToVisualize.get(functionalRoots.get(i)).visualizeForQueryResults2(functionalAbstractionsToVisualize.get(functionalRoots.get(i)).getRepresentedInterfaces().size(), root1);
		                		}
		                		else{	//show both representative and represented info
		                			functionalAbstractionsToVisualize.get(functionalRoots.get(i)).visualizeForQueryResults2(functionalAbstractionsToVisualize.get(functionalRoots.get(i)).getRepresentedInterfaces().size(), root1);
		                			root3.add(functionalAbstractionsToVisualize.get(functionalRoots.get(i)).visualizeForQueryResults(functionalAbstractionsToVisualize.get(functionalRoots.get(i)).getRepresentedInterfaces().size()));
		                		}
		                		
		                	}
		                	
		                	ArrayList <Integer> nonFunctionalRoots = qEngine.getNonFunctionalRoots();
		                	for (int i = 0; i < nonFunctionalRoots.size(); i++){
		                		nonFunctionalAbstractionsToVisualize.get(i).visualizeForQueryResults(root2);
		                	}
		                	
		                	if (root1 != null){
		                		jTree3 = new JTree(root1);
		                		jTree3.setEditable(true);
		                		jScrollPane3.setViewportView( jTree3 );
	
		                		jTree3 = JTreeManipulation.expand( jTree3, new TreePath( root1 ) );
		                	}
		                	
		                	if (root2 != null){
		                		jTree4 = new JTree(root2);
		                		jTree4.setEditable(true);
		                		jScrollPane4.setViewportView( jTree4 );
	
		                		jTree4 = JTreeManipulation.expand( jTree4, new TreePath( root2 ) );
		                	}
                    	}
                    }
            	});

            	thread.setPriority( Thread.MAX_PRIORITY );  
                thread.start();
            }
            
        };
    }
	
	private ActionListener showRepresentedInfoActionListener(){

		return new ActionListener(){

            public void actionPerformed( ActionEvent e ){

            	Thread thread = new Thread( new Runnable(){

                    public void run(){

                    	if( ! UserAuthenticationChecker.isAuthorizedForServiceRegistration( userCategory, curatorPassword ) ) jTabbedPane1.setSelectedComponent(jPanel4 );

                    	else{

	                    	if ( root3 != null ){
	
	                    		JTree jTree1 = new JTree(root3);
	                    		jTree1.setEditable(true);
	                    		jScrollPane3.setViewportView( jTree1 );
		
	                    		jTree1 = JTreeManipulation.expand( jTree1, new TreePath( root3 ) );
		                    }
	                    }
                    }
            	});

            	thread.setPriority( Thread.MAX_PRIORITY );
                thread.start();
            }
            
        };
	
	}


    public static void main( String args[] ) {

    	java.awt.EventQueue.invokeLater( new Runnable() {

            public void run(){

            	if( UserAuthenticationChecker.check() ) new ServiceRegistrationVisualizer();

            	else PrintMessages.print( "You do not have the privilege of using this software!\n\nPlease e-mail the mac address of your machine to the administrator of this software (dionysiscsuoi@yahoo.com)!" );
            }
    	});
	}

    /*public static void main( String args[] ) {

    	java.awt.EventQueue.invokeLater( new Runnable() {

            public void run(){

            	new ServiceRegistrationVisualizer();
            }
    	});
	}*/
}