package org.ow2.choreos.gui.interfaceMappingsVisualizer.components;


import javax.swing.JMenuItem;

import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnection;

/**
 *
 * This class extends {@link JMenuItem JMenuItem} and represents a JMenuItem with
 * a {@link VisualComponentConnection VisualComponentConnection} component attached.
 * <p>This class provides a getter and setter for the VisualComponentConnection component
 */
public class MappingMenuItem extends JMenuItem{
    /**
	 * 
	 */
	private static final long serialVersionUID = -2149931022693351911L;
	VisualComponentConnection mapping;

    /**
     * Creates a {@code MappingMenuItem} with the specified {@code VisualComponentConnection}
     * and text
     * @param mapping An instance of {@code VisualComponentConnection}
     * @param text the text of the {@code JMenuItem}
     */
    public MappingMenuItem(VisualComponentConnection mapping, String text){
        super(text);
        this.mapping = mapping;
    }

    public VisualComponentConnection getMapping() {
        return mapping;
    }

    public void setConnection(VisualComponentConnection mapping) {
        this.mapping = mapping;
    }
}
