/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MappingsInfoDialog.java
 *
 * Created on 25 Ιουν 2012, 2:42:55 πμ
 */

package org.ow2.choreos.gui.interfaceMappingsVisualizer.components;


import java.awt.Color;
import java.util.ArrayList;

import javax.swing.AbstractListModel;
import javax.swing.JList;

import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnection;


/**
 *
 * @author user
 */
public class MappingsInfoDialog extends javax.swing.JDialog {
    /**
	 * 
	 */
	private static final long serialVersionUID = 8072335700895820920L;
	public static final int EXISTING = 0;
    public static final int TO_BE_ADDED = 1;
    public static final int TO_BE_DELETED = 2;


    private ArrayList<VisualComponentConnection> existingMappings;
    private ArrayList<VisualComponentConnection> addedMappings;
    private ArrayList<VisualComponentConnection> deletedMappings;

    /** Creates new form MappingsInfoDialog */
    public MappingsInfoDialog(java.awt.Dialog parent) {
        this(parent,null,null,null);
        initComponents();
    }

    public MappingsInfoDialog(java.awt.Dialog parent,
            ArrayList<VisualComponentConnection> existingConnections,
            ArrayList<VisualComponentConnection> addedConnections,
            ArrayList<VisualComponentConnection> deletedConnections) {
        super(parent);
        this.existingMappings = existingConnections;
        this.addedMappings = addedConnections;
        this.deletedMappings = deletedConnections;
        initComponents();
        initList();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
	private void initComponents() {

        scrollPane = new javax.swing.JScrollPane();
        mappingsInfoList = new javax.swing.JList();
        separator = new javax.swing.JSeparator();
        sourceLabel = new javax.swing.JLabel();
        destLabel = new javax.swing.JLabel();
        stateLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Mappings' Info");
        setResizable(false);

        mappingsInfoList.setModel(new javax.swing.AbstractListModel() {
            /**
			 * 
			 */
			private static final long serialVersionUID = -5330323905534276301L;
			String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        mappingsInfoList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                mappingsInfoListValueChanged(evt);
            }
        });
        scrollPane.setViewportView(mappingsInfoList);

        separator.setOrientation(javax.swing.SwingConstants.VERTICAL);

        sourceLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        sourceLabel.setBorder(javax.swing.BorderFactory.createTitledBorder("Source"));

        destLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        destLabel.setBorder(javax.swing.BorderFactory.createTitledBorder("Destination"));

        stateLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        stateLabel.setBorder(javax.swing.BorderFactory.createTitledBorder("State"));
        stateLabel.setOpaque(true);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(scrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 535, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(separator, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(stateLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                    .addComponent(sourceLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                    .addComponent(destLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(sourceLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(destLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(stateLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(separator, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE)
                    .addComponent(scrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mappingsInfoListValueChanged(javax.swing.event.ListSelectionEvent evt) {
        MappingInfo info = (MappingInfo) mappingsInfoList.getSelectedValue();
        VisualComponentConnection mapping = info.getMapping();
        sourceLabel.setText(mapping.getSourcePath().getLastPathComponent().toString());
        destLabel.setText(mapping.getDestPath().getLastPathComponent().toString());
        switch(info.getState()){
            case EXISTING:
                stateLabel.setText("Existing Mapping");
                stateLabel.setBackground(Color.cyan);
                break;
            case TO_BE_ADDED:
                stateLabel.setText("To be Added Mapping");
                stateLabel.setBackground(Color.green);
                break;
            case TO_BE_DELETED:
                stateLabel.setText("To be Deleted Mapping");
                stateLabel.setBackground(Color.red);
                break;
            default: break;
        }
    }

    @SuppressWarnings("unchecked")
	private void initList(){
        final ArrayList<MappingInfo> mappingsInfo = new ArrayList<MappingInfo>();

        if(existingMappings != null){
            for(int i=0; i<existingMappings.size();i++)
                mappingsInfo.add(new MappingInfo(existingMappings.get(i),EXISTING));
        }
        if(addedMappings != null){
            for(int i=0; i<addedMappings.size();i++)
                mappingsInfo.add(new MappingInfo(addedMappings.get(i),TO_BE_ADDED));
        }
        if(deletedMappings != null){
            for(int i=0; i<deletedMappings.size();i++)
                mappingsInfo.add(new MappingInfo(deletedMappings.get(i),TO_BE_DELETED));
        }

        AbstractListModel model = new AbstractListModel() {

            /**
			 * 
			 */
			private static final long serialVersionUID = 7879773045829505701L;

			public int getSize() {
                return mappingsInfo.size();
            }

            public Object getElementAt(int index) {
                return mappingsInfo.get(index);
            }
        };
        mappingsInfoList.setModel(model);
    }

    @SuppressWarnings("unchecked")
	public JList getMappingsList() {
        return mappingsInfoList;
    }

    @SuppressWarnings("unchecked")
	public ArrayList getAddedMappings() {
        return addedMappings;
    }

    @SuppressWarnings("unchecked")
	public ArrayList getDeletedMappings() {
        return deletedMappings;
    }

//    /**
//    * @param args the command line arguments
//    */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                MappingsInfoDialog dialog = new MappingsInfoDialog(new javax.swing.JFrame(), true);
//                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
//                    public void windowClosing(java.awt.event.WindowEvent e) {
//                        System.exit(0);
//                    }
//                });
//                dialog.setVisible(true);
//            }
//        });
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    @SuppressWarnings("unchecked")
	private javax.swing.JList mappingsInfoList;
    private javax.swing.JLabel destLabel;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JSeparator separator;
    private javax.swing.JLabel sourceLabel;
    private javax.swing.JLabel stateLabel;
    // End of variables declaration//GEN-END:variables

}
class MappingInfo {
    private VisualComponentConnection mapping;
    private int state;

    public MappingInfo(VisualComponentConnection mapping, int state) {
        this.mapping = mapping;
        this.state = state;
    }

    public VisualComponentConnection getMapping() {
        return mapping;
    }

    public int getState() {
        return state;
    }

    public String toString() {
        return mapping.toString();
    }

}