/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ow2.choreos.gui.interfaceMappingsVisualizer.components;


import java.util.ArrayList;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.JSeparator;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.abstractionDrivenServiceOrganization.mappings.functionalRepresentation.service.interfaceMappingsToJTrees.MenuScroller;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.listeners.InterfaceMappingsVisualizerListener;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.listeners.PopupListener;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnection;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnectionUtils;


/**
 *
 * @author user
 */
public class MappingsManagementPopupMenu extends JPopupMenu {

   	private static final long serialVersionUID = 8242722846705133483L;
	private JMenuItem addMappingMenuItem;
    private JMenu cancelAddingMappingMenu;
    private JMenu deleteMappingMenu;
    private JMenuItem deleteAllMappingsMenuItem;
    private JMenuItem deleteAllMappingsFromSelectedMenuItem;
    private JSeparator popupSeparator1;
    private JSeparator popupSeparator2;
    private JSeparator popupSeparator3;
    private MappingsPanel container;
    private InterfaceMappingsVisualizerListener callbackOperations;

    public MappingsManagementPopupMenu(MappingsPanel container, InterfaceMappingsVisualizerListener callbackOperations) {
        this.container = container;
        this.callbackOperations = callbackOperations;
        initMenu();
    }

    private void initMenu() {
        addMappingMenuItem = new JMenuItem();
        deleteAllMappingsFromSelectedMenuItem = new JMenuItem();
        deleteAllMappingsMenuItem = new JMenuItem();
        deleteMappingMenu = new JMenu();
        cancelAddingMappingMenu = new JMenu();

        popupSeparator1 = new JSeparator();
        popupSeparator2 = new JSeparator();
        popupSeparator3 = new JSeparator();

        addMappingMenuItem.setIcon(new javax.swing.ImageIcon("Icons/addIcon.png")); // NOI18N
        addMappingMenuItem.setText("Add Mapping..");
        addMappingMenuItem.setToolTipText("");
        addMappingMenuItem.setEnabled(false);
        addMappingMenuItem.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addMappingMenuItemActionPerformed(evt);
            }
        });
        this.add(addMappingMenuItem);
        this.add(popupSeparator1);

        deleteMappingMenu.setIcon(new javax.swing.ImageIcon("Icons/deleteIcon.png")); // NOI18N
        deleteMappingMenu.setText("Delete specific Mapping:");
        deleteMappingMenu.setEnabled(false);
        deleteMappingMenu.setName("deleteMappingMenu"); // NOI18N
        this.add(deleteMappingMenu);

        deleteAllMappingsFromSelectedMenuItem.setIcon(new javax.swing.ImageIcon("Icons/deleteIcon.png")); // NOI18N
        deleteAllMappingsFromSelectedMenuItem.setText("Delete All Mappings from or to a Node..");
        deleteAllMappingsFromSelectedMenuItem.setEnabled(false);
        deleteAllMappingsFromSelectedMenuItem.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAllMappingsFromSelectedMenuItemActionPerformed(evt);
            }
        });
        this.add(deleteAllMappingsFromSelectedMenuItem);
        this.add(popupSeparator2);

        deleteAllMappingsMenuItem.setIcon(new javax.swing.ImageIcon("Icons/deleteIcon.png")); // NOI18N
        deleteAllMappingsMenuItem.setText("Delete All Mappings");
        deleteAllMappingsMenuItem.setToolTipText("Deletes all existing Mappings");
        deleteAllMappingsMenuItem.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteAllMappingsActionPerformed(evt);
            }
        });
        this.add(deleteAllMappingsMenuItem);
        this.add(popupSeparator3);

        cancelAddingMappingMenu.setIcon(new javax.swing.ImageIcon("Icons/cancelAddIcon.png")); // NOI18N
        cancelAddingMappingMenu.setText("Cancel adding a new mapping");
        this.add(cancelAddingMappingMenu);

        MenuScroller.setScrollerFor(deleteMappingMenu, 10, 50);
        MenuScroller.setScrollerFor(cancelAddingMappingMenu, 10, 50);
        this.addPopupMenuListener(new PopupListener(this));
    }

    /**
     * Shows the {@code popup} at the {@code (xLoc,yLoc)} and having {@code tree JTree} as invoker
     * @param tree An instance of {@code Jtree}
     * @param xLoc An integer indicating the x coordinate of the popup menu
     * @param yLoc An integer indicating the y coordinate of the popup menu
     */
    @SuppressWarnings("static-access")
	public void showPopupMenu(JTree tree, int xLoc, int yLoc) {
        int row = tree.getRowForLocation(xLoc, yLoc);
        tree.setSelectionRow(row);
        TreePath aPath = null;
        if (row == -1) {
            return;
        }

        if (tree.equals(container.getSourceTree())) {
            aPath = container.getSourceTree().getSelectionPath();
            if (aPath != null) {
                generatePopupMenu(container.SOURCE_TREE, aPath);
            }
        } else if (tree.equals(container.getDestTree())) {
            aPath = container.getDestTree().getSelectionPath();
            if (aPath != null) {
                generatePopupMenu(container.DESTINATION_TREE, aPath);
            }
        }
        this.show(tree, xLoc, yLoc);
    }

    /**
     * Generates the popupMenu's menu items  and its submenus. The popup is shown
     * only when triggered from a mouse event on the Last Component of the TreePath Parameter
     *
     * @param treeId An integer Indicating which tree {@code aPath} TreePath belongs too.
     * <ul>Valid IDs from an instance of {@link MappingsPanel} class are:
     * <li>SOURCE_TREE
     * <li>DESTINATION_TREE
     * </ul>
     * @param aPath An instance of {@code TreePath}
     */
    @SuppressWarnings("static-access")
	private void generatePopupMenu(int treeId, TreePath aPath) {
        generateAddMappingMenuItem(treeId, aPath);
        generateCancelAddingMappingMenu(treeId, aPath);
        if (generateDeleteMappingMenu(treeId, aPath)) {
            deleteAllMappingsFromSelectedMenuItem.setEnabled(true);
            if (treeId == container.SOURCE_TREE) {
                deleteAllMappingsFromSelectedMenuItem.setText("Delete all Mappings from this Node");
            } else if (treeId == container.DESTINATION_TREE) {
                deleteAllMappingsFromSelectedMenuItem.setText("Delete all Mappings to this Node");
            }
        } else {
            deleteAllMappingsFromSelectedMenuItem.setEnabled(false);
        }
    }

    @SuppressWarnings("static-access")
	private void generateAddMappingMenuItem(int treeId, TreePath aPath) {
        if (treeId == container.SOURCE_TREE) {
            TreePath destPath = container.getDestTree().getSelectionPath();
            if (destPath != null) {
                addMappingMenuItem.setText("<html>Add mapping between<br>[" + aPath.getLastPathComponent().toString() + "]<br>and<br>[" + destPath.getLastPathComponent().toString()+"]</html>");
                addMappingMenuItem.setEnabled(true);
            }
            else addMappingMenuItem.setEnabled(false);
        } else if (treeId == container.DESTINATION_TREE) {
            TreePath sourcePath = container.getSourceTree().getSelectionPath();
            if (sourcePath != null) {
                addMappingMenuItem.setText("<html>Add mapping between<br>[" + sourcePath.getLastPathComponent().toString() + "]<br>and<br>[" + aPath.getLastPathComponent().toString()+"]</html>");
                addMappingMenuItem.setEnabled(true);
            }
            else addMappingMenuItem.setEnabled(false);
        }
    }

    /**
     * Generates {@code "Delete Specific Mapping" Menu} depending from the {@code treeId and  aPath} parameters.
     *
     * @param treeId An integer Indicating which tree {@code aPath}'s last node belongs too.
     * <ul>Valid IDs from an instance of {@link MappingsPanel} class are:
     * <li>SOURCE_TREE
     * <li>DESTINATION_TREE
     * </ul>
     * @param aPath An instance of {@code TreePath}
     * @return {@code false} if nothing was generated/added to the menu, {@code true} otherwise
     * @see #GeneratePopupMenu
     */
    private boolean generateDeleteMappingMenu(int treeId, TreePath aPath) {
        return generateMappingMenu(deleteMappingMenu,treeId,VisualComponentConnectionUtils.EXISTING_CONNECTIONS,aPath);
    }

    /**
     * Generates {@code "Cancel Adding Mapping" Menu} depending from the {@code treeId and  aPath} parameters.
     *
     * @param treeId An integer Indicating which tree {@code aPath}'s last node belongs too.
     * <ul>Valid IDs from an instance of {@link MappingsPanel} class are:
     * <li>SOURCE_TREE
     * <li>DESTINATION_TREE
     * </ul>
     * @param aPath An instance of {@code TreePath}
     * @return {@code false} if nothing was generated/added to the menu, {@code true} otherwise
     * @see #GeneratePopupMenu
     */
    private boolean generateCancelAddingMappingMenu(int treeId, TreePath aPath) {
        return generateMappingMenu(cancelAddingMappingMenu,treeId,VisualComponentConnectionUtils.FOR_ADDITION_CONNECTIONS,aPath);
    }

    /**
     * Generates {@link MappingMenuItem}s(from a set of {@link VisualComponentConnection}s in {@link MappingsPanel}
     * specified from {@code mappingsId}) and adds them to {@code menu} depending from
     * the {@code treeid and aPath} parameters.
     * @param menu An instance of {@code JMenu}
     * @param treeId An integer Indicating which tree {@code aPath}'s last node belongs too.
     * <ul>Valid IDs from an instance of {@link MappingsPanel} class are:
     * <li>SOURCE_TREE
     * <li>DESTINATION_TREE
     * </ul>
     * @param mappingsId An integer indicating which set of {@code VisualComponentConnection} components should be used
     * <ul>Valid IDs from {@link VisualComponentConnectionUtils} class are:
     * <li>ALL_CONNECTIONS
     * <li>EXISTING_AND_FOR_DELETION_CONNECTIONS
     * <li>EXISTING_AND_FOR_ADDITION_CONNECTIONS
     * <li>EXISTING_CONNECTIONS
     * <li>FOR_ADDITION_CONNECTIONS
     * <li>FOR_DELETION_CONNECTIONS
     * </ul>
     * @param aPath An instance of {@code TreePath}
     * @return {@code false} if nothing was generated/added to the menu, {@code true} otherwise
     * @see #GenerateCancelAddingMappingMenu
     * @see #GenerateDeleteMappingMenu
     */
    @SuppressWarnings("static-access")
	private boolean generateMappingMenu(JMenu menu, int treeId, int mappingsId, TreePath aPath){
        DefaultMutableTreeNode aNode = (DefaultMutableTreeNode) aPath.getLastPathComponent();

        ArrayList<VisualComponentConnection> foundConnections = null;
        if (treeId == container.SOURCE_TREE) {
            foundConnections = VisualComponentConnectionUtils.findConnectionsWith(container, mappingsId, aNode, null);
        } else if (treeId == container.DESTINATION_TREE) {
            foundConnections = VisualComponentConnectionUtils.findConnectionsWith(container, mappingsId, null, aNode);
        }

        if (!foundConnections.isEmpty()) {
            menu.setEnabled(true);

            for (int i = 0; i < foundConnections.size(); i++) {
                JMenuItem menuItem = new MappingMenuItem(
                        foundConnections.get(i),"<html>["+ foundConnections.get(i).getSourcePath().getLastPathComponent().toString() + "]<br>and<br>[" + foundConnections.get(i).getDestPath().getLastPathComponent().toString()+"]</html>");
                menuItem.addActionListener(new java.awt.event.ActionListener() {

                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        deleteSelectedMappingMenuItemActionPerfomed(evt);
                    }
                });
                menu.add(menuItem);
                menu.addSeparator();
            }
            return true;
        } else {
            menu.setEnabled(false);
            return false;
        }

    }
    
    private void addMappingMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
		TreePath destPath = container.getDestTree().getSelectionPath();
        TreePath sourcePath = container.getSourceTree().getSelectionPath();

        if ((sourcePath != null) && (destPath != null)){
        	ArrayList<VisualComponentConnection> foundConnections 
        		= VisualComponentConnectionUtils.findConnectionsWith(
        				container, 
        				VisualComponentConnectionUtils.ALL_CONNECTIONS,
	                    (DefaultMutableTreeNode) sourcePath.getLastPathComponent(),
	                    (DefaultMutableTreeNode) destPath.getLastPathComponent()
	        );

            //If mapping with sourcePath as source and destPath as dest not found
            if (foundConnections.isEmpty()) {
            	VisualComponentConnection mapping = container.createNewMapping(sourcePath, destPath);
				if(callbackOperations != null)
            		callbackOperations.addMapping(mapping);
            	else
	            	container.addToAddedMappings(mapping);
            	container.repaint();
            }
        }
        this.addMappingMenuItem.setEnabled(false);
    }

    private void deleteAllMappingsFromSelectedMenuItemActionPerformed(java.awt.event.ActionEvent evt) {
        JPopupMenu popup = (JPopupMenu) ((JMenuItem) evt.getSource()).getParent();
        JTree tree = (JTree) popup.getInvoker();
        this.deleteAllMappingsFromSelection(tree);
    }

    /**
     * Deletes all {@code VisualComponentConnection} objects with one endpoint to a TreeNode of {@code tree}
     * @param tree An instance of {@code JTree}
     */
    private void deleteAllMappingsFromSelection(JTree tree) {
        TreePath selectedPath = tree.getSelectionPath();

        ArrayList<VisualComponentConnection> foundConnections = null;
        if (tree.equals(container.getSourceTree())) {
            foundConnections = VisualComponentConnectionUtils.findConnectionsWith(container, VisualComponentConnectionUtils.ALL_CONNECTIONS, (DefaultMutableTreeNode) selectedPath.getLastPathComponent(), null);
        } else if (tree.equals(container.getDestTree())) {
            foundConnections = VisualComponentConnectionUtils.findConnectionsWith(container, VisualComponentConnectionUtils.ALL_CONNECTIONS, null, (DefaultMutableTreeNode) selectedPath.getLastPathComponent());
        }

        if(callbackOperations != null){
        	callbackOperations.deleteMappings(foundConnections);
        }
        else{
        	for (int i = 0; i < foundConnections.size(); i++) {
        		container.addToDeletedMappings(foundConnections.get(i));
        	}
        }
    }

    private void deleteAllMappingsActionPerformed(java.awt.event.ActionEvent evt) {
        int option = JOptionPane.showOptionDialog(this, "You're about to delete ALL existing mappings! This CANNOT be UNDONE! Are you sure?",
                "Deletion of all existing Mappings!", JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE, null, null, null);
        if (option == JOptionPane.OK_OPTION) {
            container.clearMappings();
            container.repaint();
        }
    }

    /**
     * Deletes the {@code VisualComponentConnection} which was selected from the {@code deletePopupMenu}
     * @param evt The {@code ActionEvent} that triggered the deletion
     */
    private void deleteSelectedMappingMenuItemActionPerfomed(java.awt.event.ActionEvent evt) {
        VisualComponentConnection mapping = ((MappingMenuItem) evt.getSource()).getMapping();
    	if(callbackOperations != null)
    		callbackOperations.deleteMapping(mapping);
    	else{
	        container.addToDeletedMappings(mapping);
    	}
    }

	/**
	 * @return the addMappingMenuItem
	 */
	public JMenuItem getAddMappingMenuItem() {
		return addMappingMenuItem;
	}

	/**
	 * @return the cancelAddingMappingMenu
	 */
	public JMenu getCancelAddingMappingMenu() {
		return cancelAddingMappingMenu;
	}

	/**
	 * @return the deleteMappingMenu
	 */
	public JMenu getDeleteMappingMenu() {
		return deleteMappingMenu;
	}

	/**
	 * @return the deleteAllMappingsMenuItem
	 */
	public JMenuItem getDeleteAllMappingsMenuItem() {
		return deleteAllMappingsMenuItem;
	}

	/**
	 * @return the deleteAllMappingsFromSelectedMenuItem
	 */
	public JMenuItem getDeleteAllMappingsFromSelectedMenuItem() {
		return deleteAllMappingsFromSelectedMenuItem;
	}
    
    
}
