/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.ow2.choreos.gui.interfaceMappingsVisualizer.listeners;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import org.ow2.choreos.gui.interfaceMappingsVisualizer.components.MappingsManagementPopupMenu;
import org.ow2.choreos.gui.interfaceMappingsVisualizer.components.MappingsPanel;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnection;
import org.ow2.choreos.gui.visualComponentConnection.VisualComponentConnectionUtils;

/**
 *
 * @author user
 */
public class MappingsPanelMouseListener extends MouseAdapter {

    private MappingsManagementPopupMenu popup;
    private MappingsPanel container;
	private InterfaceMappingsVisualizerListener callbackFunctions;

    public MappingsPanelMouseListener(InterfaceMappingsVisualizerListener callbackFunctions,MappingsPanel container) {
        this(callbackFunctions,null,container);
    }

    public MappingsPanelMouseListener(InterfaceMappingsVisualizerListener callbackFunctions,MappingsManagementPopupMenu popup, MappingsPanel container) {
        this.popup = popup;
        this.container = container;
        this.callbackFunctions = callbackFunctions;
    }

    @Override
    public void mousePressed(MouseEvent evt) {
        maybeShowPopup(evt);
    }

    @Override
    public void mouseReleased(MouseEvent evt) {
    	if(evt.getSource() == container.getDestTree()){
    		TreePath destPath = container.getDestTree().getSelectionPath();
            TreePath sourcePath = container.getSourceTree().getSelectionPath();

            if ((sourcePath != null) && (destPath != null)){
            	ArrayList<VisualComponentConnection> foundConnections 
            		= VisualComponentConnectionUtils.findConnectionsWith(
            				container, 
            				VisualComponentConnectionUtils.ALL_CONNECTIONS,
    	                    (DefaultMutableTreeNode) sourcePath.getLastPathComponent(),
    	                    (DefaultMutableTreeNode) destPath.getLastPathComponent()
    	        );

                //If mapping with sourcePath as source and destPath as dest not found
                if (foundConnections.isEmpty()) {
                	VisualComponentConnection mapping = container.createNewMapping(sourcePath, destPath);
    				if(callbackFunctions != null)
                		callbackFunctions.addMapping(mapping);
                	else
    	            	container.addToAddedMappings(mapping);
                	container.repaint();
                }
            }
    	}
        maybeShowPopup(evt);
        container.repaint();
    }

    private void maybeShowPopup(MouseEvent evt) {
        if (evt.isPopupTrigger() && popup != null) {
            this.popup.showPopupMenu((JTree) evt.getSource(), evt.getX(), evt.getY());
        }
    }
}

