package org.ow2.choreos.matchingProcess;

import java.util.List;

import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.gui.UserSettings;


/**
 * 
 * @author dathanas
 *
 */
public abstract class Matcher {


	//Variables.
	private double matchingConfidenceThreshold;//user-provided.


	protected String currentPhase, nextPhase;

	protected long currentPhaseDuration = 0, totalDuration = 0;

	protected MatcherStatistics matcherStatistics;

	protected List<Object> acceptedMatchings;//where the second Object is a 'Matching' object.


	protected int k;


	protected boolean interactive;

	protected String logFilePath;


	//Constructors.
	protected Matcher( UserSettings userSettings, String cCurrentPhase ){

		initVariables( userSettings, cCurrentPhase, null );
	}

	protected Matcher( UserSettings userSettings, String cCurrentPhase, String cLogFilePath ){

		initVariables( userSettings, cCurrentPhase, cLogFilePath );
	}

	private void initVariables( UserSettings userSettings, String cCurrentPhase, String cLogFilePath ){

		logFilePath = cLogFilePath;

		PrintMessages.resetLogFile( PrintMessages.matchingPrint, logFilePath );


		if( userSettings != null ){

			matchingConfidenceThreshold = userSettings.getMatchingConfidenceThreshold();

			k = userSettings.getTopK();

			interactive = userSettings.getInteractiveMatchingProcess();

			PrintMessages.stdPrintLn( PrintMessages.matchingPrint, "matchingConfidenceThreshold = " + matchingConfidenceThreshold + " - k = " + k );
		}


		currentPhase = cCurrentPhase;
	}


	//Setters.
	abstract public void match();

	abstract public void match( Object guiLabel, Object guiComponent );


	//Getters.
	String getCurrentPhase(){

		return currentPhase;
	}

	String getNextPhase(){

		return nextPhase;
	}

	MatcherStatistics getStatistics(){

		return matcherStatistics;
	}

	String getLogFilePath(){

		return logFilePath;
	}

	void openLogFile(){

		PrintMessages.openLogFile( PrintMessages.matchingPrint, logFilePath );
	}


	//Visualization.
	protected abstract Object visualize( Object guiLabel, Object guiProgressBar, String filePrint );
}