package org.ow2.choreos.matchingProcess;

import java.util.List;
import java.util.Map;

import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
public class MatcherStatistics {


	//Variables.
	private Map<Object, Map<Object, Object>> statisticKinds;//The 1st object is the currentPhase, the 2nd is the integer(counter) and the 3rd the 'String' description of the group of statistics.

	private Map<Object, Map<Object, List<Object>>> statistics;//The 1st object is the currentPhase, the 2nd is the statistic kinds and the 3rd the list of the different statistics.

	private Map<Object, Map<Object, Object>> visualizedStatistics;//The 1st corresponds to the integer (counter) of the different statistic kinds, the 2nd to the 'DefaultMutableTreeNode' root node. 


	//Setters.
	public void addStatisticKind( String currentPhase, Object statisticKind ){

		Map<Object, Object> statisticKindsOfPhase = MapGetter.getValueOfMapOfMap( currentPhase, statisticKinds );
		
		Integer statisticKindCounter = statisticKindsOfPhase != null ? statisticKindsOfPhase.size() : 0;

		statisticKindsOfPhase = MapInsertion.put( ++statisticKindCounter, statisticKind, statisticKindsOfPhase, true );

		statisticKinds = MapInsertion.putInMapOfMap( currentPhase, statisticKindsOfPhase, statisticKinds, true );
	}

	public void addStatistic( String currentPhase, Object statisticKind, String statisticKey, String statisticValue ){

		Map<Object, List<Object>> statisticKindsOfPhase = MapGetter.getValueOfMapOfMapOfList( currentPhase, statistics );

		List<Object> listOfStatistics = MapGetter.getValueOfMapOfList( statisticKind, statisticKindsOfPhase );


		Object[] statistic = new Object[] { statisticKey, statisticValue };

		listOfStatistics = ListInsertion.add( statistic, listOfStatistics );

		statisticKindsOfPhase = MapInsertion.putInMapOfList( statisticKind, listOfStatistics, statisticKindsOfPhase, true );

		statistics = MapInsertion.putInMapOfMapOfList( currentPhase, statisticKindsOfPhase, statistics, true );
	}

	public void addVisualizedStatistic( String currentPhase, Object statisticKind, DefaultMutableTreeNode visualizedStatistic ){

		Map<Object, Object> visualizedStatisticsOfPhase = MapGetter.getValueOfMapOfMap( currentPhase, visualizedStatistics );

		visualizedStatisticsOfPhase = MapInsertion.put( statisticKind, visualizedStatistic, visualizedStatisticsOfPhase, true );

		visualizedStatistics = MapInsertion.putInMapOfMap( currentPhase, visualizedStatisticsOfPhase, visualizedStatistics, true );
	}


	//Getters.
	public Object getStatisticKind( String currentPhase, Integer statisticKindCounter ){

		return MapGetter.getValue( statisticKindCounter, MapGetter.getValueOfMapOfMap( currentPhase, statisticKinds ) );
	}

	public Object[] getStatistic( String currentPhase, Object statisticKind, Integer statisticCounter ){

		List<Object> listOfStatistics = MapGetter.getValueOfMapOfList( statisticKind, MapGetter.getValueOfMapOfMapOfList( currentPhase, statistics ) ); 


		return listOfStatistics != null && statisticCounter < listOfStatistics.size() ? (Object[]) listOfStatistics.get( statisticCounter ) : null;
	}

	public Object getVisualizedStatistic( String currentPhase, Object statisticKind ){

		return MapGetter.getValue( statisticKind, MapGetter.getValueOfMapOfMap( currentPhase, visualizedStatistics ) );
	}
}
