package org.ow2.choreos.matchingProcess;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.schemaRepresentation.SchemaMatchingController;


/**
 * 
 * @author dathanas
 *
 */
public class MatchingController {


	//Variables.
	public final static String matchingConfidenceUserOptionLabel = "Matching confidence:";

	public final static String[] normalizedValues = new String[] { "0.0", "0.1", "0.2", "0.3", "0.4", "0.5", "0.6", "0.7", "0.8", "0.9", "1.0" };


	public final static String maximumNumberOfReturnedMatchingsUserOptionLabel = "Select the maximum number of returned matchings:";

	public final static String[] maximumNumberOfReturnedMatchingsUserOptions = new String[] { "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "All" };


	//Verifiers.
	public static boolean isMatcherObject( Object matcher ){

		return matcher != null && matcher instanceof Matcher;
	}


	//Getters.
	public static void getAlternativeUserOptions( String matcherKind, List<Object> optionLabels, Map<Object, Object[]> options ){

		if( SchemaMatchingController.isSchemaMatcherKind( matcherKind ) ) SchemaMatchingController.getAlternativeUserOptions( matcherKind, optionLabels, options );
	}

	public static String[] getMatcherKinds(){

		return SchemaMatchingController.getMatcherKinds();
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings ){

		if( SchemaMatchingController.isSchemaMatcherKind( matcherKind ) ) return SchemaMatchingController.newMatcher( matcherKind, userSettings );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent ){

		if( SchemaMatchingController.isSchemaMatcherKind( matcherKind ) ) return SchemaMatchingController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent, String printFilePath ){

		if( SchemaMatchingController.isSchemaMatcherKind( matcherKind ) ) return SchemaMatchingController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent, printFilePath );


		return null;
	}

	public static MatcherStatistics getStatistics( Object matcher ){

		if( isMatcherObject( matcher ) ) return ((Matcher) matcher).getStatistics();


		return null;
	}

	public static String getLogFilePath( Object matcher ){

		if( isMatcherObject( matcher ) ) return ((Matcher) matcher).getLogFilePath();


		return null;
	}

	public static void openLogFile( Object matcher ){

		if( isMatcherObject( matcher ) ) ((Matcher) matcher).openLogFile();
	}

	public static String getStartPhase( String matcherKind ){

		if( SchemaMatchingController.isSchemaMatcherKind( matcherKind ) ) return SchemaMatchingController.getStartPhase( matcherKind );


		return null;
	}

	public static String getCurrentPhase( Object matcher ){

		if( isMatcherObject( matcher ) ) return ((Matcher) matcher).getCurrentPhase();


		return null;
	}

	public static String getNextPhase( Object matcher ){

		if( isMatcherObject( matcher ) ) return ((Matcher) matcher).getNextPhase();


		return null;
	}


	//Setters.
	public static void match( Object matcher ) {

		if( isMatcherObject( matcher ) ) ((Matcher) matcher).match( );
	}

	public static void match( Object matcher, Object guiLabel, Object guiComponent ) {

		if( isMatcherObject( matcher ) ) ((Matcher) matcher).match( guiLabel, guiComponent );
	}
}
