package org.ow2.choreos.matchingProcess.schemaRepresentation.concreteElementIndexing;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
public class ConcreteElementsDataStructureController {


	//Variables.
	protected final static String list = "List of concrete elements", intervalTree = "Interval tree based on the scope of concrete elements";

	public final static String mapOfMapOfMap = "Map of map of map of concrete elements";

	private final static String[] dataStructureKinds = new String[]{ list, intervalTree };


	private final static String indexUserOptionLabel = "Indexing data structure:";

	private final static String typeOfIndexingDataStructureUserOptionLabel = "Select the type of the data structure for indexing concrete elements:";


	//Getters.
	public static void getAlternativeUserOptions( List<Object> userOptionLabels, Map<Object, Object[]> userOptions ){

		userOptionLabels = ListInsertion.add( indexUserOptionLabel, userOptionLabels );

		userOptionLabels = ListInsertion.add( typeOfIndexingDataStructureUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( typeOfIndexingDataStructureUserOptionLabel, dataStructureKinds, userOptions, false );
	}


	//Setters.
	@SuppressWarnings("unchecked")
	static Object add( String dataStructureKind, Object dataStructure, Object currentConcreteElementInASchema ){

		if( dataStructureKind != null ){

			if( dataStructureKind.equals( list ) ) return dataStructure != null ? addInList( currentConcreteElementInASchema, (List<Object>) dataStructure ) : addInList( currentConcreteElementInASchema, null );

			if( dataStructureKind.equals( mapOfMapOfMap ) ) return dataStructure != null ? addInMapOfMapOfMap( currentConcreteElementInASchema, (Map<Object, Object>) dataStructure ) : addInMapOfMapOfMap( currentConcreteElementInASchema, null );
		}


		return dataStructure;
	}

	private static List<Object> addInList( Object value, List<Object> list ){

		return ListInsertion.add( value, list );
	}

	@SuppressWarnings("unchecked")
	private static Map<Object, Object> addInMapOfMapOfMap( Object pairOfConcreteElementAndRightmostChildScopeRightEndpoint, Map<Object, Object> map ){//In a sense, this is the data structure: Map<Map<Object, Object>> e.g., <value, <key, value>>.

		Map<Object, Object> castedPairOfConcreteElementAndRightmostChildScopeRightEndpoint = pairOfConcreteElementAndRightmostChildScopeRightEndpoint != null ? (Map<Object, Object>) pairOfConcreteElementAndRightmostChildScopeRightEndpoint : null;

		Iterator<Object> i = castedPairOfConcreteElementAndRightmostChildScopeRightEndpoint != null && castedPairOfConcreteElementAndRightmostChildScopeRightEndpoint.keySet() != null ? castedPairOfConcreteElementAndRightmostChildScopeRightEndpoint.keySet().iterator() : null;

		Object concreteElement = i != null && i.hasNext() ? i.next() : null;

		Integer rightmostChildScopeRightEndpoint = (Integer) MapGetter.getValue( concreteElement, castedPairOfConcreteElementAndRightmostChildScopeRightEndpoint );


		Map<Object, Object> existingPairOfConcreteElementAndRightmostChildScopeRightEndpoints = null;

		if( MapGetter.exists( rightmostChildScopeRightEndpoint, map ) ) existingPairOfConcreteElementAndRightmostChildScopeRightEndpoints = (Map<Object, Object>) MapGetter.getValue( rightmostChildScopeRightEndpoint, map );

		existingPairOfConcreteElementAndRightmostChildScopeRightEndpoints = MapInsertion.put( concreteElement, pairOfConcreteElementAndRightmostChildScopeRightEndpoint, existingPairOfConcreteElementAndRightmostChildScopeRightEndpoints, false );

		map = MapInsertion.put( rightmostChildScopeRightEndpoint, existingPairOfConcreteElementAndRightmostChildScopeRightEndpoints, map, true );


		return map;
	}


	//Visualization.
	@SuppressWarnings("unchecked")
	protected static List<Object> visualize( String dataStructureKind, Object dataStructure, String logFilePath ){

		if( dataStructureKind != null ){

			if( dataStructureKind.equals( mapOfMapOfMap ) ) return visualize( (Map<Object, Object>) dataStructure, logFilePath );

			if( dataStructureKind.equals( list ) ) return visualize( (List<Object>) dataStructure, logFilePath );
		}


		return null;
	}

	@SuppressWarnings("unchecked")
	private static List<Object> visualize( Map<Object, Object> totalPairOfConcreteElementAndRightmostChildScopeRightEndpoints, String logFilePath ){

		boolean filePrint = logFilePath != null ? true : false;

		List<Object> concreteElementNodes = null;


		Iterator<Object> i = totalPairOfConcreteElementAndRightmostChildScopeRightEndpoints != null && totalPairOfConcreteElementAndRightmostChildScopeRightEndpoints.keySet() != null ? totalPairOfConcreteElementAndRightmostChildScopeRightEndpoints.keySet().iterator() : null;

		while( i != null && i.hasNext() ){

			int rightmostChildScopeRightEndpoint = (Integer) i.next();

			Map<Object, Object> pairOfConcreteElementAndRightmostChildScopeRightEndpoints = (Map<Object, Object>) MapGetter.getValue( rightmostChildScopeRightEndpoint, totalPairOfConcreteElementAndRightmostChildScopeRightEndpoints );


			Iterator<Object> j = pairOfConcreteElementAndRightmostChildScopeRightEndpoints != null && pairOfConcreteElementAndRightmostChildScopeRightEndpoints.keySet() != null ? pairOfConcreteElementAndRightmostChildScopeRightEndpoints.keySet().iterator() : null;

			while( j != null && j.hasNext() ){

				Object concreteElement = j.next();


				Object retValue = SchemaRepresentationController.visualize( concreteElement, rightmostChildScopeRightEndpoint, logFilePath );

				if( ! filePrint ) concreteElementNodes = ListInsertion.add( retValue, concreteElementNodes );
			}
		}


		return concreteElementNodes;
	}

	private static List<Object> visualize( List<Object> concreteElements, String logFilePath ){

		boolean filePrint = logFilePath != null ? true : false;

		List<Object> concreteElementNodes = null;


		for( int i = 0; concreteElements != null && i < concreteElements.size(); ++i ){

			Object concreteElement = concreteElements.get( i );


			Object retValue = SchemaRepresentationController.visualize( concreteElement, logFilePath );

			if( ! filePrint ) concreteElementNodes = ListInsertion.add( retValue, concreteElementNodes );
		}


		return concreteElementNodes;
	}
}
