package org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listInsertion.ListInsertion;
import org.ow2.choreos.dataStructures.map.mapInsertion.MapInsertion;
import org.ow2.choreos.gui.UserSettings;
import org.ow2.choreos.matchingProcess.Matcher;
import org.ow2.choreos.matchingProcess.MatchingController;
import org.ow2.choreos.matchingProcess.schemaRepresentation.SchemaMatchingController;
import org.ow2.choreos.matchingProcess.schemaRepresentation.patternBasedMatching.holisticMatching.HolisticPatternBasedSchemaMatcherController;


/**
 * 
 * @author dathanas
 *
 */
public class PatternBasedSchemaMatchingController {


	//Variables.
	private final static String structuralPatternConfidenceUserOptionLabel = "Structural-pattern confidence:";


	private final static String confidenceOfPatternInstantiationsInASchemaUserOptionLabel = "Select the function for aggregating the confidence of the instantiations of a pattern in a pattern schema:";

	private final static String[] confidenceOfPatternInstantiationsInASchemaUserOptions = new String[] { "Maximum", "Average" };


	private final static String confidenceOfPatternInstantiationsInAllSchemasUserOptionLabel = "Select the function for aggregating the confidence of the instantiations of a pattern in all pattern schemas:";

	private final static String[] confidenceOfPatternInstantiationsInAllSchemasUserOptions = new String[] { "Product", "Average" };


	private final static String aggregatingDensityAndCoverageOfAPatternUserOptionLabel = "Select the function for aggregating the density and coverage of the instantiations of a pattern in all pattern schemas:";

	private final static String[] aggregatingDensityAndCoverageOfAPatternUserOptions = new String[] { "Product", "Average" };


	final static String thresholdOfClosenessDensityValueUserOptionLabel = "Select threshold for the maximum closeness degree to the maximum density value for considering other values high:";

	private final static String[] thresholdOfClosenessDensityValueUserOptions = MatchingController.normalizedValues;


	private final static String thresholdOfPatternConfidenceUserOptionLabel = "Select threshold for pattern-confidence metric:";

	private final static String[] thresholdOfPatternConfidenceUserOptions = MatchingController.normalizedValues;


	private final static String matchingPatternInstantiationsUserOptionLabel = "Matching pattern instantiations:";


	private final static String preservationOfSchemasStructureUserOptionLabel = "Select the matching property with respect to the preservation of the schemas structure:";

	private final static String[] preservationOfSchemasStructureUserOptions = new String[] { "Syntax-conformance property", "Structure-preservation property" };


	private final static String cartesianProductOfSiblingElementsUserOption = "Calculating the cartesian product of elements";

	public final static String greedilyLinkCorrespondingElementsUserOption = "Calculating greedily a combination of elements";

	public final static String cartesianProductAndGredyCombinationOfElementsUserOption = "Calculating the cartesian product of a low number of elements";

	public final static String linkCorrespondingElementsUserOption = "Link elements in corresponding structural positions";

	public final static String formingMultiparititeCorrespondencesUserOptionLabel = "Select the way of forming multiparitite correspondences:";

	private final static String[] formingMultiparititeCorrespondencesUserOptions = new String[] { cartesianProductOfSiblingElementsUserOption, greedilyLinkCorrespondingElementsUserOption, cartesianProductAndGredyCombinationOfElementsUserOption, linkCorrespondingElementsUserOption };


	//Verifiers.
	public static boolean isPatternBasedSchemaMatcherKind( String matcherKind ){

		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) return true;


		return false;
	}


	//Getters.
	public static String[] getMatcherKinds(){

		return HolisticPatternBasedSchemaMatcherController.getMatcherKinds();
	}

	public static void getAlternativeUserOptions( String matcherKind, List<Object> userOptionLabels, Map<Object, Object[]> userOptions ){

		userOptionLabels = ListInsertion.add( structuralPatternConfidenceUserOptionLabel, userOptionLabels );


		userOptionLabels = ListInsertion.add( confidenceOfPatternInstantiationsInASchemaUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( confidenceOfPatternInstantiationsInASchemaUserOptionLabel, confidenceOfPatternInstantiationsInASchemaUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( confidenceOfPatternInstantiationsInAllSchemasUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( confidenceOfPatternInstantiationsInAllSchemasUserOptionLabel, confidenceOfPatternInstantiationsInAllSchemasUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( aggregatingDensityAndCoverageOfAPatternUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( aggregatingDensityAndCoverageOfAPatternUserOptionLabel, aggregatingDensityAndCoverageOfAPatternUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( thresholdOfClosenessDensityValueUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( thresholdOfClosenessDensityValueUserOptionLabel, thresholdOfClosenessDensityValueUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( HolisticPatternBasedSchemaMatcherController.minimumFrequencyValueUserOptionLabel, userOptionLabels );


		userOptionLabels = ListInsertion.add( thresholdOfPatternConfidenceUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( thresholdOfPatternConfidenceUserOptionLabel, thresholdOfPatternConfidenceUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( SchemaMatchingController.thresholdOfCorrespondenceConfidenceUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( SchemaMatchingController.thresholdOfCorrespondenceConfidenceUserOptionLabel, SchemaMatchingController.thresholdOfCorrespondenceConfidenceUserOptions, userOptions, false );


		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) HolisticPatternBasedSchemaMatcherController.getAlternativeUserOptions( matcherKind, userOptionLabels, userOptions );


		userOptionLabels = ListInsertion.add( matchingPatternInstantiationsUserOptionLabel, userOptionLabels );


		userOptionLabels = ListInsertion.add( preservationOfSchemasStructureUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( preservationOfSchemasStructureUserOptionLabel, preservationOfSchemasStructureUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( formingMultiparititeCorrespondencesUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( formingMultiparititeCorrespondencesUserOptionLabel, formingMultiparititeCorrespondencesUserOptions, userOptions, false );


		userOptionLabels = ListInsertion.add( MatchingController.maximumNumberOfReturnedMatchingsUserOptionLabel, userOptionLabels );

		userOptions = MapInsertion.putInMapOfArrays( MatchingController.maximumNumberOfReturnedMatchingsUserOptionLabel, MatchingController.maximumNumberOfReturnedMatchingsUserOptions, userOptions, false );
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings ){

		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) return HolisticPatternBasedSchemaMatcherController.newMatcher( matcherKind, userSettings );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent ){

		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) return HolisticPatternBasedSchemaMatcherController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent );


		return null;
	}

	public static Matcher newMatcher( String matcherKind, UserSettings userSettings, Object guiLabel, Object guiComponent, String printFilePath ){

		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) return HolisticPatternBasedSchemaMatcherController.newMatcher( matcherKind, userSettings, guiLabel, guiComponent, printFilePath );


		return null;
	}

	public static String getStartPhase( String matcherKind ){

		if( HolisticPatternBasedSchemaMatcherController.isHolisticSchemaMatcherKind( matcherKind ) ) return HolisticPatternBasedSchemaMatcherController.getStartPhase( matcherKind );


		return null;
	}
}
