package org.ow2.choreos.parser.freeTextDocuments;

import java.util.ArrayList;
import java.util.List;


public class Tokenizer{


	public static ArrayList<String> Tokenize(String phrase, char separator, int numOfTokens){

		ArrayList<String> terms = new ArrayList<String>();

		for(int i = 0; i < numOfTokens; ++i){
			int pos = findNextTerm(phrase, separator);
			String term = phrase.substring(0, pos);
			terms.add(term);
			if(pos + 1 <= phrase.length()) phrase = phrase.substring(pos + 1, phrase.length());
		}

		return terms;
	}

	static ArrayList<String> Tokenize( String phrase, String starterOfLine, char separator){//This function reads a line by firstly removing the first letter!

		ArrayList<String> terms = new ArrayList<String>();

		phrase = phrase.substring( 1, phrase.length() );

		int pos = -1;

		do{
			pos = findNextTerm(phrase, separator);
			if( pos != -1 ){
				String term = phrase.substring(0, pos);
				terms.add(term);
				phrase = phrase.substring(pos + 1, phrase.length());
			}

			else terms.add( phrase );//This is the last term!

		} while( pos != -1 );

		return terms;
	}

	public static List<String> tokenize( String phrase, char separator ){//This function reads a line!

		ArrayList<String> terms = new ArrayList<String>();

		int pos = -1;

		do{
			pos = findNextTerm(phrase, separator);

			if( pos != -1 ){
				String term = phrase.substring(0, pos);
				terms.add(term);
				phrase = phrase.substring(pos + 1, phrase.length());
			}

			else terms.add( phrase );//This is the last term!

		} while( pos != -1 );


		return terms;
	}

	private static int findNextTerm(String phrase, char separator){

		for(int i = 0; phrase != null && i < phrase.length(); ++i) if(phrase.charAt(i) == separator) return i;

		return -1;
	}

	public static String findExtension( String phrase ){

		if( phrase == null ) return phrase;

		int pos1 = phrase.lastIndexOf( "." );
		int pos2 = phrase.lastIndexOf( "?" );


		if(pos1 > 0 && pos2 > 0 && pos1 > pos2) return phrase.substring(pos1 + 1, phrase.length());

		else if(pos1 > 0 && pos2 > 0 && pos1 < pos2) return phrase.substring(pos2 + 1, phrase.length());

		else if(pos1 > 0 && pos2 < 0) return phrase.substring(pos1 + 1, phrase.length());

		else if(pos1 < 0 && pos2 > 0) return phrase.substring(pos2 + 1, phrase.length());


		return phrase;
	}

	public static String findExtensionAfterSpace(String phrase){

		if( phrase == null ) return phrase;


		int pos = phrase.lastIndexOf(" ");

		if( pos > 0 ) return phrase.substring( pos + 1, phrase.length() );


		return phrase;
	}

	static String findLastTerm( String phrase ){

		if( phrase == null ) return phrase;

		int pos1 = phrase.lastIndexOf( "\\" );

		int pos2 = phrase.lastIndexOf( "/" );


		if( pos1 > 0 && pos2 > 0 && pos1 > pos2 ) return phrase.substring( pos1 + 1, phrase.length() );

		else if( pos1 > 0 && pos2 > 0 && pos1 < pos2 ) return phrase.substring( pos2 + 1, phrase.length() );

		else if( pos1 > 0 && pos2 < 0 ) return phrase.substring( pos1 + 1, phrase.length() );

		else if( pos1 < 0 && pos2 > 0 ) return phrase.substring( pos2 + 1, phrase.length() );


		return phrase;
	}

	public static String getPrefix( String name, String character ){

		if( name != null ){

			int semicolPos = name.lastIndexOf( character );

			if( semicolPos >= 0 ) return name.substring( 0, semicolPos );
		}

		return "";
	}

	public static String getSuffix( String name, String character ){

		if( name != null ){

			int semicolPos = name.lastIndexOf( character );

			if( semicolPos >= 0 ) return name.substring( semicolPos + 1 );
		}

		return name;
	}
}
