package org.ow2.choreos.parser.functionalDocuments.schema;

import java.util.List;
import java.util.Map;

import org.omg.CORBA.StringHolder;


public interface SchemaParser{


	/**
	 * 
	 * @param ref2DocOfFuncProperties
	 * @return
	 * 
	 * This method accepts as input the URI of a schema document and returns a Map (e.g., Hashtable) of the schemas that it contains included the imported.
	 * Even if the imported schemas form a hierarchical structure, this function keeps a flat 'Map' structure in order to keep them only once (losing the structure of the imported schemas).
	 * The key 'String' in this map is the URI of the document in which the schema is defined.
	 */
	public void parse( String ref2DocOfSchemas, String schemaRepresentationModel, List<Object> inlineSchemas );//The last parameter is in-out.
	public void parse( String ref2DocOfSchemas, String schemaRepresentationModel, List<Object> inlineSchemas, Map<String, String> globalNamespaceQualifiers, StringHolder docTargetNamespace );//The last three parameters are in-out.
}
