package org.ow2.choreos.parser.functionalDocuments.service.sawsdl.v1.ibm;

import org.ow2.choreos.parser.functionalDocuments.service.wsdl.WSDLParser;
import org.ow2.choreos.serviceRepresentation.functional.DocOfFuncProperties;

import java.io.File;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.wsdl.Binding;
import javax.wsdl.Input;
import javax.wsdl.Operation;
import javax.wsdl.Output;
import javax.wsdl.Part;
import javax.wsdl.Port;
import javax.wsdl.PortType;
import javax.wsdl.Service;
import javax.wsdl.WSDLException;
import javax.xml.namespace.QName;

import edu.uga.cs.lsdis.sawsdl.util.SAWSDLUtility;
import edu.uga.cs.lsdis.sawsdl.*;

import javax.xml.namespace.QName;

import org.w3c.dom.Element;

import java.util.Set;

import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.parser.functionalDocuments.service.wsdl.WSDLParser;
import org.ow2.choreos.serviceRepresentation.functional.DocOfFuncProperties;
import org.ow2.choreos.serviceRepresentation.functional.FunctionalServiceRepresentationController;
import org.ow2.choreos.serviceRepresentation.functional.Message;
import org.ow2.choreos.serviceRepresentation.functional.MessageType;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInstance;
import org.ow2.choreos.serviceRepresentation.functional.ServiceInterface;
import org.ow2.choreos.serviceRepresentation.functional.ServiceType;

import com.ibm.wsdl.extensions.http.HTTPAddressImpl;
import com.ibm.wsdl.extensions.soap.SOAPAddressImpl;
import com.ibm.wsdl.extensions.soap12.SOAP12AddressImpl;

import edu.uga.cs.lsdis.sawsdl.Definition;
import edu.uga.cs.lsdis.sawsdl.ModelReferenceExtensible;
import edu.uga.cs.lsdis.sawsdl.util.SAWSDLUtility;

public class IBMSAWSDLv1Parser extends WSDLParser {


	//Overridden functions.
	public DocOfFuncProperties parse( DocOfFuncProperties docOfFuncProperties ){
		try{
			
			System.setProperty("javax.wsdl.factory.WSDLFactory", "edu.uga.cs.lsdis.sawsdl.impl.factory.WSDLFactoryImpl");
			File file=new File(docOfFuncProperties.getRef2DocOfFuncProperties());
			Definition definition = SAWSDLUtility.getDefinitionFromFile(file);
			
			Element definitionDocumentationElement = definition.getDocumentationElement();
			
			if(definitionDocumentationElement!= null){
				
					String definitionDocumentation = definitionDocumentationElement.getTextContent();
					System.out.println("Definition Documentation: "+definitionDocumentation);
			}
			
			Map definitonModel = definition.getExtensionAttributes();
			
            for (Object modelKey : definitonModel.keySet()){
            	
            	//System.out.println("definitonModel ->" + definitonModel.toString() );
            	System.out.println("definitonModelReference: "+" http:"+(definitonModel.toString()).split("=")[1].split("}")[1]);
            }
			
			Map mapServices = definition.getAllServices();
			Iterator serviceIterator = mapServices.values().iterator();

			while( serviceIterator.hasNext() ){
				
				Service service = (Service) serviceIterator.next();
				//System.out.println("\t Service = " + service.getQName());
				
				Element serviceDocumentationElement = service.getDocumentationElement();
				
				if(serviceDocumentationElement!= null){
					
						String serviceDocumentation = serviceDocumentationElement.getTextContent();
						System.out.println("  Service Documentation: "+serviceDocumentation);
				}
				
				//gia WSDL
				//ServiceType serviceType = new ServiceType( getSuffix(service.getQName().toString()), "WS", "WSDLv1" );//TODO: What about the prefix of a service?
				
				//gia SAWSDL
				ServiceType serviceType = new ServiceType( getSuffix(service.getQName().toString()), "WS"/*???*/, "SAWSDLv1" );//TODO: What about the prefix of a service?
				//System.out.println("  Service Name: "+getSuffix(service.getQName().toString()));
				
				Map mapPorts = service.getPorts();
				Iterator portIterator = mapPorts.values().iterator();

				while( portIterator.hasNext() ){

					Port port = (Port) portIterator.next();
					//System.out.println("\t port = " + port.getName());
					
					Element portDocumentationElement = port.getDocumentationElement();
					
					if(portDocumentationElement!= null){
						
							String portDocumentation = portDocumentationElement.getTextContent();
							System.out.println("Port Documentation: "+portDocumentation);
					}
					
					String uri = getURI(port); //<"protocol":address location=...
					//System.out.println("\t uri = " + uri);
					
					String protocol = getProtocol(port);
					//System.out.println("\t protocol = " + protocol);
					
					Binding binding = port.getBinding(); PrintMessages.print( PrintMessages.wsdlParserPrint, "binding = " + binding.getQName() );
					//System.out.println("\t binding = " + binding.getQName());
					
					Element bindingDocumentationElement = binding.getDocumentationElement();
					
					if(bindingDocumentationElement!= null){
						
							String bindingDocumentation = bindingDocumentationElement.getTextContent();
							System.out.println("Binding Documentation: "+bindingDocumentation);
					}
					
					PortType portType = binding.getPortType(); PrintMessages.print( PrintMessages.wsdlParserPrint, "portType = " + portType.getQName() );
				
					Map portTypes = definition.getPortTypes();
					for (Object key:portTypes.keySet()){
					
						PortType semanticPortType = definition.getSemanticPortType((QName)key);
						
						if(portType.getQName().toString().compareTo(semanticPortType.getQName().toString())==0){
												
							Element semanticPortTypeDocumentationElement = semanticPortType.getDocumentationElement();
						
							if(semanticPortTypeDocumentationElement!= null){
							
								String semanticPortTypeDocumentation = semanticPortTypeDocumentationElement.getTextContent();
								System.out.println("Port Type Documentation: "+semanticPortTypeDocumentation);
							}
							
							Map portTypeModel = semanticPortType.getExtensionAttributes();
				            for (Object modelKey : portTypeModel.keySet()){
				            	  
				            	//System.out.println("portTypeModel ->" + portTypeModel.toString() );
				            	System.out.println("portTypeModelReference: "+" http:"+(portTypeModel.toString()).split("=")[1].split("}")[1]);
				            }
							
							ServiceInterface serviceInterface = serviceType.exist( getSuffix( portType.getQName().toString() ) );//TODO: What about the prefix of a portType?
						
							if( serviceInterface != null ){//The interface exists!

								ServiceInstance interfaceInstance = new ServiceInstance( getSuffix(port.getName().toString()), protocol, uri );//TODO: What about the prefix of a port?

								serviceInterface.addServiceInstance( interfaceInstance );
							}
						
							else{//The interface does not exist!
								
								serviceInterface = new ServiceInterface( getSuffix( portType.getQName().toString() ) );//TODO: What about the prefix of a portType?
															 	
							 	List operations = portType.getOperations();
							 	Iterator opIterator = operations.iterator();

							 	while( opIterator.hasNext() ){
							 		
							 		Operation operation = (Operation) opIterator.next();
							 		//System.out.println("\t\t operation = " + operation.getName());
							 		
							 		Map messages = definition.getMessages();
							        for (Object messagesKey:messages.keySet()){
							        	edu.uga.cs.lsdis.sawsdl.Message semanticMessage = definition.getSemanticMessage((QName)messagesKey);

							            //System.out.println("Message QName ->" + semanticMessage.getQName());
							            
							           
							            Map parts = semanticMessage.getParts();

							            for (Object partKey : parts.keySet()) {
							                Part semanticPart = semanticMessage.getSemanticPart((String) partKey);
							                System.out.println("part ->" + semanticPart);
							                
							                Map partModel = semanticPart.getExtensionAttributes();
							    			
							                for (Object modelKey : partModel.keySet()){
							                	
							                	//System.out.println("partModel ->" + partModel.toString() );
							                	System.out.println("partModelReference: "+" http:"+(partModel.toString()).split("=")[1].split("}")[1]);
							                }
							  

							                              
							          /*      
							                Element test =semanticPart.getDocumentationElement();
							                if(test!=null){
							                	String doc=test.getTextContent();
							                	
							                	System.out.println(test.getNodeName()+"         documentation: "+doc);*/
							                }
							        }
						                
						                //*****************


							 		Input input = operation.getInput();
							 		javax.wsdl.Message inMsg = input.getMessage();
							 		Message inputMessage = parseMessage( inMsg );
							 		

							 		Output output = operation.getOutput();
							 		javax.wsdl.Message outMsg = output.getMessage();
							 		Message outputMessage = parseMessage( outMsg );
							 		
							 		

							 		serviceInterface.add( new org.ow2.choreos.serviceRepresentation.functional.Operation( operation.getName().toString(), inputMessage, outputMessage ) );
							 	}

							 	ServiceInstance interfaceInstance = new ServiceInstance( getSuffix(port.getName().toString()), protocol, uri );//TODO: What about the prefix of a port?
						
							 	serviceInterface.addServiceInstance( interfaceInstance );

							 	serviceType.add( serviceInterface );
							}
						}
					}
				}

				docOfFuncProperties.add( serviceType );
			}
		}
		

		catch( WSDLException e ){ docOfFuncProperties = (DocOfFuncProperties) FunctionalServiceRepresentationController.getErrorDocOfFuncProperties( docOfFuncProperties.getRef2DocOfFuncProperties(), "The document '" + ( (DocOfFuncProperties) docOfFuncProperties).getRef2DocOfFuncProperties() + "' is NOT specified in the WSDLv1.1 language" + "\n(" + e.getMessage() + ")" );}


		return docOfFuncProperties;
	}


	//Concrete functions.
	@SuppressWarnings("unchecked")
	private Message parseMessage( javax.wsdl.Message msg ){

		Message myMsg = null;

		if( msg != null ){

			//System.out.println("\t\t\t message = " + msg.getQName());

			Map mapPart = msg.getParts();//Parts
			Iterator partIterator = mapPart.values().iterator();

			myMsg = new Message( getSuffix( msg.getQName().toString() ) );//TODO: What about the prefix of a message?

			while( partIterator.hasNext() ){

				Part part = (Part) partIterator.next();

				MessageType messageType = instantiateMessageType( part );

				myMsg.add( messageType );
			}
		}

		return myMsg;
	}

	private MessageType instantiateMessageType( Part part ){

		QName referencedType = part.getTypeName();


		Map<String, String> tagAttributes = new Hashtable<String, String>();

		String name = part.getName().toString();

		tagAttributes.put( "name", name );


		if( referencedType != null ){

			String type = referencedType.getNamespaceURI() != null && ! referencedType.getNamespaceURI().isEmpty() ? referencedType.getNamespaceURI() + ":" + referencedType.getLocalPart() : referencedType.getLocalPart();

			tagAttributes.put( "type", type );
		}

		else{

			String element = part.getElementName().getNamespaceURI() != null && ! part.getElementName().getNamespaceURI().isEmpty() ? part.getElementName().getNamespaceURI() + ":" + part.getElementName().getLocalPart() : part.getElementName().getLocalPart();

			tagAttributes.put( "element", element );
		}


		return new MessageType( tagAttributes );
	}

	@SuppressWarnings("unchecked")
	private String getURI( Port port ){

		String uri = "";

		List elements = port.getExtensibilityElements();

		for( int i = 0; elements != null && i < elements.size(); ++i ){

			if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals( "com.ibm.wsdl.extensions.soap.SOAPAddressImpl" ) ) uri = ((SOAPAddressImpl) port.getExtensibilityElements().get(i)).getLocationURI();

			else if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals( "com.ibm.wsdl.extensions.soap12.SOAP12AddressImpl" ) ) uri = ((SOAP12AddressImpl) port.getExtensibilityElements().get(i)).getLocationURI();

			else if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals( "com.ibm.wsdl.extensions.http.HTTPAddressImpl" ) ) uri = ((HTTPAddressImpl) port.getExtensibilityElements().get(i)).getLocationURI();
		}

		

		return uri;
	}

	@SuppressWarnings("unchecked")
	private String getProtocol( Port port ){

		String protocol = "";

		List elements = port.getExtensibilityElements();


		for( int i = 0; elements != null && i < elements.size(); ++i ){

			if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals("com.ibm.wsdl.extensions.soap.SOAPAddressImpl") ) protocol = "soap";

			else if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals("com.ibm.wsdl.extensions.soap12.SOAP12AddressImpl") ) protocol = "soap12";

			else if( port.getExtensibilityElements().get(i).getClass().getName().toString().equals("com.ibm.wsdl.extensions.http.HTTPAddressImpl") ) protocol = "http";
		}


		return protocol;
	}

	protected String getPrefix( String name ){

		int semicolPos1 = name.lastIndexOf( "}" );

		int semicolPos2 = name.lastIndexOf( ":" );


		if( semicolPos1 >= 0 || semicolPos2 >= 0 ){

			if( semicolPos1 >  semicolPos2 ) return name.substring( 0, semicolPos1 + 1 );

			else return name.substring( 0, semicolPos2 );
		}

		return "";
	}

	protected String getSuffix( String name ){

		String newName = name;

		int semicolPos = newName.lastIndexOf( "}" );

		if( semicolPos >= 0 ) newName = newName.substring(semicolPos + 1);


		semicolPos = newName.lastIndexOf( ":" );

		if( semicolPos >= 0 ) newName = newName.substring(semicolPos + 1);


		return newName;
	}
}

