package org.ow2.choreos.parser.nonFunctionalDocuments.text;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.ow2.choreos.parser.freeTextDocuments.TxtParser;
import org.ow2.choreos.serviceRepresentation.nonFunctional.DocOfNonFuncProperties;
import org.ow2.choreos.serviceRepresentation.nonFunctional.NonFuncDescription;


public class QoSParser {


	//Methods.
	public static void parse( String ref2Source, DocOfNonFuncProperties docOfNonFuncProperties ){

		List<ArrayList<String>> allTerms = TxtParser.parse( docOfNonFuncProperties.getRef2DocOfNonFuncProperties(), true, "#", ',');

		if( allTerms == null ){

			docOfNonFuncProperties.setConstraintViolation("Non-functional document error.");

			return;
		}

		setPropertiesAndDomains( docOfNonFuncProperties, allTerms );


		allTerms = TxtParser.parse( docOfNonFuncProperties.getRef2DocOfNonFuncProperties(), false, "#", ',');

		if( allTerms == null ){

			docOfNonFuncProperties.setConstraintViolation("Non-functional document error.");

			return;
		}

		setPropertyValues( ref2Source, docOfNonFuncProperties, allTerms );
	}

	private static void setPropertiesAndDomains( DocOfNonFuncProperties docOfNonFuncProperties, List<ArrayList<String>> allTerms ){

		for( int i = 0; i < allTerms.size(); ++i ){

			ArrayList<String> domains = new ArrayList<String>();

			for( int j = 1; j < allTerms.get(i).size(); ++j ) domains.add( allTerms.get(i).get(j) );

			docOfNonFuncProperties.addProperty( allTerms.get(i).get(0), domains);
		}
	}

	private static void setPropertyValues( String ref2Source, DocOfNonFuncProperties docOfNonFuncProperties, List<ArrayList<String>> allTerms ){

		for( int i = 0; allTerms != null && i < allTerms.size(); ++i ){

			if( allTerms.get(i) != null ){

				String serviceInstance = allTerms.get(i).get(allTerms.get(i).size() - 3 );

				String serviceType = allTerms.get(i).get(allTerms.get(i).size() - 2 );

				File source = new File( allTerms.get(i).get( allTerms.get(i).size() - 1 ) );//ref2DocOfFuncProperties

				String ref2DocOfFuncProperties = source.getAbsolutePath();

				NonFuncDescription nonFuncDescription = new NonFuncDescription( ref2Source, ref2DocOfFuncProperties, serviceType, serviceInstance );

				for( int j = 0; docOfNonFuncProperties != null && j < docOfNonFuncProperties.getNumOfProperties(); ++j ) nonFuncDescription.addPropertyAndValue( docOfNonFuncProperties.getProperty(j), Double.valueOf( allTerms.get(i).get(j) ) );

				docOfNonFuncProperties.addNonFuncDescription( nonFuncDescription );
			}
		}
	}
}
