package org.ow2.choreos.queryEngineFacade;

import java.util.List;
import org.ow2.choreos.serviceRepresentation.functional.Operation;

/**
 * Contains a list of {@link org.ow2.choreos.serviceRepresentation.functional.Operation} objects.
 * 
 * @author pilios
 *
 */
public class OperationsList {

	private List<Operation> operationList;
	
	/**
	 * Creates an OperationsList object
	 * 
	 * @param operationList A list of operations
	 */
	public OperationsList(List<Operation> operationList){
		this.operationList = operationList;
	}
	
	/**
	 * <b>Special use:</b> information exchange over web.Should not be used for other purposes.
	 */
	public OperationsList(){
		
	}
	
	/**
	 * Returns the list of Operation objects.
	 * @return The list of Operation objects.
	 */
	public List<Operation> getOperationList(){
		return operationList;
	}
	
	/**
	 * <b>Special use:</b> information exchange over web.Should not be used for other purposes.
	 * Sets the list of operations.
	 * 
	 * @param operationList
	 */
	public void setOperationList(List<Operation> operationList){
		this.operationList = operationList;
	}
}
