package org.ow2.choreos.schemaRepresentation.schemaTagsTransformation;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listManipulation.ListTransformations;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.parser.freeTextDocuments.Tokenizer;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.XMLBuiltInTypes;


public class SchemaTags2JavaClassesTransformation {


	public static String[] transform( List<Map<String, String>> path ){

		List<String> listTransformedPath = null;


		for( int i = 0; path != null && i < path.size(); ++i ){

			if( listTransformedPath == null ) listTransformedPath = new ArrayList<String>();
			

			String name = (String) MapGetter.getValueByStringKey( "name", path.get( i ) );

			String referencedComponent = MapGetter.getStringValueByCandidateKeysLowerCase( ReferencedComponent.typeKinds, path.get( i ) );

			String referencedComponentSuffix = Tokenizer.getSuffix( referencedComponent, ":" );

			if( path.size() == 1 || i < path.size() - 1 ){

				if( name != null && ! name.isEmpty() && ( referencedComponentSuffix == null || ( referencedComponentSuffix != null && referencedComponentSuffix.isEmpty() ) ) )

					listTransformedPath.add( name );
			}

			else{

				String msg = "";

				if( name != null && ! name.isEmpty() ) msg = name;

				if( XMLBuiltInTypes.isBuiltInType( referencedComponentSuffix ) ) msg += "," + XMLBuiltInTypes.transformToJavaBuiltInType( referencedComponentSuffix );


				if( ! msg.equals( "" ) ) listTransformedPath.add( msg );
			}
		}


		return ListTransformations.convert2Array( listTransformedPath );
	}
}
