package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class ComponentContent {


	//Variables.
	private static Map<String, Boolean> validContent = new Hashtable<String, Boolean>() { {//In this Map, the 1st tagName can contain the 2nd tagName. The tagNames have been separated by the plus (+) symbol.

		put( ComponentTagNames.attributeTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.attributeTagName + "+" + ComponentTagNames.simpleTypeTagName, true );

		put( ComponentTagNames.elementTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.elementTagName + "+" + ComponentTagNames.simpleTypeTagName, true );
		put( ComponentTagNames.elementTagName + "+" + ComponentTagNames.complexTypeTagName, true );
		put( ComponentTagNames.elementTagName + "+" + ComponentTagNames.uniqueTagName, true );
		put( ComponentTagNames.elementTagName + "+" + ComponentTagNames.keyTagName, true );
		put( ComponentTagNames.elementTagName + "+" + ComponentTagNames.keyRefTagName, true );

		put( ComponentTagNames.complexTypeTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + StructureTagNames.simpleContentTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + StructureTagNames.complexContentTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + ComponentTagNames.groupTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + StructureTagNames.allTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + StructureTagNames.sequenceChoiceTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + ComponentTagNames.attributeTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + ComponentTagNames.attributeGroupTagName, true );
		put( ComponentTagNames.complexTypeTagName + "+" + ComponentTagNames.anyAttributeTagName, true );

		put( ComponentTagNames.anyAttributeTagName + "+" + Annotation.annotationTagName, true );

		put( ComponentTagNames.attributeGroupTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.attributeGroupTagName + "+" + ComponentTagNames.attributeTagName, true );
		put( ComponentTagNames.attributeGroupTagName + "+" + ComponentTagNames.anyAttributeTagName, true );
		put( ComponentTagNames.attributeGroupTagName + "+" + ComponentTagNames.attributeGroupTagName, true );

		put( ComponentTagNames.groupTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.groupTagName + "+" + StructureTagNames.allTagName, true );
		put( ComponentTagNames.groupTagName + "+" + StructureTagNames.sequenceChoiceTagName, true );

		put( ComponentTagNames.anyTagName + "+" + Annotation.annotationTagName, true );

		put( ComponentTagNames.identityConstraintTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.identityConstraintTagName + "+" + ComponentTagNames.selectorFieldTagName, true );

		put( ComponentTagNames.selectorFieldTagName + "+" + Annotation.annotationTagName, true );

		put( ComponentTagNames.simpleTypeTagName + "+" + Annotation.annotationTagName, true );
		put( ComponentTagNames.simpleTypeTagName + "+" + StructureTagNames.listUnionTagName, true );
		put( ComponentTagNames.simpleTypeTagName + "+" + StructureTagNames.restrictionTagName, true );
	} };


	//Verifiers.
	static boolean isContent( String currentTagName, String nextTagName, String parentOfNextTagName ){

		return isInValidContents( currentTagName, nextTagName ) && parentOfNextTagName != null && parentOfNextTagName.equals( currentTagName );
	}

	static boolean isInValidContents( String currentTagName, String nextTagName ){

		nextTagName = StructureTagNames.getSequenceChoiceTagName( nextTagName );

		nextTagName = StructureTagNames.getListUnionTagName( nextTagName );


		return MapGetter.existsStringKey( currentTagName + "+" + nextTagName, validContent );
	}
}
