package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class ComponentTagNames {


	//Variables.
	public final static String elementTagName = "element",

							   identityConstraintTagName = "identityConstraint",//Artificial overall tag name!
							   uniqueTagName = "unique",
							   keyTagName = "key",
							   keyRefTagName = "keyref",

							   selectorFieldTagName = "selectorField",//Artificial overall tag name!
							   selectorTagName = "selector",
							   fieldTagName = "field",

							   anyTagName = "any",

	   						   groupTagName = "group",

	   						   complexTypeTagName = "complexType",
	   						   simpleTypeTagName = "simpleType",

	   						   attributeTagName = "attribute",
	   						   anyAttributeTagName = "anyAttribute",
	   						   attributeGroupTagName = "attributeGroup";

	private final static String[] tagNames = new String[] {
		elementTagName,
		uniqueTagName,
		keyTagName,
		keyRefTagName,
		selectorTagName,
		fieldTagName,
		anyTagName,
		complexTypeTagName,
		simpleTypeTagName,
		attributeTagName,
		groupTagName,
		attributeGroupTagName,
		anyAttributeTagName
	};

	final static Map<String, Boolean> mapTagNames = new Hashtable<String, Boolean>() { {//This has the same content with the above array but I use it in the following function 'isComponentTagName' for constant-time retrieval.
		 put( elementTagName, true );
		 put( uniqueTagName, true );
		 put( keyTagName, true );
		 put( keyRefTagName, true );
		 put( selectorTagName, true );
		 put( fieldTagName, true );
		 put( anyTagName, true );
		 put( complexTypeTagName, true );
		 put( simpleTypeTagName, true );
		 put( attributeTagName, true );
		 put( groupTagName, true );
		 put( attributeGroupTagName, true );
		 put( anyAttributeTagName, true );
	} };


	final static Map<String, String> identityConstraintTagNames = new Hashtable<String, String>() { {
		 put( uniqueTagName, identityConstraintTagName );
		 put( keyTagName, identityConstraintTagName );
		 put( keyRefTagName, identityConstraintTagName );
	} };

	final static Map<String, String> selectorFieldTagNames = new Hashtable<String, String>() { {
		put( uniqueTagName, identityConstraintTagName );
		put( keyTagName, identityConstraintTagName );
	} };


	//Getters.
	static String[] getTagNames(){

		return tagNames;
	}

	static boolean isComponentTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, mapTagNames );
	}

	static String getIdentityConstraintTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, identityConstraintTagNames ) ? (String) MapGetter.getValueByStringKey( tagName, identityConstraintTagNames ) : tagName;
	}

	static String getSelectorFieldTagName( String tagName ){

		return MapGetter.existsStringKey( tagName, selectorFieldTagNames ) ? (String) MapGetter.getValueByStringKey( tagName, selectorFieldTagNames ) : tagName;
	}
}
