package org.ow2.choreos.schemaRepresentation.xml;

import java.util.Map;

import org.ow2.choreos.dataStructures.array.arrayManipulation.ArrayTransformations;
import org.ow2.choreos.schemaRepresentation.KindDescr;
import org.ow2.choreos.schemaRepresentation.Schema;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;


/**
 * 
 * @author dathanas
 * This class models an XML XSD Schema.
 */
public abstract class XMLSchema extends Schema {


	//Variables.
	private final static String xmlSchemaDefinitionNamespace = "http://www.w3.org/2001/XMLSchema";


	//Constructor.
	public XMLSchema( String qualifier, Map<String, String> attributes ){

		super( qualifier, attributes );


		setSchemaKind( SchemaRepresentationController.getSchemaKind() );
	}


	//Getters.
	public String getSchemaDefinitionNamespace(){

		return xmlSchemaDefinitionNamespace;
	}

	public static String[] getTagNames(){

		return ArrayTransformations.concat( ComponentTagNames.getTagNames(), StructureTagNames.getTagNames() );
	}

	public KindDescr getKindDescr(){

		return new ElementKindDescr( "schema", getTagName(), false, false );
	}

	public KindDescr getKindDescr( String tagName ){

		return new ElementKindDescr( "schema", tagName, false, false );
	}

	public static boolean isContent( String parentOfCurrentTagName, String currentTagName, String nextTagName, String parentOfNextTagName ){//Is content the nextTagName of the currentTagName?

		return XMLSchemaContent.isContent( currentTagName, nextTagName ) || ComponentContent.isContent( currentTagName, nextTagName, parentOfNextTagName ) || StructureContent.isContent( parentOfCurrentTagName, currentTagName, nextTagName, parentOfNextTagName );
	}

	static public boolean hasOrderedChildren( String tagName ){

		return StructureTagNames.hasOrderedChildren( tagName );
	}
}
