package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.attribute;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 * This class models attributes with 'type' attribute a built-in type or 'SimpleType or attributes with 'ref' attribute and not 'type' attribute.
 */
class AttributeDeclaration extends Attribute {


	//Variables.
	private static final long serialVersionUID = -3607115288805006662L;


	//Constructor.
	AttributeDeclaration( List<Map<String, String>> path, String cType, String typeKind, boolean isGlobal ){

		super( path, isGlobal );


		setReferencedComponent( new ReferencedComponent( cType, typeKind ) );
	}


	//Constraint checkers (This 1st constraint is implemented by the Reference constraint checker!).
	protected String checkConstraints() {//It accumulates all the constraint checkers of a concrete class that are not called by the constructor but by a setter! Note these checkers are not the same with the final checkers for the situation of the class that are called by the 'getFinalConstraintViolation()'

		checkConstraint2();

		return null;
	}

	private String checkConstraint2(){

		String[] attributeNames = { "name", "form" };

		if( isAnonymous() && hasForm() ) return ObjectConstraintsManipulation.setErrorAttribute( this, attributeNames, "Anonymous declaration with value in the 'form' attribute" );


		return null;
	}


	//Getters.
	public String getFinalConstraintViolation(){//It accumulates the constraints that are not called by the constructor.

		if( hasConstraintViolation() ) return getConstraintViolation();


		checkConstraints();


		super.getFinalConstraintViolation();


		return getConstraintViolation();
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\nAnnotation" );
		}


		return this;
	}
}
