package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.dataType;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ComponentTagNames;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.simpleType.SimpleTypeStructureController;


/**
 * 
 * @author dathanas
 *
 */
class SimpleType extends Component {


	//Variables.
	private static final long serialVersionUID = -3870127576918575616L;

	private List<String> finalValues;

	private boolean hasFinal;


	//Constructor.
	SimpleType( List<Map<String, String>> path, boolean isGlobal ){

		super( path, isGlobal );


		parse( (String) MapGetter.getValueByStringKey( "final", getTagAttributes() ) );

		checkConstraint2();
	}


	//Functions used by the constructor.
	private void parse( String values ){

		if( values == null || ( values != null && values.isEmpty() ) ) return;
			
		int pos = values.indexOf(" ");

		if( pos <= 0 ){//Only one value exists.

			if( checkConstraint1( values ) == null ) add( values );
		}

		else{

			while( pos > 0 ){

				String tmpValue = values.substring( 0, pos );

				if( checkConstraint1( tmpValue ) != null ) add( tmpValue );

				values = values.substring( pos + 1, values.length() );

				pos = values.indexOf(" ");
			}

			if( checkConstraint1( values ) == null ) add( values );
		}
	}

	private void add( String value ){

		if( ! hasFinal ){

			finalValues = new ArrayList<String>();

			hasFinal = true;
		}

		finalValues.add( value );
	}


	//Constraint checkers.
	private String checkConstraint1( String value ){

		return ( value != null && ! value.isEmpty() && ! value.equals( "#all" ) && ! value.equals( "list" ) && ! value.equals( "union" ) && ! value.equals( "restriction" ) ) ? ObjectConstraintsManipulation.setErrorAttribute( this, "final", "final= '#all', 'extension' and 'restriction'" ) : null;
	}

	private String checkConstraint2(){

		for( int i = 0; hasFinal && finalValues.size() > 1 && i < finalValues.size(); ++i ) if( finalValues.get( i ).equals( "#all" ) ) return ObjectConstraintsManipulation.setErrorAttribute( this, "final", "The 'final' attribute cannot have a list of '#all' values" );

		return null;
	}


	//Setters.
	public Object add( Object object ){//Object is Structure.

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( SimpleTypeStructureController.isSimpleTypeStructureKind( object ) ) addStructure( (Structure) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. simpleType structures: " + SimpleTypeStructureController.getSimpleTypeStructureKinds() + "\n2. Annotation" );
		}

		return this;
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return ComponentTagNames.simpleTypeTagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
