package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.group;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ComponentTagNames;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.attribute.AttributeController;


/**
 * 
 * @author dathanas
 *
 */
class AttributeGroupDefinition extends GroupDefinition {


	//Variables.
	private static final long serialVersionUID = 7317541366279194823L;


	//Constructor.
	AttributeGroupDefinition( List<Map<String, String>> path, boolean isGlobal ) {

		super( path, isGlobal );


		PrintMessages.print( PrintMessages.xmlPrint, hasConstraintViolation(), this );
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( AttributeController.isAttributeKind( object ) || GroupController.isAttributeGroupKind( object ) ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. Component kinds: attribute groups: " + GroupController.getFlatAttributeGroupKinds() + " and attributes: " + AttributeController.getFlatAttributeKinds() + ".\n2. Annotation");
		}

		return this;
	}


	//Getters.
	public String getTagName(){

		return ComponentTagNames.attributeGroupTagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}
}
