package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.identityConstraint;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ComponentTagNames;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 * This class models the 'selector' and 'field' tags.
 */
class SelectorOrField extends Component {


	//Variables.
	private static final long serialVersionUID = -6590741692805394635L;

	private String xPath;
	private boolean hasXPath;


	//Constructor.
	protected SelectorOrField( List<Map<String, String>> path ){

		super( path, false );


		String cxPath = (String) MapGetter.getValueByStringKey( "xpath", getTagAttributes() );

		if( checkConstraint( cxPath ) == null ){

			xPath = cxPath;

			hasXPath = true;
		}

		else hasXPath = false;
	}


	//Constraint checkers.
	private String checkConstraint( String value ){

		return value == null || ( value != null && value.isEmpty() ) ? ObjectConstraintsManipulation.setEmptyAttribute( this, "xpath" ) : null;
	}


	//Getters.
	boolean hasXPath(){

		return hasXPath;
	}
	String getXPath(){

		return xPath;
	}
	public boolean isField(){

		return getTagName().equals( ComponentTagNames.fieldTagName );
	}

	public boolean isSelector(){

		return getTagName().equals( ComponentTagNames.selectorTagName );
	}

	public String getTagName(){

		return (String) MapGetter.getValueByStringKey( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() ) + printMyOrderID();
	}

	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}
}
