package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.composition;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.list.listManipulation.ListGetters;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class ComplexTypeCompositionController {


	//Variables.
	private static Map<String, String> complexTypeCompositionKinds = new Hashtable<String, String>() { { put( "SequenceOrChoice", "SequenceOrChoice" );
																										 put( "All", "All" ); } };


	//Verifiers.
	public static boolean isCompositionKind( Object object ){

		return object != null ? object instanceof Composition : false;
	}

	public static boolean isAllKind( Object object ){

		return object != null ? object.getClass().equals( All.class ) : false;
	}

	public static boolean isSequenceOrChoiceKind( Object object ){

		return object != null ? object.getClass().equals( SequenceOrChoice.class ) : false;
	}


	public static boolean isCompositionTagName( String tagName ){

		return isAllTagName( tagName ) || isSequenceTagName( tagName ) || isChoiceTagName( tagName ) ? true : false;
	}

	public static boolean isAllTagName( String tagName ){

		return tagName != null && tagName.equals( "all" ) ? true : false;
	}

	public static boolean isSequenceTagName( String tagName ){

		return tagName != null && tagName.equals( "sequence" ) ? true : false;
	}

	public static boolean isChoiceTagName( String tagName ){

		return tagName != null && tagName.equals( "choice" ) ? true : false;
	}


	//Getters.
	public static Object getTagObject( List<Map<String, String>> path ){

		String tagName = ListGetters.getLastListElementValue( SchemaRepresentationController.getTagNameKey(), path );


		if( isAllTagName( tagName ) ) return new All( path );

		if( isSequenceTagName( tagName ) || isChoiceTagName( tagName ) ) return new SequenceOrChoice( path );


		return UnknownClassesController.getUnknownTag( tagName, XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel() );
	}

	public static Map<String, String> getComplexTypeCompositionKinds(){

		return complexTypeCompositionKinds;
	}

	public static String getFlatComplexTypeCompositionKinds(){

		return MapPrinting.printCommaSeparated( getComplexTypeCompositionKinds() );
	}

	public static String getFlatSequenceOrChoiceKinds(){

		return "[ Sequence, Choice ]";
	}
}
