package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.complexType.specialization;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.attribute.AttributeController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.dataType.DataTypeController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.group.GroupController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet.RestrictionFacetController;


/**
 * 
 * @author dathanas
 *
 */
class Restriction extends SimpleContentSpecializationKind {


	//Variables.
	private static final long serialVersionUID = 4553895220097404558L;


	//Constructor.
	protected Restriction( List<Map<String, String>> path ){

		super( path );
	}


	//Constraint checkers.
	private String checkConstraint2( Object object ){

		return hasSimpleType() ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one simpleTypes" ) : null;
	}

	private String checkConstraint5( Object object ){

		return hasStructures() ? ObjectConstraintsManipulation.setConnectionError( this, object, "The '" + getTag() + "' cannot contain more than one restriction facets" ) : null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( RestrictionFacetController.isRestrictionFacetKind( object ) && checkConstraint5( object ) == null ) addStructure( (Structure) object );

			else if( ( AttributeController.isAttributeKind( object ) && checkConstraint3( object ) == null ) || GroupController.isAttributeGroupKind( object ) || ( DataTypeController.isSimpleTypeKind( object ) && checkConstraint2( object ) == null ) ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) && checkConstraint4( object ) == null ) setAnnotation( (Annotation) object );

			else{

				String message1 = "Valid content:\n1. For structures, the restriction facets: " + RestrictionFacetController.getFlatFestrictionFacetKinds();

				String message2 = "\n2. For components, the dataTypes: " + DataTypeController.getFlatSimpleTypeKinds() + ", the attributes: " + AttributeController.getFlatAttributeKinds() + " and the attribute groups: " + GroupController.getFlatAttributeGroupKinds();

				String message3 = "\n3. Annotation";

				ObjectConstraintsManipulation.setConnectionError ( this, object, message1 + message2 + message3 );
			}
		}

		return this;
	}


	//Getters.
	private boolean hasSimpleType(){

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i ) if( DataTypeController.isSimpleTypeKind( getComponents().get( i ) ) ) return true;


		return false;
	}
}
