package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.restrictionFacet;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;


/**
 * 
 * @author dathanas
 *
 */
abstract class IntegerValueFixedFacet extends FixedFacet {


	//Variables.
	private static final long serialVersionUID = -8273151283761924902L;

	private int value;


	//Constructor.
	protected IntegerValueFixedFacet( List<Map<String, String>> path ){

		super( path );


		String cValue = (String) MapGetter.getValueByStringKey( "value", getTagAttributes() );

		if( checkConstraint( cValue ) == null ) value = Integer.parseInt( cValue );
	}


	//Constraint checkers.
	private String checkConstraint( String cValue ){

		if( cValue == null || ( cValue != null && cValue.isEmpty() ) ) return ObjectConstraintsManipulation.setEmptyAttribute( this, "value" );

		try{

			Integer.parseInt( cValue );
		}

		catch( Exception ex ){

			return ObjectConstraintsManipulation.setErrorAttribute( this, "value", "The value should be an integer" );
		}

		return null;
	}


	//Getters.
	protected int getValue(){

		return value;
	}
}
