package org.ow2.choreos.schemaRepresentation.xml.completelyStructured.structure.simpleType;

import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Annotation;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.ReferencedComponent;
import org.ow2.choreos.schemaRepresentation.xml.Structure;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.completelyStructured.component.dataType.DataTypeController;


/**
 * 
 * @author dathanas
 *
 */
class Union extends Structure {


	//Variables.
	private static final long serialVersionUID = -3150897228208067338L;

	public final static String tagName = "union";


	//Constructor.
	protected Union( List<Map<String, String>> path ){

		super( path );


		parse( MapGetter.getValueByKeyToLowerCase( "memberTypes", getTagAttributes() ) );
	}


	//Methods used by the constructor.
	void parse( String values ){

		if( values == null || ( values != null && values.isEmpty() ) ) return;


		int pos = values.indexOf(" ");

		if( pos <= 0 ){//Only one value exists.

			addReferencedComponent( new ReferencedComponent( values, "memberType" ) );
		}

		else{

			while( pos > 0 ){

				String tmpValue = values.substring( 0, pos );

				addReferencedComponent( new ReferencedComponent( tmpValue, "memberType" ) );

				values = values.substring( pos + 1, values.length() );

				pos = values.indexOf(" ");
			}

			addReferencedComponent( new ReferencedComponent( values, "memberType" ) );
		}
	}

	


	//Constraint checkers.
	private String checkConstraints(){//It accumulates all the constraint checkers that are not called neither by the constructor nor by a setter!

		String constraintViolation =  null;


		return ( constraintViolation =  checkConstraint1() ) != null ? constraintViolation : null;
	}

	private String checkConstraint1(){

		return ! hasReferencedComponents() && ! hasSimpleTypes() ? ObjectConstraintsManipulation.setContainmentError( this, getComponents() ) : null;
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( DataTypeController.isSimpleTypeKind( object ) ) addComponent( (Component) object );

			else if( XMLSchemaRepresentationController.isAnnotationKind( object ) ) setAnnotation( (Annotation) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\n\n1. the simpleTypes: " + DataTypeController.getFlatSimpleTypeKinds() + "\n2. Annotation");
		}

		return this;
	}


	//Getters.
	public String getFinalConstraintViolation(){

		if( hasConstraintViolation() ) return getConstraintViolation();


		checkConstraints();//It accumulates the constraint checkers of this class.


		super.getFinalConstraintViolation();


		return getConstraintViolation();
	}

	private boolean hasSimpleTypes(){

		for( int i = 0; hasComponents() && i < getComponents().size(); ++i ) if( DataTypeController.isSimpleTypeKind( getComponents().get( i ) ) ) return true;


		return false;
	}

	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getXMLSchemaCompletelyStructuredRepresentationModel();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return tagName;
	}

	public String getTag(){

		Map<String, String> exceptedKeys = new Hashtable<String, String>(){

			private static final long serialVersionUID = -3331246935773737202L;

			{ put( SchemaRepresentationController.getTagNameKey(), SchemaRepresentationController.getTagNameKey() );
			  put( "memberTypes", "memberTypes" );
			}
		};


		return getTagName() + MapPrinting.printSpaceSeparated( exceptedKeys, getTagAttributes() ) + " memberTypes= '" + MapGetter.getValueByKeyToLowerCase( "memberTypes", getTagAttributes() ) + printMyOrderID();
	}
}
