package org.ow2.choreos.schemaRepresentation.xml.completelyUnstructured.component.dataType;

import java.util.List;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapPrinting;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.SchemaRepresentationController;
import org.ow2.choreos.schemaRepresentation.xml.Component;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;


/**
 * 
 * @author dathanas
 *
 */
class ComplexType extends Component {


	//Variables.
	private static final long serialVersionUID = 5513903504109205631L;

	public final static String tagName = "complexType";


	//Constructor.
	protected ComplexType( List<Map<String, String>> path, boolean isGlobal ){

		super( path, isGlobal );
	}


	//Setters.
	public Object add( Object object ){

		if( ObjectConstraintsManipulation.setContainmentError( this, object ) == null ){

			if( DataTypeController.isDataTypeKind( object ) ) addComponent( (Component) object );

			else ObjectConstraintsManipulation.setConnectionError ( this, object, "Valid content:\nThe dataTypes: " + DataTypeController.getFlatDataTypeKinds() );
		}


		return this;
	}


	//Getters.
	public String getSchemaRepresentationModel(){

		return XMLSchemaRepresentationController.getCompletelyUnstructuredSchemaRepresentation();
	}

	public String getSchemaKind(){

		return SchemaRepresentationController.getSchemaKind();
	}

	public String getTagName(){

		return tagName;
	}

	public String getTag(){

		return getTagName() + MapPrinting.printSpaceSeparated( SchemaRepresentationController.getTagNameKey(), getTagAttributes() );
	}
}
