package org.ow2.choreos.serviceRegistration;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.classInfo.ClassInfo;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class ServiceRegistrationController {


	//Variables.
	private static Map<String, String> serviceRegistrationKinds = new Hashtable<String, String>() { { put("ServiceSource", "ServiceSource"); put("ServiceCollection", "ServiceCollection"); put("ServiceRegistration", "ServiceRegistration"); } };


	//Verifiers.
	public static boolean isServiceRegistrationKinds( Object object ){

		return MapGetter.objectNameBelongsToMapStrings( object, serviceRegistrationKinds );
	}

	private static boolean isServiceSourceKind( Object object ){

		String objectKind = ClassInfo.getClass( object );

		return ( objectKind.equals( "ServiceSource" ) ) ? true : false;
	}

	private static boolean isServiceCollectionKind( Object object ){

		String objectKind = ClassInfo.getClass( object );

		return ( objectKind.equals( "ServiceCollection" ) ) ? true : false;
	}

	private static boolean isServiceRegistrationKind( Object object ){

		String objectKind = ClassInfo.getClass( object );

		return ( objectKind.equals( "ServiceRegistration" ) ) ? true : false;
	}


	//Getters.
	public static String getTag( Object object ){

		if( isServiceCollectionKind( object ) ) return ( (ServiceCollection) object).getTag();

		if( isServiceSourceKind( object ) ) return ( (ServiceSource) object).getTag();

		if( isServiceRegistrationKind( object ) ) return ( (ServiceRegistration) object).getTag();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String getConstraintViolation( Object object ){

		if( isServiceCollectionKind( object ) ) return ( (ServiceCollection) object).getConstraintViolation();

		if( isServiceSourceKind( object ) ) return ( (ServiceSource) object).getConstraintViolation();

		if( isServiceRegistrationKind( object ) ) return ( (ServiceRegistration) object).getConstraintViolation();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String setConstraintViolation( Object object, String constraintViolation ){

		if( isServiceCollectionKind( object ) ) return ( (ServiceCollection) object).setConstraintViolation( constraintViolation );

		if( isServiceSourceKind( object ) ) return ( (ServiceSource) object).setConstraintViolation( constraintViolation );

		if( isServiceRegistrationKind( object ) ) return ( (ServiceRegistration) object).setConstraintViolation( constraintViolation );


		return UnknownClassesController.getUnknownTagName();
	}
}

