package org.ow2.choreos.serviceRepresentation.behavioral;

import javax.swing.tree.DefaultMutableTreeNode;

import org.ow2.choreos.gui.PrintMessages;


class DocOfBehSpecification {


	//Variables.
	private String ref2DocOfBehSpecification;

	private String ref2DocOfFuncProperties;
	private boolean hasRef2DocOfFuncProperties;

	private String serviceTypeName;
	private boolean hasServiceTypeName;

	private String serviceInterfaceName;
	private boolean hasServiceInterfaceName;

	private String content;
	private boolean hasContent;

	private String constraintViolation;
	private boolean hasConstraintViolation;


	//Constructor.
	DocOfBehSpecification( String cRef2DocOfBehSpecification ){

		ref2DocOfBehSpecification = cRef2DocOfBehSpecification;

		hasRef2DocOfFuncProperties = false;
		hasServiceTypeName = false;
		hasServiceInterfaceName = false;

		hasContent = false;
		hasConstraintViolation = false;


		setRef2DocOfFuncProperties( getName() );


		PrintMessages.print( PrintMessages.behavioralPrint, this );
	}

	//Method used by the constructor.
	public String getName(){

		String name = new String( ref2DocOfBehSpecification );


		int pos = ref2DocOfBehSpecification.lastIndexOf( "\\" );

		if( pos > 0 ) name = ref2DocOfBehSpecification.substring( pos + 1 );


		pos = name.lastIndexOf( "." );

		if( pos > 0 ) name = name.substring( 0, pos );


		return name;
	}


	//Setters.
	public String setConstraintViolation( String cConstraintViolation ){

		if( ! hasConstraintViolation && cConstraintViolation != null ){

			constraintViolation = cConstraintViolation;

			hasConstraintViolation = true;
		}

		return constraintViolation;
	}

	public void setRef2DocOfFuncProperties( String cRef2DocOfFuncProperties ){

		if( ! hasRef2DocOfFuncProperties && cRef2DocOfFuncProperties != null ){

			ref2DocOfFuncProperties = cRef2DocOfFuncProperties;

			hasRef2DocOfFuncProperties = true;
		}
	}

	public void setServiceTypeName( String cServiceTypeName ){

		if( ! hasServiceTypeName && cServiceTypeName != null ){

			serviceTypeName = cServiceTypeName;

			hasServiceTypeName = true;
		}
	}

	public void setServiceInterfaceName( String cServiceInterfaceName ){

		if( ! hasServiceInterfaceName && cServiceInterfaceName != null ){

			serviceInterfaceName = cServiceInterfaceName;

			hasServiceInterfaceName = true;
		}
	}

	public void setContent( String cContent ){

		if( ! hasContent && cContent != null ){

			content = cContent;

			hasContent = true;
		}
	}


	//Getters.
	public boolean hasConstraintViolation(){

		return hasConstraintViolation;
	}

	public String getConstraintViolation(){

		return constraintViolation;
	}

	public String getRef2DocOfBehSpecification(){

		return ref2DocOfBehSpecification;
	}

	public boolean hasRef2DocOfFuncProperties(){

		return hasRef2DocOfFuncProperties;
	}

	public String getRef2DocOfFuncProperties(){

		return ref2DocOfFuncProperties;
	}

	public boolean hasServiceTypeName(){

		return hasServiceTypeName;
	}

	public String getServiceTypeName(){

		return serviceTypeName;
	}

	public boolean hasServiceInterfaceName(){

		return hasServiceInterfaceName;
	}

	public String getServiceInterfaceName(){

		return serviceInterfaceName;
	}

	public boolean hasContent(){

		return hasContent;
	}

	public String getContent(){

		return content;
	}


	//Visualization.
	DefaultMutableTreeNode visualize(){

		return content != null ? new DefaultMutableTreeNode( content ) : null;
    }
}
