package org.ow2.choreos.serviceRepresentation.functional;

import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.classInfo.ClassInfo;
import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.parser.functionalDocuments.objectConstraintsManipulation.ObjectConstraintsManipulation;
import org.ow2.choreos.schemaRepresentation.Schema;
import org.ow2.choreos.schemaRepresentation.xml.XMLSchemaRepresentationController;
import org.ow2.choreos.unknownClasses.UnknownClassesController;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class FunctionalServiceRepresentationController {


	//Variables.
	private static Map<String, String> functionalServiceRepresentationKinds = new Hashtable<String, String>() { { put( "DocOfFuncProperties", "DocOfFuncProperties" ); put("ServiceType", "ServiceType"); put("Operation", "Operation"); put("MessageType", "MessageType"); put("Message", "Message"); put("ServiceInstance", "ServiceInstance"); put("ServiceInterface", "ServiceInterface"); } };


	//Verifiers.
	public static boolean isFunctionalServiceRepresentationKind( Object object ){

		return MapGetter.objectNameBelongsToMapStrings( object, functionalServiceRepresentationKinds );
	}

	private static boolean isDocOfFunPropertiesKind( Object object ){

		return object != null ? object.getClass().equals( DocOfFuncProperties.class ) : false;
	}

	private static boolean isServiceTypeKind( Object object ){

		return object != null ? object.getClass().equals( ServiceType.class ) : false;
	}

	private static boolean isServiceInterfaceKind( Object object ){

		return object != null ? object.getClass().equals( ServiceInterface.class ) : false;
	}

	private static boolean isServiceInstanceKind( Object object ){

		return object != null ? object.getClass().equals( ServiceInstance.class ) : false;
	}

	private static boolean isOperationKind( Object object ){

		return object != null ? object.getClass().equals( Operation.class ) : false;
	}

	private static boolean isMessageKind( Object object ){

		return object != null ? object.getClass().equals( Message.class ) : false;
	}

	public static boolean isMessageTypeKind( Object object ){

		return object != null ? object.getClass().equals( MessageType.class ) : false;
	}


	//Getters.
	public static Object getDocOfFunProperties( String ref2DocOfFuncProperties ){

		return new DocOfFuncProperties( ref2DocOfFuncProperties );
	}

	public static Object getErrorDocOfFuncProperties( String ref2DocOfFuncProperties, String constraintViolation ){

		DocOfFuncProperties docOfFuncProperties = new DocOfFuncProperties( ref2DocOfFuncProperties );

		docOfFuncProperties.setConstraintViolation( constraintViolation );


		return docOfFuncProperties;
	}

	public static String getRef2DocOfFunProperties( Object object ){

		if( isDocOfFunPropertiesKind( object ) ) return ( (DocOfFuncProperties) object).getRef2DocOfFuncProperties();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String getTag( Object object ){

		if( isDocOfFunPropertiesKind( object ) ) return ( (DocOfFuncProperties) object).getTag();

		if( isServiceTypeKind( object ) ) return ( (ServiceType) object).getTag();

		if( isServiceInstanceKind( object ) ) return ( (ServiceInstance) object).getTag();

		if( isServiceInterfaceKind( object ) ) return ( (ServiceInterface) object).getTag();

		if( isOperationKind( object ) ) return ( (Operation) object).getTag();

		if( isMessageKind( object ) ) return ( (Message) object).getTag();

		if( isMessageTypeKind( object ) ) return ( (MessageType) object).getTag();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String getName( Object object ){

		if( isDocOfFunPropertiesKind( object ) ) return ( (DocOfFuncProperties) object).getName();

		if( isServiceTypeKind( object ) ) return ( (ServiceType) object).getName();

		if( isServiceInterfaceKind( object ) ) return ( (ServiceInterface) object).getName();

		if( isServiceInstanceKind( object ) ) return ( (ServiceInstance) object).getName();

		if( isOperationKind( object ) ) return ( (Operation) object).getName();

		if( isMessageKind( object ) ) return ( (Message) object).getName();

		if( isMessageTypeKind( object ) ) return ( (MessageType) object).getName();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String getConstraintViolation( Object object ){

		if( isDocOfFunPropertiesKind( object ) ) return ( (DocOfFuncProperties) object).getConstraintViolation();

		if( isServiceTypeKind( object ) ) return ( (ServiceType) object).getConstraintViolation();

		if( isServiceInterfaceKind( object ) ) return ( (ServiceInterface) object).getConstraintViolation();

		if( isServiceInstanceKind( object ) ) return ( (ServiceInstance) object).getConstraintViolation();

		if( isOperationKind( object ) ) return ( (Operation) object).getConstraintViolation();

		if( isMessageKind( object ) ) return ( (Message) object).getConstraintViolation();

		if( isMessageTypeKind( object ) ) return ( (MessageType) object).getConstraintViolation();


		return UnknownClassesController.getUnknownTagName();
	}

	public static String setConstraintViolation( Object object, String constraintViolation ){

		if( isDocOfFunPropertiesKind( object ) ) return ( (DocOfFuncProperties) object).setConstraintViolation( constraintViolation );

		if( isServiceTypeKind( object ) ) return ( (ServiceType) object).setConstraintViolation( constraintViolation );

		if( isServiceInterfaceKind( object ) ) return ( (ServiceInterface) object).setConstraintViolation( constraintViolation );

		if( isServiceInstanceKind( object ) ) return ( (ServiceInstance) object).setConstraintViolation( constraintViolation );

		if( isOperationKind( object ) ) return ( (Operation) object).setConstraintViolation( constraintViolation );

		if( isMessageKind( object ) ) return ( (Message) object).setConstraintViolation( constraintViolation );

		if( isMessageTypeKind( object ) ) return ( (MessageType) object).setConstraintViolation( constraintViolation );


		return UnknownClassesController.getUnknownTagName();
	}


	//Setters.
	public static Object set( Object internal, Object external ){

		PrintMessages.print( PrintMessages.controllerPrint, "ServiceRepresentationController1: Set the internal= " + ClassInfo.getClass( internal ) + " to external= " + ClassInfo.getClass( external ) );


		if( isDocOfFunPropertiesKind( external ) ) return set( internal, (DocOfFuncProperties) external );


		return external;
	}


	private static Object set( Object internal, DocOfFuncProperties docOfFunProperties ){//For the internals...

		PrintMessages.print( PrintMessages.controllerPrint, "ServiceRepresentationController2: Set the internal= " + ClassInfo.getClass( internal ) + " to docOfFunProperties= " + ClassInfo.getClass( docOfFunProperties ) );


		if( XMLSchemaRepresentationController.isXMLSchemaKind( internal ) ) docOfFunProperties.add( (Schema) internal );

		//TODO: else if{}//sth else ... ( StructureController.isStructureKind( internalKind ) ) ConstraintsManipulation.setConnectionError( "schema", xmlSchema, "structure", (Structure) internal, "The schema should containt a component" );

		else if( UnknownClassesController.isUnknownTag( internal ) ) ObjectConstraintsManipulation.setUnknownTag( docOfFunProperties, UnknownClassesController.getUnknownTagName( internal ) );

		else if( UnknownClassesController.isUnknownObject( internal ) ) ObjectConstraintsManipulation.setUnknownObject( docOfFunProperties, UnknownClassesController.getUnknownSourceObjectName( internal ), UnknownClassesController.getUnknownObjectSourceSchemaRepresentationModel( internal ), UnknownClassesController.getUnknownObjectTargetSchemaRepresentationModel( internal ) );

		else if( XMLSchemaRepresentationController.isUnknownSchemaModelKind( internal ) ) ObjectConstraintsManipulation.setUnknownSchemaModel( docOfFunProperties, XMLSchemaRepresentationController.getUnknownSourceSchemaModel( internal ), XMLSchemaRepresentationController.getUnknownTargetSchemaModel( internal ) );


		return docOfFunProperties;
	}
}

