package org.ow2.choreos.serviceRepresentation.nonFunctional;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Map;


public class QualityProperties implements java.io.Serializable{


	//Variables.
	private static final long serialVersionUID = -8490330761238350150L;

	private ArrayList<String> properties;
	private ArrayList<ArrayList<String>> domains;
	private Hashtable<String, ArrayList<String>> propertiesAndDomains;

	//Extra fields used for xml transformation
	private ArrayList<Domain> xDomains = null;
	private Hashtable<String, Domain> xPropertiesAndDomains = null;
	//
	
	//Empty constructor used for xml transformation
	public QualityProperties(){
		
	}
	
	//Setters.
	public void add( String property, ArrayList<String> domains ){

		if( property != null && domains != null && ! domains.isEmpty() ){

			if( properties == null ) properties = new ArrayList<String>();
			this.properties.add( property );

			if( this.domains == null ) this.domains = new ArrayList<ArrayList<String>>();
			this.domains.add( domains);

			if( propertiesAndDomains == null ) propertiesAndDomains = new Hashtable<String, ArrayList<String>>();
			propertiesAndDomains.put( property, domains);
		}
	}


	//Getters.
	public int getNumOfProperties(){

		if( properties != null ) return properties.size();

		return 0;
	}

	public String getProperty( int index ){

		if( properties != null ) return properties.get( index );

		return null;
	}
	
	public ArrayList<String> getProperties(){

		return properties;
	}

	public ArrayList<String> getDomain( int index ){

		if( domains != null ) return domains.get( index );

		return null;
	}

	public ArrayList<String> getDomain( String property ){

		if( properties != null ) return propertiesAndDomains.get( property );

		return null;
	}
	
	//Setters used for xml transformation
	
	public void setxProperties( ArrayList<String> cProperties ){
		properties = cProperties;
	}
		
	public void setxDomains( ArrayList<Domain> cDomains ){
		xDomains = cDomains;
	}
		
	public void setxPropertiesAndDomains( Hashtable<String, Domain> cPropertiesAndDomains ){
		xPropertiesAndDomains = cPropertiesAndDomains;
	}
		
	//Getters used for xml transformation
		
	public ArrayList<String> getxProperties(){
		return properties;
	}
			
	public ArrayList<Domain> getxDomains(){
		
		if(xDomains == null){
		
			if(domains != null){
			
				xDomains = new ArrayList<Domain>();
			
				int domainsSize = domains.size();
				for(int i = 0; i < domainsSize; i++){
					xDomains.add(new Domain(domains.get(i)));
				}
			}
		}
		
		return xDomains;
	}
			
	public Hashtable<String, Domain> getxPropertiesAndDomains(){
		
		if(xPropertiesAndDomains == null){
		
			if(propertiesAndDomains != null){
			
				xPropertiesAndDomains = new Hashtable<String, Domain>();
				
				for(Map.Entry<String, ArrayList<String>> entry : propertiesAndDomains.entrySet()) {
					String propertyName = entry.getKey();
					ArrayList<String> domain = entry.getValue();
					
					xPropertiesAndDomains.put(propertyName, new Domain(domain));
				}
			}
		}
			
		return xPropertiesAndDomains;
	}
}

