package org.ow2.choreos.unknownClasses;

import java.util.Arrays;

import org.ow2.choreos.classInfo.ClassInfo;


/**
 * 
 * @author dathanas
 * TODO
 */
public class UnknownClassesController {


	//Variables.
	private static String unknownTag = "UnknownTag";
	private static String unknownObject = "UnknownObject";


	//Verifiers.
	public static boolean isUnknownTag( Object object ){

		String objectKind = ClassInfo.getClass( object );

		return ( objectKind.equals( unknownTag ) ) ? true : false;
	}

	public static boolean isUnknownObject( Object object ){

		String objectKind = ClassInfo.getClass( object );

		return objectKind.equals( unknownObject );
	}


	//Getters.
	public static Object getUnknownTag( String tagName, String schemaRepresentationModel ){

		return new UnknownTag( tagName, schemaRepresentationModel );
	}

	public static Object getUnknownObject( String[] sourceObjectKind, String sourceSchemaRepresentationModel, String[] targetObjectKind, String targetSchemaRepresentationModel ){

		return new UnknownObject( sourceObjectKind, sourceSchemaRepresentationModel, targetObjectKind, targetSchemaRepresentationModel );
	}

	public static String getTagName( Object object ){

		if( isUnknownTag( object ) ) return getUnknownTagName( object );

		else return getUnknownSourceObjectName( object ) != null ? Arrays.toString( getUnknownSourceObjectName( object ) ) : null;
	}

	public static String getUnknownTagName(){

		return unknownTag;
	}

	public static String getUnknownObjectName(){

		return unknownObject;
	}

	public static String getUnknownTagName( Object unknownTag ){//pre-condition: 'unknownTag' is kind of 'UnknownTag'.

		return ( (UnknownTag) unknownTag).getTagName();
	}

	public static String[] getUnknownSourceObjectName( Object unknownObject ){//pre-condition: 'unknownObject' is kind of 'UnknownObject'.

		return unknownObject != null ? ( (UnknownObject) unknownObject).getSourceObjectKind() : null;
	}

	public static String[] getUnknownTargetObjectName( Object unknownObject ){//pre-condition: 'unknownObject' is kind of 'UnknownObject'.

		return unknownObject != null ? ( (UnknownObject) unknownObject).getTargetObjectKind() : null;
	}

	public static String getUnknownTagSchemaRepresentationModel( Object unknownTag ){//pre-condition: 'unknownTag' is kind of 'UnknownTag'.

		return ( (UnknownTag) unknownTag).getSchemaRepresentationModel();
	}

	public static String getUnknownObjectSourceSchemaRepresentationModel( Object unknownObject ){//pre-condition: 'unknownObject' is kind of 'UnknownObject'.

		return ( (UnknownObject) unknownObject).getSourceSchemaRepresentationModel();
	}

	public static String getUnknownObjectTargetSchemaRepresentationModel( Object unknownObject ){//pre-condition: 'unknownObject' is kind of 'UnknownObject'.

		return ( (UnknownObject) unknownObject).getTargetSchemaRepresentationModel();
	}
}
