package org.ow2.choreos.userAuthentication;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.Hashtable;
import java.util.Map;

import org.ow2.choreos.dataStructures.map.mapManipulation.MapGetter;
import org.ow2.choreos.gui.PrintMessages;
import org.ow2.choreos.parser.freeTextDocuments.TxtParser;


/**
 * 
 * @author dathanas
 *
 */
@SuppressWarnings("serial")
public class UserAuthenticationChecker {


	//Variables.
	private static final String curatorCategory = "curator";
	private static final String curatorPassword = "uoi";
	private static final String otherCategory = "designer/developer"; 

	private static Map<String, String> userCategories = new Hashtable<String, String>() { { put( curatorCategory, curatorCategory );
	  																						put( otherCategory, otherCategory ); }};

	private static Map<String, String> acceptedMACAddresses = new Hashtable<String, String>() { { put( "F0-BF-97-E7-12-25", "Dionysis-Office" );
																								  put( "88-53-2E-A7-41-DF", "Dionysis-Home" );
																								  put( "00-22-FB-A3-89-64", "Hlias" );
																								  put( "00-1D-BA-C9-C3-91", "Hlias1" );
																								  put( "00-0F-FE-C1-A0-7B", "SVN server");
																								  put( "20-68-9D-74-BC-3A", "George Gkavresis");
																								  put( "00-24-BE-3E-C3-36", "Zarras-wired");
																								  put( "00-24-D6-0E-F1-F4", "Zarras-wireless");
																								  put( "9C-B7-0D-AF-F7-CA", "Geotsilis-Laptop");
																								  put( "00-23-8B-AC-CC-C9", "Pilios-Laptop");
																								  put( "00-21-00-D1-EE-C0", "Pilios-Laptop-2");}};
																								  
																								  


	//Verifiers.
	public static boolean isCurator( String userCategory ){

		return userCategory != null && userCategory.equals( curatorCategory ) ? true : false;
	}

	public static boolean isAuthorizedForServiceRegistration( String userCategory, String cCuratorPassword ){

		if( userCategory == null ){

			PrintMessages.print( PrintMessages.guiPrint, "You have not logged in." );

			return false;
		}

		else if( ! MapGetter.keyBelongsToMapStrings( userCategory, userCategories ) ){

			PrintMessages.print( PrintMessages.guiPrint, "You do not belong in one of the two main categories: curator and designer/developer." );

			return false;
		}

		else if( userCategory.equals( otherCategory ) ) return true;

		else if( userCategory.equals( curatorCategory ) && cCuratorPassword != null && cCuratorPassword.equals( curatorPassword ) ) return true;

		else{

			PrintMessages.print( PrintMessages.guiPrint, "You did not give right curator password." );

			return false;
		}
	}

	public static boolean isAuthorizedForSchemaRegistration( String username, String password ){

		if( username == null || ( username != null && username.toString().equals( "" ) ) ){

			PrintMessages.print( PrintMessages.guiPrint, "You have not inserted your username." );

			return false;
		}

		if( password == null || ( password != null && password.toString().equals( "" ) ) ){

			PrintMessages.print( PrintMessages.guiPrint, "You have not inserted your password." );

			return false;
		}

		else{

			String insertedContent = username + "\n" + password + "\n";

			String storedContent = TxtParser.read( "SchemaRegistrationAuthentication" );


			if( storedContent == null || ( storedContent != null && ! insertedContent.equals( storedContent ) ) ){

				PrintMessages.print( PrintMessages.guiPrint, "You are not an authorized user." );

				return false;
			}

			return true;
		}
	}

	public static boolean check(){

		NetworkInterface network = null;

		try{ network = NetworkInterface.getByInetAddress( InetAddress.getLocalHost() ); }

		catch( SocketException ex ){}
		catch( UnknownHostException ex ){}


		byte[] mac = null;

		try{ mac = network.getHardwareAddress(); }

		catch ( SocketException ex ) {}


		//System.out.print( "Current MAC address: " );

		StringBuilder sb = new StringBuilder();

		for( int i = 0; i < mac.length; i++ ) sb.append( String.format( "%02X%s", mac[i], i < mac.length - 1 ? "-" : "" ) ); //System.out.println( sb.toString() );

		return MapGetter.keyBelongsToMapStrings( sb.toString(), acceptedMACAddresses );
	}


	//Getters.
	public static String getCuratorCaterory(){

		return curatorCategory;
	}

	public static String getOtherCaterory(){

		return otherCategory;
	}
}
