package serviceBaseTesting;

import java.io.*;
import java.util.Random;

public class DBDataProducer{

	//change these parameters to scale data
	
	private static final int N = 10000;
	private static final int NFAbstrRepresentedInstances = 200000;
	private static final int RepresentativeIfacesToActual = NFAbstrRepresentedInstances;  //this means that each actual interface has exactly 1 instance
	private static final int RepresentativeOperationsToActual = NFAbstrRepresentedInstances;
	private static final int RepresentativeMessagesToActual = NFAbstrRepresentedInstances;
	private static final int RepresentativeMessagesTypesToActual = NFAbstrRepresentedInstances;
	
	//
	
	private static final int RepresentativeIfacesToOperations = 3;
	private static final int RepresentativeOperationsToMessages = 2;	//do not change!!!
	private static final int RepresentativeMessagesToMessageTypes = 2;
	private static final int ActualIfacesToOperations = RepresentativeIfacesToOperations;
	private static final int ActualOperationsToMessages = RepresentativeOperationsToMessages;
	private static final int ActualMessagesToMessageTypes = RepresentativeMessagesToMessageTypes;
	
	public static void main(String[] args){
		
		try{
			
			int abstrID = 1;
			Random rand = new Random();
			
			File dbdataFolder = new File("C:/Users/Dimitris/Documents/DBData");
			
			if(dbdataFolder.exists())
				deleteFolder(dbdataFolder);
			
			dbdataFolder.mkdir();
			
			File file = new File("C:/Users/Dimitris/Documents/AoSBM/src/test/java/serviceBaseTesting/loadRawServiceBaseData.sql");
			if(file.exists())
				file.delete();
			
			FileWriter fstreamLRSBD = new FileWriter("C:/Users/Dimitris/Documents/AoSBM/src/test/java/serviceBaseTesting/loadRawServiceBaseData.sql");
			BufferedWriter LRSBDFile = new BufferedWriter(fstreamLRSBD);
			
			String LRSBD = "LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/Abstraction" + 2*N + ".txt' INTO TABLE `abstractions`" + "\r\n" +
						   "FIELDS TERMINATED BY ',';" + "\r\n" +
						   	"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/Interface" + N + ".txt' INTO TABLE `representativeinterfaces`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/Operation" + N + ".txt' INTO TABLE `representativeoperations`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +
  
							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/Message" + N + ".txt' INTO TABLE `representativemessages`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +
  
							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/MessageType" + N + ".txt' INTO TABLE `representativemessagetypes`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/NfaRanges" + N + ".txt' INTO TABLE `nfabstractionsranges`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/NfaDescriptions" + N + ".txt' INTO TABLE `nfanonfuncdescriptions`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/ServiceInterface" + N + ".txt' INTO TABLE `serviceinterfaces`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/ServiceOperation" + N + ".txt' INTO TABLE `operations`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/ServiceMessage" + N + ".txt' INTO TABLE `messages`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/InterfacesMappings" + N + ".txt' INTO TABLE `interfacesmappings`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/OperationsMappings" + N + ".txt' INTO TABLE `operationsmappings`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/MessagesMappings" + N + ".txt' INTO TABLE `messagesmappings`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/ServiceInstances" + N + ".txt' INTO TABLE `serviceinstances`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedServiceInstances" + N + ".txt' INTO TABLE `representedinstances`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/NonFuncDescriptions" + N + ".txt' INTO TABLE `nonfuncdescriptions`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/QualityProperties" + N + ".txt' INTO TABLE `qualityproperties`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/QPNames" + N + ".txt' INTO TABLE `qppropertiesnames`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/QPRankings" + N + ".txt' INTO TABLE `qprankings`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/PropertiesValues" + N + ".txt' INTO TABLE `propertiesvalues`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +
							
							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedInterfaces" + N + ".txt' INTO TABLE `mappedinterfaces`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedOperations" + N + ".txt' INTO TABLE `mappedoperations`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedMessages" + N + ".txt' INTO TABLE `mappedmessages`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedServiceInterfaces" + N + ".txt' INTO TABLE `representedinterfaces`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/ServiceMessagesTypes" + N + ".txt' INTO TABLE `messagetypes`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/MessagesTypesMappings" + N + ".txt' INTO TABLE `messagetypesmappings`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n" +

							"LOAD DATA LOCAL INFILE 'C:/Users/Dimitris/Documents/DBDATA/RepresentedMessagesTypes" + N + ".txt' INTO TABLE `mappedmessagetypes`" + "\r\n" +
							"FIELDS TERMINATED BY ',';" + "\r\n" +
							"COMMIT;" + "\r\n\r\n";
					
					
			LRSBDFile.write(LRSBD);
			LRSBDFile.close();
			
			
			FileWriter fstream = new FileWriter("C:/Users/Dimitris/Documents/DBData/Abstraction" + 2*N + ".txt");
			BufferedWriter abstractionFile = new BufferedWriter(fstream);
			
			FileWriter fstream1 = new FileWriter("C:/Users/Dimitris/Documents/DBData/Interface" + N + ".txt");
			BufferedWriter representativeInterfaceFile = new BufferedWriter(fstream1);
			
			FileWriter fstream13 = new FileWriter("C:/Users/Dimitris/Documents/DBData/ServiceInterface" + N + ".txt");
			BufferedWriter serviceInterfaceFile = new BufferedWriter(fstream13);
			
			FileWriter fstream2 = new FileWriter("C:/Users/Dimitris/Documents/DBData/Operation" + N + ".txt");
			BufferedWriter representativeOperationFile = new BufferedWriter(fstream2);
			
			FileWriter fstream14 = new FileWriter("C:/Users/Dimitris/Documents/DBData/ServiceOperation" + N + ".txt");
			BufferedWriter serviceOperationFile = new BufferedWriter(fstream14);
			
			FileWriter fstream3 = new FileWriter("C:/Users/Dimitris/Documents/DBData/Message" + N + ".txt");
			BufferedWriter representativeMessageFile = new BufferedWriter(fstream3);
			
			FileWriter fstream15 = new FileWriter("C:/Users/Dimitris/Documents/DBData/ServiceMessage" + N + ".txt");
			BufferedWriter serviceMessageFile = new BufferedWriter(fstream15);
			
			FileWriter fstream4 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + ".txt");
			BufferedWriter representativeMessageTypeFile = new BufferedWriter(fstream4);
			
			FileWriter fstream16 = new FileWriter("C:/Users/Dimitris/Documents/DBData/InterfacesMappings" + N + ".txt");
			BufferedWriter interfaceMappingsFile = new BufferedWriter(fstream16);
			
			FileWriter fstream17 = new FileWriter("C:/Users/Dimitris/Documents/DBData/OperationsMappings" + N + ".txt");
			BufferedWriter operationMappingsFile = new BufferedWriter(fstream17);
			
			FileWriter fstream18 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessagesMappings" + N + ".txt");
			BufferedWriter messageMappingsFile = new BufferedWriter(fstream18);
			
			FileWriter fstream19 = new FileWriter("C:/Users/Dimitris/Documents/DBData/ServiceInstances" + N + ".txt");
			BufferedWriter serviceInstancesFile = new BufferedWriter(fstream19);
			
			FileWriter fstream20 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedServiceInstances" + N + ".txt");
			BufferedWriter representedServiceInstancesFile = new BufferedWriter(fstream20);
			
			FileWriter fstream21 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedServiceInterfaces" + N + ".txt");
			BufferedWriter representedServiceInterfacesFile = new BufferedWriter(fstream21);
			
			FileWriter fstream22 = new FileWriter("C:/Users/Dimitris/Documents/DBData/QualityProperties" + N + ".txt");
			BufferedWriter qualityPropertiesFile = new BufferedWriter(fstream22);
			
			FileWriter fstream23 = new FileWriter("C:/Users/Dimitris/Documents/DBData/NonFuncDescriptions" + N + ".txt");
			BufferedWriter NonFuncDescriptionsFile = new BufferedWriter(fstream23);
			
			FileWriter fstream24 = new FileWriter("C:/Users/Dimitris/Documents/DBData/QPNames" + N + ".txt");
			BufferedWriter QPNamesFile = new BufferedWriter(fstream24);
			
			FileWriter fstream25 = new FileWriter("C:/Users/Dimitris/Documents/DBData/QPRankings" + N + ".txt");
			BufferedWriter QPRankingsFile = new BufferedWriter(fstream25);
			
			FileWriter fstream26 = new FileWriter("C:/Users/Dimitris/Documents/DBData/PropertiesValues" + N + ".txt");
			BufferedWriter PropertiesValuesFile = new BufferedWriter(fstream26);
			
			FileWriter fstream27 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedOperations" + N + ".txt");
			BufferedWriter representedOperationsFile = new BufferedWriter(fstream27);
			
			FileWriter fstream28 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedMessages" + N + ".txt");
			BufferedWriter representedMessagesFile = new BufferedWriter(fstream28);
			
			FileWriter fstream29 = new FileWriter("C:/Users/Dimitris/Documents/DBData/ServiceMessagesTypes" + N + ".txt");
			BufferedWriter serviceMessageTypesFile = new BufferedWriter(fstream29);
			
			FileWriter fstream30 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessagesTypesMappings" + N + ".txt");
			BufferedWriter messageTypesMappingsFile = new BufferedWriter(fstream30);
			
			FileWriter fstream31 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedMessagesTypes" + N + ".txt");
			BufferedWriter representedMessageTypesFile = new BufferedWriter(fstream31);
			
			FileWriter fstream32 = new FileWriter("C:/Users/Dimitris/Documents/DBData/RepresentedInterfaces" + N + ".txt");
			BufferedWriter representedInterfacesFile = new BufferedWriter(fstream32);
			
			int interfaceIncrementalID = 0;
			int operationIncrementalID = 0;
			int messageIncrementalID = 0;
			int messageTypeIncrementalID = 0;
			int nfaDescriptionIncrementalID = 0;
			int nfaRangesIncrementalID = 0;
			int serviceInstancesIncrementalID = 0;
			int representedMessagesIncrementalID = 0;
			int representedMessageTypesIncrementalID = 0;
			
			//fabstractions
			for (int i = 0; i < N; i++){
				abstractionFile.write( i + "," + i + ",-1,FUNCTIONAL,1 \r\n");
			}
			//nfabstractions
			for (int i = N; i < 2*N; i++){
				abstractionFile.write( i + ",-1," + i + ",NONFUNCTIONAL,1 \r\n");
			}
			
			
			int cOperation = 0;
			int cMessage = 0;
			int cMessageType = 0;
			int scalingFactor = RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes;
			int scalingFactor2 = RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes;
			for (int i3 = 0; i3 < scalingFactor*(N/2); i3++){
				if (i3 % scalingFactor == 0){
					representativeInterfaceFile.write( i3/scalingFactor + ",iface_name" + ",iface_profile" + ",iface_behav" + ",iface_constraint," + i3/scalingFactor + "\r\n");
					interfaceMappingsFile.write( i3/scalingFactor + "," + 0 + "," + i3/scalingFactor + "\r\n"); //interfacesMappings
				}
				
				if (i3 % scalingFactor2 == 0){
					representativeOperationFile.write( i3/scalingFactor2 + ",operation_name" + ",operation_profile" + ",operation_pre" + ",operation_post," + i3/scalingFactor + "\r\n");
					operationMappingsFile.write( i3/scalingFactor2 + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					representativeMessageFile.write( i3/RepresentativeMessagesToMessageTypes + ",message_name," + 1 + ",message_type," + i3/scalingFactor2 + "\r\n");
					messageMappingsFile.write( i3/RepresentativeMessagesToMessageTypes + "," + 0 + ",IN," + i3/scalingFactor2 + "\r\n");
				}

				representativeMessageTypeFile.write( i3 + ",message_type_name" + ",message_type_prefix" + ",message_type_kind," + "message_type," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				messageTypeIncrementalID++;
				messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
			}
			
			for (int i3 = scalingFactor*(N/2); i3 < scalingFactor*(N/2 + N/100); i3++){
				if (i3 % scalingFactor == 0){
					representativeInterfaceFile.write( i3/scalingFactor + ",Weather" + ",iface_profile" + ",iface_behav" + ",iface_constraint," + i3/scalingFactor + "\r\n");
					interfaceMappingsFile.write( i3/scalingFactor + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % scalingFactor2 == 0){
					representativeOperationFile.write( i3/scalingFactor2 + ",getHumidity" + ",operation_profile" + ",operation_pre" + ",operation_post," + i3/scalingFactor + "\r\n");
					operationMappingsFile.write( i3/scalingFactor2 + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					representativeMessageFile.write( i3/RepresentativeMessagesToMessageTypes + ",response," + 1 + ",message_type," + i3/scalingFactor2 + "\r\n");
					messageMappingsFile.write( i3/RepresentativeMessagesToMessageTypes + "," + 0 + ",IN," + i3/scalingFactor2 + "\r\n");
				}
				
				representativeMessageTypeFile.write( messageTypeIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_type_kind," + "Double," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				messageTypeIncrementalID++;
				messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				
			}
			
			for (int i3 = scalingFactor*(N/2 + N/100); i3 < scalingFactor*(N/2 + N/100 + N/1000); i3++){
				if (i3 % scalingFactor == 0){
					representativeInterfaceFile.write( i3/scalingFactor + ",Temperature" + ",iface_profile" + ",iface_behav" + ",iface_constraint," + i3/scalingFactor + "\r\n");
					interfaceMappingsFile.write( i3/scalingFactor + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % scalingFactor2 == 0){
					representativeOperationFile.write( i3/scalingFactor2 + ",getTemperature" + ",operation_profile" + ",operation_pre" + ",operation_post," + i3/scalingFactor + "\r\n");
					operationMappingsFile.write( i3/scalingFactor2 + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					representativeMessageFile.write( i3/RepresentativeMessagesToMessageTypes + ",ack," + 1 + ",message_type," + i3/scalingFactor2 + "\r\n");
					messageMappingsFile.write( i3/RepresentativeMessagesToMessageTypes + "," + 0 + ",IN," + i3/scalingFactor2 + "\r\n");
				}
				
				representativeMessageTypeFile.write( messageTypeIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_type_kind," + "Float," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				messageTypeIncrementalID++;
				messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
			}
			
			for (int i3 = scalingFactor*(N/2 + N/100 + N/1000); i3 < scalingFactor*(N/2 + N/100 + N/1000) + scalingFactor*N/1000000; i3++){
				if (i3 % scalingFactor == 0){
					representativeInterfaceFile.write( i3/scalingFactor + ",BookRoom" + ",iface_profile" + ",iface_behav" + ",iface_constraint," + i3/scalingFactor + "\r\n");
					interfaceMappingsFile.write( i3/scalingFactor + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % scalingFactor2 == 0){
					representativeOperationFile.write( i3/scalingFactor2 + ",getAvailability" + ",operation_profile" + ",operation_pre" + ",operation_post," + i3/scalingFactor + "\r\n");
					operationMappingsFile.write( i3/scalingFactor2 + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					representativeMessageFile.write( i3/RepresentativeMessagesToMessageTypes + ",ret," + 1 + ",message_type," + i3/scalingFactor2 + "\r\n");
					messageMappingsFile.write( i3/RepresentativeMessagesToMessageTypes + "," + 0 + ",IN," + i3/scalingFactor2 + "\r\n");
				}
				
				representativeMessageTypeFile.write( messageTypeIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_type_kind," + "Int," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				messageTypeIncrementalID++;
				messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
			}
			
			for (int i3 = scalingFactor*(N/2 + N/100 + N/1000) + scalingFactor*N/1000000; i3 < scalingFactor*N; i3++){
				if (i3 % scalingFactor == 0){
					representativeInterfaceFile.write( i3/scalingFactor + ",iface_name" + ",iface_profile" + ",iface_behav" + ",iface_constraint," + i3/scalingFactor + "\r\n");
					interfaceMappingsFile.write( i3/scalingFactor + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % scalingFactor2 == 0){
					representativeOperationFile.write( i3/scalingFactor2 + ",operation_name" + ",operation_profile" + ",operation_pre" + ",operation_post," + i3/scalingFactor + "\r\n");
					operationMappingsFile.write( i3/scalingFactor2 + "," + 0 + "," + i3/scalingFactor + "\r\n");
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					representativeMessageFile.write( i3/RepresentativeMessagesToMessageTypes + ",message_name," + 1 + ",message_type," + i3/scalingFactor2 + "\r\n");
					messageMappingsFile.write( i3/RepresentativeMessagesToMessageTypes + "," + 0 + ",IN," + i3/scalingFactor2 + "\r\n");
				}
				
				representativeMessageTypeFile.write( i3 + ",message_type_name" + ",message_type_prefix" + ",message_type_kind," + "message_type," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
				messageTypeIncrementalID++;
				messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\r\n");
			}
			
			//-----------------------------------------------------------------------------------
			
			
			for (int i3 = 0; i3 < RepresentativeIfacesToActual*scalingFactor*(N/2); i3++){
				if (i3 % scalingFactor == 0){
					serviceInterfaceFile.write(interfaceIncrementalID + ",siface_name" + ",siface_profile" + ",siface_behav" + ",siface_constraint," + 1 + "\r\n");
					representedServiceInterfacesFile.write(interfaceIncrementalID + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					representedInterfacesFile.write(interfaceIncrementalID + "," + interfaceIncrementalID + "," + "\\N" + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					interfaceIncrementalID++;
				}
				
				if (i3 % scalingFactor2 == 0){
					serviceOperationFile.write( operationIncrementalID + ",soperation_name" + ",soperation_profile" + ",soperation_pre" + ",soperation_post," + (interfaceIncrementalID - 1) + "\r\n");
					representedOperationsFile.write(operationIncrementalID + "," + operationIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "\r\n");
					operationIncrementalID++;
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					serviceMessageFile.write(messageIncrementalID + ",message_name," + 1 + ",message_type," + (operationIncrementalID - 1) + "\r\n");
					representedMessagesFile.write(messageIncrementalID + "," + messageIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "\r\n");
					messageIncrementalID++;
					
				}

				serviceMessageTypesFile.write( representedMessageTypesIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_tk," + "message_type," + (messageIncrementalID - 1) + "\r\n");;
				representedMessageTypesFile.write(representedMessageTypesIncrementalID + "," + representedMessageTypesIncrementalID + "," + "\\N"  + "," + i3/RepresentativeMessagesTypesToActual + "," + i3/RepresentativeMessagesTypesToActual + "\r\n");
				representedMessageTypesIncrementalID++;
				//messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\n");
			}
			
			for (int i3 = RepresentativeIfacesToActual*scalingFactor*(N/2); i3 < RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100); i3++){
				if (i3 % scalingFactor == 0){
					serviceInterfaceFile.write(interfaceIncrementalID + ",predictWeather" + ",siface_profile" + ",siface_behav" + ",siface_constraint," + 1 + "\r\n");
					representedServiceInterfacesFile.write(interfaceIncrementalID + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					representedInterfacesFile.write(interfaceIncrementalID + "," + interfaceIncrementalID + "," + "\\N" + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					interfaceIncrementalID++;
				}
				
				if (i3 % scalingFactor2 == 0){
					serviceOperationFile.write( operationIncrementalID + ",getHumidity" + ",soperation_profile" + ",soperation_pre" + ",soperation_post," + (interfaceIncrementalID - 1) + "\r\n");
					representedOperationsFile.write(operationIncrementalID + "," + operationIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "\r\n");
					operationIncrementalID++;
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					serviceMessageFile.write(messageIncrementalID + ",response," + 1 + ",message_type," + (operationIncrementalID - 1) + "\r\n");
					representedMessagesFile.write(messageIncrementalID + "," + messageIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "\r\n");
					messageIncrementalID++;
				}
				
				serviceMessageTypesFile.write( representedMessageTypesIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_tk," + "Double," + (messageIncrementalID - 1) + "\r\n");;
				representedMessageTypesFile.write(representedMessageTypesIncrementalID + "," + representedMessageTypesIncrementalID + "," + "\\N"  + "," + i3/RepresentativeMessagesTypesToActual + "," + i3/RepresentativeMessagesTypesToActual + "\r\n");
				representedMessageTypesIncrementalID++;
				//messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\n");
				
			}
			
			for (int i3 = RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100); i3 < RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100 + N/1000); i3++){
				if (i3 % scalingFactor == 0){
					serviceInterfaceFile.write(interfaceIncrementalID + ",showTemperature" + ",siface_profile" + ",siface_behav" + ",siface_constraint," + 1 + "\r\n");
					representedServiceInterfacesFile.write(interfaceIncrementalID + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					representedInterfacesFile.write(interfaceIncrementalID + "," + interfaceIncrementalID + "," + "\\N" + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					interfaceIncrementalID++;
				}
				
				if (i3 % scalingFactor2 == 0){
					serviceOperationFile.write( operationIncrementalID + ",getTemperature" + ",soperation_profile" + ",soperation_pre" + ",soperation_post," + (interfaceIncrementalID - 1) + "\r\n");
					representedOperationsFile.write(operationIncrementalID + "," + operationIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "\r\n");
					operationIncrementalID++;
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					serviceMessageFile.write(messageIncrementalID + ",ack," + 1 + ",message_type," + (operationIncrementalID - 1) + "\r\n");
					representedMessagesFile.write(messageIncrementalID + "," + messageIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "\r\n");
					messageIncrementalID++;
				}
				
				serviceMessageTypesFile.write( representedMessageTypesIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_tk," + "Float," + (messageIncrementalID - 1) + "\r\n");;
				representedMessageTypesFile.write(representedMessageTypesIncrementalID + "," + representedMessageTypesIncrementalID + "," + "\\N"  + "," + i3/RepresentativeMessagesTypesToActual + "," + i3/RepresentativeMessagesTypesToActual + "\r\n");
				representedMessageTypesIncrementalID++;
				//messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\n");
			}
			
			for (int i3 = RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100 + N/1000); i3 < RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100 + N/1000) + RepresentativeIfacesToActual*scalingFactor*N/1000000; i3++){
				if (i3 % scalingFactor == 0){
					serviceInterfaceFile.write(interfaceIncrementalID + ",BookRoom" + ",siface_profile" + ",siface_behav" + ",siface_constraint," + 1 + "\r\n");
					representedServiceInterfacesFile.write(interfaceIncrementalID + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					representedInterfacesFile.write(interfaceIncrementalID + "," + interfaceIncrementalID + "," + "\\N" + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					interfaceIncrementalID++;
				}
				
				if (i3 % scalingFactor2 == 0){
					serviceOperationFile.write( operationIncrementalID + ",getAvailability" + ",soperation_profile" + ",soperation_pre" + ",soperation_post," + (interfaceIncrementalID - 1) + "\r\n");
					representedOperationsFile.write(operationIncrementalID + "," + operationIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "\r\n");
					operationIncrementalID++;
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					serviceMessageFile.write(messageIncrementalID + ",ret," + 1 + ",message_type," + (operationIncrementalID - 1) + "\r\n");
					representedMessagesFile.write(messageIncrementalID + "," + messageIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "\r\n");
					messageIncrementalID++;
				}
				
				serviceMessageTypesFile.write( representedMessageTypesIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_tk," + "Int," + (messageIncrementalID - 1) + "\r\n");
				representedMessageTypesFile.write(representedMessageTypesIncrementalID + "," + representedMessageTypesIncrementalID + "," + "\\N"  + "," + i3/RepresentativeMessagesTypesToActual + "," + i3/RepresentativeMessagesTypesToActual + "\r\n");
				representedMessageTypesIncrementalID++;
				//messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\n");
			}
			
			for (int i3 = RepresentativeIfacesToActual*scalingFactor*(N/2 + N/100 + N/1000) + RepresentativeIfacesToActual*scalingFactor*N/1000000; i3 < RepresentativeIfacesToActual*scalingFactor*N; i3++){
				if (i3 % scalingFactor == 0){
					serviceInterfaceFile.write(interfaceIncrementalID + ",siface_name" + ",siface_profile" + ",siface_behav" + ",siface_constraint," + 1 + "\r\n");
					representedServiceInterfacesFile.write(interfaceIncrementalID + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					representedInterfacesFile.write(interfaceIncrementalID + "," + interfaceIncrementalID + "," + "\\N" + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "," + i3/(RepresentativeIfacesToActual*scalingFactor) + "\r\n");
					interfaceIncrementalID++;
				}
				
				if (i3 % scalingFactor2 == 0){
					serviceOperationFile.write( operationIncrementalID + ",operation_name" + ",soperation_profile" + ",soperation_pre" + ",soperation_post," + (interfaceIncrementalID - 1) + "\r\n");
					representedOperationsFile.write(operationIncrementalID + "," + operationIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "," + i3/(RepresentativeOperationsToActual*scalingFactor2) + "\r\n");
					operationIncrementalID++;
				}
				
				if (i3 % RepresentativeMessagesToMessageTypes == 0){
					serviceMessageFile.write(messageIncrementalID + ",message_name," + 1 + ",message_type," + (operationIncrementalID - 1) + "\r\n");
					representedMessagesFile.write(messageIncrementalID + "," + messageIncrementalID + "," + "\\N"  + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "," + i3/(RepresentativeIfacesToActual*RepresentativeMessagesToMessageTypes) + "\r\n");
					messageIncrementalID++;
				}
				
				serviceMessageTypesFile.write( representedMessageTypesIncrementalID + ",message_type_name" + ",message_type_prefix" + ",message_tk," + "message_type," + (messageIncrementalID - 1) + "\r\n");;
				representedMessageTypesFile.write(representedMessageTypesIncrementalID + "," + representedMessageTypesIncrementalID + "," + "\\N"  + "," + i3/RepresentativeMessagesTypesToActual + "," + i3/RepresentativeMessagesTypesToActual + "\r\n");
				representedMessageTypesIncrementalID++;
				//messageTypesMappingsFile.write( i3 + "," + 0 + "," + i3/RepresentativeMessagesToMessageTypes + "\n");
			}
		
			
			if (N == 1000000 ){
				
				FileInputStream fstream10 = new FileInputStream("C:/Users/Dimitris/Documents/DBData/MessageType" + N + ".txt");
				DataInputStream in = new DataInputStream(fstream10);
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				String strLine;
				
				FileWriter fstream5 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + "_1.txt");
				BufferedWriter MessageTypeSplitFile1 = new BufferedWriter(fstream5);
				
				FileWriter fstream6 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + "_2.txt");
				BufferedWriter MessageTypeSplitFile2 = new BufferedWriter(fstream6);
				
				FileWriter fstream7 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + "_3.txt");
				BufferedWriter MessageTypeSplitFile3 = new BufferedWriter(fstream7);
				
				FileWriter fstream8 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + "_4.txt");
				BufferedWriter MessageTypeSplitFile4 = new BufferedWriter(fstream8);
				
				FileWriter fstream9 = new FileWriter("C:/Users/Dimitris/Documents/DBData/MessageType" + N + "_5.txt");
				BufferedWriter MessageTypeSplitFile5 = new BufferedWriter(fstream9);
				
				int counter = 0;
				while ((strLine = br.readLine()) != null) {
					if (counter >= 10000000 && counter < 20000000){
						MessageTypeSplitFile2.write(strLine + "\r\n");
					}
					else if (counter >= 20000000 && counter < 30000000){
						MessageTypeSplitFile3.write(strLine + "\r\n");
					}
					else if (counter >= 30000000 && counter < 40000000){
						MessageTypeSplitFile4.write(strLine + "\r\n");
					}
					else if (counter >= 40000000 && counter < 50000000){
						MessageTypeSplitFile5.write(strLine + "\r\n");
					}
					else{
						MessageTypeSplitFile1.write(strLine + "\r\n");
					}
					counter++;
				}
				MessageTypeSplitFile1.close();
				MessageTypeSplitFile2.close();
				MessageTypeSplitFile3.close();
				MessageTypeSplitFile4.close();
				MessageTypeSplitFile5.close();
			}
			
			FileWriter fstream11 = new FileWriter("C:/Users/Dimitris/Documents/DBData/NfaRanges" + N + ".txt");
			BufferedWriter NfaRangesFile = new BufferedWriter(fstream11);
			
			FileWriter fstream12 = new FileWriter("C:/Users/Dimitris/Documents/DBData/NfaDescriptions" + N + ".txt");
			BufferedWriter NfaDescriptionsFile = new BufferedWriter(fstream12);
			
			int cQPNames = 0;
			int cQPRankings = 0;
			for (int i = 0; i < N/2; i++){
				NfaRangesFile.write(nfaRangesIncrementalID + ",Price," + 20 + "," + 80 + "," + (i + N) + "\r\n");	
				NfaRangesFile.write(nfaRangesIncrementalID + 1 + ",Availability," + 50 + "," + 100 + "," + (i + N) + "\r\n");		
				NfaRangesFile.write(nfaRangesIncrementalID + 2 + ",Awareness," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 3 + ",Property4," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 4 + ",Property5," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				
				for (int j = 0; j < NFAbstrRepresentedInstances; j++){
					serviceInstancesFile.write(serviceInstancesIncrementalID + ",sinstance_name" + ",sinstance_protocol" + ",sinstance_URI" + ",sinstance_impl_details" + ",sinstance_requirements," + serviceInstancesIncrementalID /*cInstances*/ + "\r\n");
					representedServiceInstancesFile.write(serviceInstancesIncrementalID + "," + (i + N) + "\r\n");
					qualityPropertiesFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)," + serviceInstancesIncrementalID + "\r\n");
					NonFuncDescriptionsFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)" + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)\\weatherforecastservice.wsdl" + ",TemperatureForecastService" + ",sinstance_name," + serviceInstancesIncrementalID + "\r\n");
					
					QPNamesFile.write(cQPNames + ",Price," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 1 + ",Availability," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 1, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 2 + ",Awareness," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 2, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 3 + ",Property4," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 3, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 4 + ",Property5," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 4, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
					
					PropertiesValuesFile.write(cQPNames + ",Price," + (rand.nextInt(61) + 20) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 1 + ",Availability," + (rand.nextInt(51) + 50) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 2 + ",Awareness," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 3 + ",Property4," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 4 + ",Property5," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					
					cQPNames = cQPNames + 5;
					
					serviceInstancesIncrementalID++;
				}
				//cInstances++;
				
				nfaRangesIncrementalID = nfaRangesIncrementalID + 5;
			}
			
			for (int i = N/2; i < N/2 + N/100; i++){
				NfaRangesFile.write(nfaRangesIncrementalID + ",Price," + 10 + "," + 20 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 1 + ",Availability," + 50 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 2 + ",Awareness," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 3 + ",Property4," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 4 + ",Property5," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				
				for (int j = 0; j < NFAbstrRepresentedInstances; j++){
					serviceInstancesFile.write(serviceInstancesIncrementalID + ",WeatherPort" + ",sinstance_protocol" + ",sinstance_URI" + ",sinstance_impl_details" + ",sinstance_requirements," + serviceInstancesIncrementalID /*cInstances*/ + "\r\n");
					representedServiceInstancesFile.write(serviceInstancesIncrementalID + "," + (i + N) + "\r\n");
					qualityPropertiesFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)," + serviceInstancesIncrementalID + "\r\n");
					NonFuncDescriptionsFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)" + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)\\weatherforecastservice.wsdl" + ",TemperatureForecastService" + ",WeatherPort," + serviceInstancesIncrementalID + "\r\n");
					//for (int k = 0; k < 5; k++){
					QPNamesFile.write(cQPNames + ",Price," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 1 + ",Availability," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 1, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 2 + ",Awareness," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 2, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 3 + ",Property4," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 3, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 4 + ",Property5," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 4, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					PropertiesValuesFile.write(cQPNames + ",Price," + (rand.nextInt(11) + 10) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 1 + ",Availability," + (rand.nextInt(51) + 50) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 2 + ",Awareness," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 3 + ",Property4," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 4 + ",Property5," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					//}
					cQPNames = cQPNames + 5;
					serviceInstancesIncrementalID++;
				}
				//cInstances++;
				
				nfaRangesIncrementalID = nfaRangesIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100; i < N/2 + N/100 + N/1000; i++){
				NfaRangesFile.write(nfaRangesIncrementalID + ",Price," + 0 + "," + 10 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 1 + ",Availability," + 50 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 2 + ",Awareness," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 3 + ",Property4," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 4 + ",Property5," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				
				for (int j = 0; j < NFAbstrRepresentedInstances; j++){
					serviceInstancesFile.write(serviceInstancesIncrementalID + ",TemperaturePort" + ",sinstance_protocol" + ",sinstance_URI" + ",sinstance_impl_details" + ",sinstance_requirements," + serviceInstancesIncrementalID /*cInstances*/ + "\r\n");
					representedServiceInstancesFile.write(serviceInstancesIncrementalID + "," + (i + N) + "\r\n");
					qualityPropertiesFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)," + serviceInstancesIncrementalID + "\r\n");
					NonFuncDescriptionsFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)" + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)\\weatherforecastservice.wsdl" + ",TemperatureForecastService" + ",TemperaturePort," + serviceInstancesIncrementalID + "\r\n");
					//for (int k = 0; k < 5; k++){
					QPNamesFile.write(cQPNames + ",Price," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 1 + ",Availability," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 1, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 2 + ",Awareness," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 2, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 3 + ",Property4," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 3, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 4 + ",Property5," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 4, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					PropertiesValuesFile.write(cQPNames + ",Price," + rand.nextInt(10) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 1 + ",Availability," + (rand.nextInt(51) + 50) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 2 + ",Awareness," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 3 + ",Property4," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 4 + ",Property5," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					//}
					cQPNames = cQPNames + 5;
					serviceInstancesIncrementalID++;
				}
				//cInstances++;
				
				nfaRangesIncrementalID = nfaRangesIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100 + N/1000; i < N/2 + N/100 + N/1000 + N/1000000; i++){
				NfaRangesFile.write(nfaRangesIncrementalID + ",Price," + 80 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 1 + ",Availability," + 50 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 2 + ",Awareness," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 3 + ",Property4," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 4 + ",Property5," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				
				for (int j = 0; j < NFAbstrRepresentedInstances; j++){
					serviceInstancesFile.write(serviceInstancesIncrementalID + ",BookRoomPort" + ",sinstance_protocol" + ",sinstance_URI" + ",sinstance_impl_details" + ",sinstance_requirements," + serviceInstancesIncrementalID /*cInstances*/ + "\r\n");
					representedServiceInstancesFile.write(serviceInstancesIncrementalID + "," + (i + N) + "\r\n");
					qualityPropertiesFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)," + serviceInstancesIncrementalID + "\r\n");
					NonFuncDescriptionsFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)" + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)\\weatherforecastservice.wsdl" + ",TemperatureForecastService" + ",BookRoomPort," + serviceInstancesIncrementalID + "\r\n");
					//for (int k = 0; k < 5; k++){
					QPNamesFile.write(cQPNames + ",Price," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 1 + ",Availability," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 1, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 2 + ",Awareness," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 2, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 3 + ",Property4," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 3, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 4 + ",Property5," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 4, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					PropertiesValuesFile.write(cQPNames + ",Price," + (rand.nextInt(21) + 80) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 1 + ",Availability," + (rand.nextInt(51) + 50) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 2 + ",Awareness," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 3 + ",Property4," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 4 + ",Property5," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					//}
					cQPNames = cQPNames + 5;
					serviceInstancesIncrementalID++;
				}
				//cInstances++;
				
				nfaRangesIncrementalID = nfaRangesIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100 + N/1000 + N/1000000; i < N; i++){
				NfaRangesFile.write(nfaRangesIncrementalID + ",Price," + 20 + "," + 80 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 1 + ",Availability," + 50 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 2 + ",Awareness," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 3 + ",Property4," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				NfaRangesFile.write(nfaRangesIncrementalID + 4 + ",Property5," + 0 + "," + 100 + "," + (i + N) + "\r\n");
				
				for (int j = 0; j < NFAbstrRepresentedInstances; j++){
					serviceInstancesFile.write(serviceInstancesIncrementalID + ",sinstance_name" + ",sinstance_protocol" + ",sinstance_URI" + ",sinstance_impl_details" + ",sinstance_requirements," + serviceInstancesIncrementalID /*cInstances*/ + "\r\n");
					representedServiceInstancesFile.write(serviceInstancesIncrementalID + "," + (i + N) + "\r\n");
					qualityPropertiesFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)," + serviceInstancesIncrementalID + "\r\n");
					NonFuncDescriptionsFile.write(serviceInstancesIncrementalID + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)" + ",C:\\Users\\User1\\Desktop\\InputData\\Source(WSDLv1.1)\\weatherforecastservice.wsdl" + ",TemperatureForecastService" + ",sinstance_name," + serviceInstancesIncrementalID + "\r\n");
					//for (int k = 0; k < 5; k++){
					QPNamesFile.write(cQPNames + ",Price," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 1 + ",Availability," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 1, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 2 + ",Awareness," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 2, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
					
					QPNamesFile.write(cQPNames + 3 + ",Property4," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 3, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					QPNamesFile.write(cQPNames + 4 + ",Property5," + serviceInstancesIncrementalID + "\r\n");
						writeQPRankings(cQPNames + 4, cQPRankings, QPRankingsFile);
						cQPRankings = cQPRankings + 4;
						
					PropertiesValuesFile.write(cQPNames + ",Price," + (rand.nextInt(61) + 20) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 1 + ",Availability," + (rand.nextInt(51) + 50) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 2 + ",Awareness," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 3 + ",Property4," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					PropertiesValuesFile.write(cQPNames + 4 + ",Property5," + rand.nextInt(101) + "," + serviceInstancesIncrementalID + "\r\n");
					//}
					cQPNames = cQPNames + 5;
					serviceInstancesIncrementalID++;
				}
				//cInstances++;
				
				nfaRangesIncrementalID = nfaRangesIncrementalID + 5;
			}
			
			
			//-----------------------------------------------------------------
			for (int i = 0; i < N/2; i++){
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + ",Price," + "High," + (i + N) + "\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 1 + ",Availability," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 2 + ",Awareness," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 3 + ",Property4," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 4 + ",Property5," + "Medium," + (i + N) + "\r\n");
				nfaDescriptionIncrementalID = nfaDescriptionIncrementalID + 5;
			}
			
			for (int i = N/2; i < N/2 + N/100; i++){
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + ",Price," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 1 + ",Availability," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 2 + ",Awareness," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 3 + ",Property4," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 4 + ",Property5," + "Medium," + (i + N) + "\r\n");
				nfaDescriptionIncrementalID = nfaDescriptionIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100; i < N/2 + N/100 + N/1000; i++){
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + ",Price," + "Low," + (i + N) + "\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 1 + ",Availability," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 2 + ",Awareness," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 3 + ",Property4," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 4 + ",Property5," + "Medium," + (i + N) + "\r\n");
				nfaDescriptionIncrementalID = nfaDescriptionIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100 + N/1000; i < N/2 + N/100 + N/1000 + N/1000000; i++){
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + ",Price," + "Very High," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 1 + ",Availability," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 2 + ",Awareness," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 3 + ",Property4," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 4 + ",Property5," + "Medium," + (i + N) + "\r\n");
				nfaDescriptionIncrementalID = nfaDescriptionIncrementalID + 5;
			}
			
			for (int i = N/2 + N/100 + N/1000 + N/1000000; i < N; i++){
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + ",Price," + "High," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 1 + ",Availability," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 2 + ",Awareness," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 3 + ",Property4," + "Medium," + (i + N) + "\r\n");
				NfaDescriptionsFile.write(nfaDescriptionIncrementalID + 4 + ",Property5," + "Medium," + (i + N) + "\r\n");
				nfaDescriptionIncrementalID = nfaDescriptionIncrementalID + 5;
			}
			
			
			abstractionFile.write( 2*N + "," + 2*N + "," + "-1,FUNCTIONAL,1" + "\r\n");
			
			representativeInterfaceFile.write( N + ",WeatherService" + ",WeatherService_profile,WeatherService_behav,WeatherService_constraint," + 2*N + "\r\n");
			interfaceMappingsFile.write( N + "," + 0 + "," + 2*N + "\r\n");
			
			for(int i = 0; i < RepresentativeIfacesToActual; i++){
				
				representedInterfacesFile.write( (N*RepresentativeIfacesToActual + i) + "," + (N*RepresentativeIfacesToActual + i) + "," + "\\N" + "," + N + "," + N + "\r\n");
				serviceInterfaceFile.write( (N*RepresentativeIfacesToActual + i) + ",WeatherService_siface,WeatherService_profile,WeatherService_behav,WeatherService_constraint,1" + "\r\n");
				serviceInstancesFile.write( (N*RepresentativeIfacesToActual + i) + ",weather_sinstance,weather_sinstance_protocol,weather_sinstance_URI,weather_sinstance_impl_details,weather_sinstance_requirements," + (N*RepresentativeIfacesToActual + i) + "\r\n");
				representedServiceInterfacesFile.write( (N*RepresentativeIfacesToActual + i) + "," + 2*N + "\r\n");
				
				int op1_id = N*RepresentativeIfacesToActual*ActualIfacesToOperations + i*ActualIfacesToOperations;
				int op2_id = op1_id + 1;
				int op3_id = op2_id + 1;
				
				int inMes1_id = op1_id*ActualOperationsToMessages;
				int outMes1_id = inMes1_id + 1;
				int inMes2_id = inMes1_id + 2;
				int outMes2_id = inMes1_id + 3;
				int inMes3_id = inMes1_id + 4;
				int outMes3_id = inMes1_id + 5;
				
				int inMes1_type1_id = inMes1_id*ActualMessagesToMessageTypes;
				int inMes1_type2_id = inMes1_type1_id + 1;
				int outMes1_type1_id = inMes1_type1_id + 2;
				int outMes1_type2_id = inMes1_type1_id + 3;
				int inMes2_type1_id = inMes1_type1_id + 4;
				int inMes2_type2_id = inMes1_type1_id + 5;
				int outMes2_type1_id = inMes1_type1_id + 6;
				int outMes2_type2_id = inMes1_type1_id + 7;
				int inMes3_type1_id = inMes1_type1_id + 8;
				int inMes3_type2_id = inMes1_type1_id + 9;
				int outMes3_type1_id = inMes1_type1_id + 10;
				int outMes3_type2_id = inMes1_type1_id + 11;
				
				serviceOperationFile.write( op1_id + ",getTemperature" + ",weather_op_profile,weather_op_pre,weather_op_post" + "," + (N*RepresentativeIfacesToActual + i) + "\r\n");
				
				serviceMessageFile.write( inMes1_id + ",getTemperatureInMessage" + ",1" + "," + "IN" + "," + op1_id + "\r\n");
				
				serviceMessageTypesFile.write( inMes1_type1_id + "," + "TemperatureInParamA" + ",message_type_prefix,message_tk,message_type" + "," + inMes1_id + "\r\n");
				serviceMessageTypesFile.write( inMes1_type2_id + "," + "TemperatureInParamB" + ",message_type_prefix,message_tk,message_type" + "," + inMes1_id + "\r\n");
				
				serviceMessageFile.write( outMes1_id + ",getTemperatureOutMessage" + ",1" + "," + "OUT" + "," + op1_id + "\r\n");
				
				serviceMessageTypesFile.write( outMes1_type1_id + "," + "TemperatureOutParamA" + ",message_type_prefix,message_tk,message_type" + "," + outMes1_id + "\r\n");
				serviceMessageTypesFile.write( outMes1_type2_id + "," + "TemperatureOutParamB" + ",message_type_prefix,message_tk,message_type" + "," + outMes1_id + "\r\n");
				
				
				serviceOperationFile.write( op2_id + ",getHumidity" + ",weather_op_profile,weather_op_pre,weather_op_post" + "," + (N*RepresentativeIfacesToActual + i) + "\r\n");
				
				serviceMessageFile.write( inMes2_id + ",getHumidityInMessage" + ",1" + "," + "IN" + "," + op2_id + "\r\n");
				
				serviceMessageTypesFile.write( inMes2_type1_id + "," + "HumidityInParamA" + ",message_type_prefix,message_tk,message_type" + "," + inMes2_id + "\r\n");
				serviceMessageTypesFile.write( inMes2_type2_id + "," + "HumidityInParamB" + ",message_type_prefix,message_tk,message_type" + "," + inMes2_id + "\r\n");
				
				serviceMessageFile.write( outMes2_id + ",getHumidityOutMessage" + ",1" + "," + "OUT" + "," + op2_id + "\r\n");
				
				serviceMessageTypesFile.write( outMes2_type1_id + "," + "HumidityOutParamA" + ",message_type_prefix,message_tk,message_type" + "," + outMes2_id + "\r\n");
				serviceMessageTypesFile.write( outMes2_type2_id + "," + "HumidityOutParamB" + ",message_type_prefix,message_tk,message_type" + "," + outMes2_id + "\r\n");
				
				
				serviceOperationFile.write( op3_id + ",getWind" + ",weather_op_profile,weather_op_pre,weather_op_post" + "," + (N*RepresentativeIfacesToActual + i) + "\r\n");
				
				serviceMessageFile.write( inMes3_id + ",getWindInMessage" + ",1" + "," + "IN" + "," + op3_id + "\r\n");
				
				serviceMessageTypesFile.write( inMes3_type1_id + "," + "WindInParamA" + ",message_type_prefix,message_tk,message_type" + "," + inMes3_id + "\r\n");
				serviceMessageTypesFile.write( inMes3_type2_id + "," + "WindInParamB" + ",message_type_prefix,message_tk,message_type" + "," + inMes3_id + "\r\n");
				
				serviceMessageFile.write( outMes3_id + ",getWindOutMessage" + ",1" + "," + "OUT" + "," + op3_id + "\r\n");
				
				serviceMessageTypesFile.write( outMes3_type1_id + "," + "WindOutParamA" + ",message_type_prefix,message_tk,message_type" + "," + outMes3_id + "\r\n");
				serviceMessageTypesFile.write( outMes3_type2_id + "," + "WindOutParamB" + ",message_type_prefix,message_tk,message_type" + "," + outMes3_id + "\r\n");
			
				representedOperationsFile.write( op1_id + "," + op1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations) + "," + (N*RepresentativeIfacesToOperations) + "\r\n");
				representedOperationsFile.write( op2_id + "," + op2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations + 1) + "," + (N*RepresentativeIfacesToOperations + 1) + "\r\n");
				representedOperationsFile.write( op3_id + "," + op3_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations + 2) + "," + (N*RepresentativeIfacesToOperations + 2) + "\r\n");
				
				representedMessagesFile.write( inMes1_id + "," + inMes1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages) + "\r\n");
				representedMessagesFile.write( outMes1_id + "," + outMes1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "\r\n");
				representedMessagesFile.write( inMes2_id + "," + inMes2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "\r\n");
				representedMessagesFile.write( outMes2_id + "," + outMes2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "\r\n");
				representedMessagesFile.write( inMes3_id + "," + inMes3_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "\r\n");
				representedMessagesFile.write( outMes3_id + "," + outMes3_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "\r\n");
				
				representedMessageTypesFile.write( inMes1_type1_id + "," + inMes1_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes) + "\r\n");
				representedMessageTypesFile.write( inMes1_type2_id + "," + inMes1_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 1) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 1) + "\r\n");
				representedMessageTypesFile.write( outMes1_type1_id + "," + outMes1_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 2) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 2) + "\r\n");
				representedMessageTypesFile.write( outMes1_type2_id + "," + outMes1_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 3) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 3) + "\r\n");
				representedMessageTypesFile.write( inMes2_type1_id + "," + inMes2_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 4) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 4) + "\r\n");
				representedMessageTypesFile.write( inMes2_type2_id + "," + inMes2_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 5) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 5) + "\r\n");
				representedMessageTypesFile.write( outMes2_type1_id + "," + outMes2_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 6) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 6) + "\r\n");
				representedMessageTypesFile.write( outMes2_type2_id + "," + outMes2_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 7) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 7) + "\r\n");
				representedMessageTypesFile.write( inMes3_type1_id + "," + inMes3_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 8) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 8) + "\r\n");
				representedMessageTypesFile.write( inMes3_type2_id + "," + inMes3_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 9) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 9) + "\r\n");
				representedMessageTypesFile.write( outMes3_type1_id + "," + outMes3_type1_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 10) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 10) + "\r\n");
				representedMessageTypesFile.write( outMes3_type2_id + "," + outMes3_type2_id + "," + "\\N" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 11) + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 11) + "\r\n");
				
			}
			
			representativeOperationFile.write( N*RepresentativeIfacesToOperations + ",getTemperature" + ",operation_profile,operation_pre,operation_post," + N + "\r\n");
			representativeOperationFile.write( (N*RepresentativeIfacesToOperations + 1) + ",getHumidity" + ",operation_profile,operation_pre,operation_post," + N + "\r\n");
			representativeOperationFile.write( (N*RepresentativeIfacesToOperations + 2) + ",getWind" + ",operation_profile,operation_pre,operation_post," + N + "\r\n");
			
			operationMappingsFile.write( N*RepresentativeIfacesToOperations + ",0" + "," + N + "\r\n" );
			operationMappingsFile.write( (N*RepresentativeIfacesToOperations + 1) + ",0" + "," + N + "\r\n" );
			operationMappingsFile.write( (N*RepresentativeIfacesToOperations + 2) + ",0" + "," + N + "\r\n" );
			
			representativeMessageFile.write( N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + "," + "getTemperatureInMessage" + ",1,IN" + "," + N*RepresentativeIfacesToOperations + "\r\n");
			representativeMessageFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "," + "getTemperatureOutMessage" + ",1,OUT" + "," + N*RepresentativeIfacesToOperations + "\r\n");
			representativeMessageFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "," + "getHumidityInMessage" + ",1,IN" + "," + (N*RepresentativeIfacesToOperations + 1) + "\r\n");
			representativeMessageFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "," + "getHumidityOutMessage" + ",1,OUT" + "," + (N*RepresentativeIfacesToOperations + 1) + "\r\n");
			representativeMessageFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4)+ "," + "getWindInMessage" + ",1,IN" + "," + (N*RepresentativeIfacesToOperations + 2) + "\r\n");
			representativeMessageFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "," + "getWindOutMessage" + ",1,OUT" + "," + (N*RepresentativeIfacesToOperations + 2) + "\r\n");
			
			messageMappingsFile.write( N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + ",0," + "IN" + "," + N*RepresentativeIfacesToOperations + "\r\n");
			messageMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + ",0," + "OUT" + "," + N*RepresentativeIfacesToOperations + "\r\n");
			messageMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + ",0," + "IN" + "," + (N*RepresentativeIfacesToOperations + 1) + "\r\n");
			messageMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + ",0," + "OUT" + "," + (N*RepresentativeIfacesToOperations + 1) + "\r\n");
			messageMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + ",0," + "IN" + "," + (N*RepresentativeIfacesToOperations + 2) + "\r\n");
			messageMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + ",0," + "OUT" + "," + (N*RepresentativeIfacesToOperations + 2) + "\r\n");
			
			representativeMessageTypeFile.write( N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + "," + "TemperatureInParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 1) + "," + "TemperatureInParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 2) + "," + "TemperatureOutParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 3) + "," + "TemperatureOutParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 4) + "," + "HumidityInParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 5) + "," + "HumidityInParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 6) + "," + "HumidityOutParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 7) + "," + "HumidityOutParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 8) + "," + "WindInParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 9) + "," + "WindInParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 10) + "," + "WindOutParamA" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "\r\n");
			representativeMessageTypeFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 11) + "," + "WindOutParamB" + ",message_type_prefix,message_type_kind, message_type" + "," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "\r\n");
			
			messageTypesMappingsFile.write( N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + ",0," + N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 1) + ",0," + N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 2) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 3) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 1) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 4) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 5) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 2) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 6) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 7) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 3) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 8) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 9) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 4) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 10) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "\r\n");
			messageTypesMappingsFile.write( (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages*RepresentativeMessagesToMessageTypes + 11) + ",0," + (N*RepresentativeIfacesToOperations*RepresentativeOperationsToMessages + 5) + "\r\n");
			
			abstractionFile.close();
			representativeInterfaceFile.close();
			serviceInterfaceFile.close();
			representativeOperationFile.close();
			serviceOperationFile.close();
			serviceMessageFile.close();
			interfaceMappingsFile.close();
			operationMappingsFile.close();
			messageMappingsFile.close();
			representedServiceInterfacesFile.close();
			representativeMessageFile.close();
			representativeMessageTypeFile.close();
			representedOperationsFile.close();
			representedMessagesFile.close();
			serviceMessageTypesFile.close();
			messageTypesMappingsFile.close();
			representedMessageTypesFile.close();
			representedInterfacesFile.close();
			
			NfaRangesFile.close();
			serviceInstancesFile.close();
			representedServiceInstancesFile.close();
			qualityPropertiesFile.close();
			NonFuncDescriptionsFile.close();
			QPNamesFile.close();
			QPRankingsFile.close();
			PropertiesValuesFile.close();
			NfaDescriptionsFile.close();
						
		}catch (Exception e){
			System.err.println("Error: " + e.getMessage());
		}
		
	}
	
	private static void writeQPRankings(int cQPNames, int cQPRankings, BufferedWriter QPRankingsFile){
		try{
	
		QPRankingsFile.write(cQPRankings + ",Low," + cQPNames + "\r\n");
		QPRankingsFile.write(cQPRankings + 1 + ",Medium," + cQPNames + "\r\n");
		QPRankingsFile.write(cQPRankings + 2 + ",High," + cQPNames + "\r\n");
		QPRankingsFile.write(cQPRankings + 3 + ",Very High," + cQPNames + "\r\n");
		
		}catch (Exception e){
			System.err.println("Error: " + e.getMessage());
		}
	}
	
	public static void deleteFolder(File folder) {
	    File[] files = folder.listFiles();
	    if(files!=null) { //some JVMs return null for empty dirs
	        for(File f: files) {
	            if(f.isDirectory()) {
	                deleteFolder(f);
	            } else {
	                f.delete();
	            }
	        }
	    }
	    folder.delete();
	}

}