SELECT COUNT(*) 
FROM representativeinterfaces I, representativeoperations O, representativemessages M, representativemessagetypes T
WHERE ROP_RSI_ID = RSI_ID and RMS_ROP_ID = ROP_ID and RMT_RMS_ID = RMS_ID;

/*--------------------------------------------------------------------------------------------------------*/

SELECT COUNT(*)
FROM representativeinterfaces I, representativeoperations O, representativemessages M, representativemessagetypes T
WHERE ROP_RSI_ID = RSI_ID and RMS_ROP_ID = ROP_ID and RMT_RMS_ID = RMS_ID
AND RSI_NAME LIKE 'Weather';

/*--------------------------------------------------------------------------------------------------------*/

SELECT distinct fa.a_id, fa.a_fa_id, fa.a_nfa_id
FROM servicecollections c,
hierarchies _fa_hierarchies,abstractions fa,
representativeinterfaces ri,
representativeoperations o1,
representativemessages _p1_representativemessages,representativemessagetypes p1
WHERE ri.rsi_name like '%Weather%' AND
o1.rop_name like '%getHumidity%' AND
p1.rmt_typekind like '%Double%' AND 
A_NFA_ID = -1

AND c.C_ID =  _fa_hierarchies.h_c_id
AND  _fa_hierarchies.H_ID = fa.a_h_id
AND fa.A_ID = ri.rsi_a_id
AND ri.RSI_ID = o1.rop_rsi_id
AND o1.ROP_ID =  _p1_representativemessages.rms_rop_id
AND  _p1_representativemessages.RMS_ID = p1.rmt_rms_id;

/*----------------------------------------------------------------------------------*/

SELECT nfa.a_id, nfa.a_fa_id, nfa.a_nfa_id
FROM servicecollections c,
hierarchies _nfa_hierarchies,abstractions nfa,
nfaqp_v pr1,
nfaqp_v pr2
WHERE pr1.qp_name like '%Aware%' AND
pr2.qp_name like '%Availab%' AND
pr2.qp_value like '%High%'

AND c.C_ID =  _nfa_hierarchies.h_c_id
AND  _nfa_hierarchies.H_ID = nfa.a_h_id
AND nfa.A_ID = pr1.nfa_id
AND nfa.A_ID = pr2.nfa_id;

/*----------------------------------------------------------------------------------*/

SELECT distinct c.c_id
FROM servicecollections c,
servicesources s1,
docoffuncproperties d1,
servicetypes st,
serviceinterfaces i1,
operations o1, 
messages m1

WHERE i1.si_name like '%Weather%' AND
o1.op_name like '%getHumidity%' AND
m1.ms_name like '%response%'

AND c.C_ID = s1.ss_sc_id
AND s1.SS_ID = d1.docfuncprops_ss_id
AND d1.docfuncprops_id = st.st_docfuncprops_id
AND st.st_id = i1.si_st_id
AND i1.SI_ID = o1.op_si_id
AND o1.op_id = m1.ms_op_id;

/*-------------------------------------------------------------------------------------*/

SELECT distinct c.c_id
FROM servicecollections c,
servicesources s1,
docoffuncproperties d1,
servicetypes st,
serviceinterfaces i1,
operations o1, 
messages _p1_messages,messagetypes p1

WHERE i1.si_name like '%Weather%' AND
o1.op_name like '%getHumidity%' AND
p1.mt_typekind like '%Double%' 

AND c.C_ID = s1.ss_sc_id
AND s1.SS_ID = d1.docfuncprops_ss_id
AND d1.docfuncprops_id = st.st_docfuncprops_id
AND st.st_id = i1.si_st_id
AND i1.SI_ID = o1.op_si_id
AND o1.OP_ID =  _p1_messages.ms_op_id
AND  _p1_messages.MS_ID = p1.mt_ms_id;

/*-------------------------------------------------------------------------------------*/

SELECT count(*)
FROM servicecollections c,
servicesources s1,
docoffuncproperties d1,
servicetypes st, 
serviceinterfaces i1,
serviceinstances si1,
nonfuncdescriptions nfd1,
propertiesvalues pv1

WHERE pv1.pv_property_name = 'Price' AND
pv1.pv_value >= 10 and pv1.pv_value <= 20

AND c.C_ID = s1.ss_sc_id
AND s1.SS_ID = d1.docfuncprops_ss_id
AND d1.docfuncprops_id = st.st_docfuncprops_id
AND st.st_id = i1.si_st_id
AND i1.SI_ID = si1.sis_si_id
AND si1.SIS_ID =  nfd1.nf_sis_id
AND  nfd1.NF_ID = pv1.pv_nf_id;

/*-------------------------------------------------------------------------------------*/

SELECT count(*)
FROM servicecollections c,
hierarchies _nfa_hierarchies,abstractions nfa,
nfaqp_v pr2
WHERE pr2.qp_name like '%Price%' AND
pr2.qp_value like '%Medium%'

AND c.C_ID =  _nfa_hierarchies.h_c_id
AND  _nfa_hierarchies.H_ID = nfa.a_h_id
AND nfa.A_ID = pr2.nfa_id;

