/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.AoSBM;

import org.ow2.choreos.executable_service_discovery.plugin_manager.CommonServiceDescription;

/**
 * Provides service register and unregister methods to be used by the Plugin 
 * Manager
 */
public interface PluginManagerCallback {
    
    /**
     * Plugin Manager calls this method for every received service description, 
     * either new or updated.
     * 
     * @param service_descriptions The service description in Common Service
     * Description Format
     * @param registryURI the URI of the registry that hosts the specific 
     * service.
     */
    public void register(CommonServiceDescription service_description, String registryURI);
    
    /**
     * Plugin Manager calls this method in order to unregister a service.
     *
     * @param serviceURI the URI of the service to be unregistered .
     * @param registryURI the URI of the associated registry.
     */
    public void unregisterByServiceURI(String serviceURI, String registryURI);

}
