/**
 * @author Kostas Lekkas -- lekkas@vtrip.net
 */
package org.ow2.choreos.executable_service_discovery.plugin_manager;

public interface PassiveDiscovery {
    /**
     * All plugin types must call this to deliver service descriptions for both
     * new and updated services. 
     * 
     * @param service_description The service description in common service 
     * description format
     * @param registryURI the associated registry URI
     * 
     */
    public void register(CommonServiceDescription service_description, String registryURI);
    
    /**
     * Plugins may call this to unregister a service.
     * 
     * @param serviceURI the unregistered service URI
     * @param registryURI the associated registry URI
     */
    public void unregisterByServiceURI(String serviceURI, String registryURI);
    
}
