package org.ow2.choreos.executable_service_discovery.plugin_manager;

/**
 *
 * @author lekkas
 */
public class PluginMsg {
    public static final char MSG_REGISTER = 0x01;
    public static final char MSG_UNREGISTER = 0x02;
    
    private char msgType;
    private CommonServiceDescription serviceDescription;
    private String registryURI;
    private String serviceURI;
    
    /*
     * Constructor for registration/update operations.
     */
    public PluginMsg(char msg_type, 
            CommonServiceDescription service_description, String registryURI) {
        this.msgType = msg_type;
        this.serviceDescription = service_description;
        this.registryURI = registryURI;
        serviceURI = null;
    }
    
    /*
     * Constructor for unregister operations.
     */
    public PluginMsg(char msg_type, String serviceURI, String registryURI) {
        this.msgType = msg_type;
        this.serviceURI = serviceURI;
        this.registryURI = registryURI;
        serviceDescription = null;
    }
    
    public char getMsgType() {
        return msgType;
    }
    
    public CommonServiceDescription getServiceDescription() {
        return serviceDescription;
    }
    
    public String getRegistryURI() {
        return registryURI;
    }
    
    public String getServiceURI() {
        return serviceURI;
    }
}
