package test.java;

import java.util.LinkedList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.ow2.choreos.executable_service_discovery.DummyActiveRegistry.Registry;
import org.ow2.choreos.executable_service_discovery.plugin_manager.PluginManager;


public class PluginManagerTest {

	//private ExecutorService exec;
    private LinkedList<String> list;
    private PluginManager pluginmanager;
   // private static String RegistryServicesDirPath;
    private MockAoSBM aosbm;
    
	@Before
	public void setup() throws Exception {
		/*
		exec = Executors.newSingleThreadExecutor();
		//RegistryServicesDirPath = "dummy_registry_services/";
		
		exec.execute(new Runnable() {
			@Override
			public void run() {
				Registry.getInstance().start(2000, RegistryServicesDirPath, 31337);
		    	try {
		            Registry.getInstance().getConnectionAcceptThread().join();
		        } catch(InterruptedException e) {
		            
		        }
			}
		});*/
    	
        //PluginManager.setConfDir(args[0]);
    	PluginManager.setConfDir("plugin_conf/plugin.properties");
        pluginmanager = PluginManager.getInstance();
        
        aosbm = new MockAoSBM();	
        
    }
	
	@Test
	public void testPluginManager() {
		
		/* Test 0: set retrieve service callback */
		pluginmanager.setRetrieveServiceCallback(aosbm);
		
		/* Test 1: load plugins from file */
        pluginmanager.addPluginsFromConf();
        
        /* Test 2: explicitly load plugin */
        assertFalse(pluginmanager.addPluginType("org.ow2.choreos.executable_service_discovery.DPWSPlugin"));
	
        /* Test 3: get number of available plugins */
        list = pluginmanager.getAvailablePluginTypes();
        assertEquals(1, list.size());
        
        /* Test 4: view number of loaded plugins */
        list = pluginmanager.getLoadedPluginTypes();
        assertEquals(1, list.size());
        
        /* Test 7: create plugin instance */
        assertTrue(pluginmanager.createPluginInstance("" +
        		"org.ow2.choreos.executable_service_discovery.DummyPlugin.DummyPlugin", "localhost:31337"));
        
        /* Test 8: get list of plugin instances for plugintype */
        list = pluginmanager.getPluginInstancesOfType("org.ow2.choreos.executable_service_discovery.DummyPlugin.DummyPlugin");
        assertEquals(1, list.size());
        
	}
	
	@After
	public void cleanup() throws Exception {
		pluginmanager.destroyPluginInstance("" +
				"org.ow2.choreos.executable_service_discovery.DummyPlugin.DummyPlugin", "localhost:31337");
		/*
		Registry.getInstance().stop();
		exec.shutdownNow();
		*/
	}
	
}
