package org.ow2.choreos.registry;

import java.io.IOException;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.ow2.chereos.iots.common.ServiceDescription;

/**
 * Servlet implementation class FindDevices
 */
public class FindDevicesServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public FindDevicesServlet() {
		super();
	}

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("application/json");

		PrintWriter pr = response.getWriter();
		
		String globalRegion = request.getParameter("global_region");
		String[] concepts = request.getParameterValues("concept");

		if ((globalRegion == null) || (concepts == null)) {
			response.sendError(500);
			return;
		}
		try {
			Set<ServiceDescription> result = RegistryMap.findDevice(
					globalRegion, concepts);

			if (result != null) {
				JSONArray ansArray = new JSONArray();
				Map<String, JSONArray> resultMap = new HashMap<String, JSONArray>();

				JSONObject obj = new JSONObject();
				Iterator<ServiceDescription> iter = result.iterator();
				int i = 0;
				while (iter.hasNext()) {
					JSONObject serviceObject = iter.next().serializeAsJSON();
					ansArray.add(serviceObject);

					resultMap.put("value", ansArray);
					i = i + 1;
				}

				obj.putAll(resultMap);
				obj.writeJSONString(pr);

			}

			else
				response.sendError(400);

		} catch (Exception e) {
			response.sendError(500);
		}
	}

}
