package fr.inria.arles.choreos.iots.common;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.ow2.choreos.queryiotsmanager.datatypes.DefaultDouble2dLocationData;

public class Service {
	String myType, mySensorType, myAddress, myTypeOfCoverage;
	double myProbabilityThreshold;
	double mySensingRange;
	double myRequiredAccuracy, mySensingAccuracy;
	Map<Integer, ArrayList<Double>> myEstimatedPath;
	double myRequiredNeighbors;
	// ArrayList<Location> myLocationsOfInterest;
	Location myCoveredLocation, myGlobalLocation;
	DefaultDouble2dLocationData myLocation;
	String myPhysicalConcept;
	String myMeasuredDataType;
	double myCoordinateX, myCoordinateY;
	String myName;
	String myDeviceId;
	String myUnit;

	/*
	 * public Service(String serviceType, double requiredServiceAccuracy, double
	 * sensingAccuracy, String sensorType, double sensingRange, double
	 * requiredProbabilityThreshold, String typeOfCoverage, double
	 * requiredNeighbors, ArrayList<String> locationsOfInterest, String
	 * coveredLocation) { myType = serviceType; myRequiredAccuracy =
	 * requiredServiceAccuracy; mySensingAccuracy = sensingAccuracy;
	 * mySensorType = sensorType; mySensingRange = sensingRange;
	 * myProbabilityThreshold = requiredProbabilityThreshold; myTypeOfCoverage =
	 * typeOfCoverage; myRequiredNeighbors = requiredNeighbors; for (int i = 0;
	 * i < locationsOfInterest.size(); i++) myLocationsOfInterest.add(new
	 * Location(locationsOfInterest.get(i))); myCoveredLocation = new
	 * Location(coveredLocation);
	 * 
	 * }
	 */

	public Service(String deviceId, String serviceName, String serviceType,
			double sensingAccuracy, String sensorType, String concept,
			double sensingRange, double requiredProbabilityThreshold,
			String accessAddress, String measuredDataType,
			double locationCoordinateX, double locationCoordinateY, String unit) {
		myType = serviceType;
		myName = serviceName;
		mySensingAccuracy = sensingAccuracy;
		mySensorType = sensorType;
		mySensingRange = sensingRange;
		myProbabilityThreshold = requiredProbabilityThreshold;
		myPhysicalConcept = concept;
		myDeviceId = deviceId;
		myAddress = accessAddress;
		myMeasuredDataType = measuredDataType;
		myCoordinateX = locationCoordinateX;
		myCoordinateY = locationCoordinateY;
		myUnit = unit;
	}

	public String getServiceName() {
		return myName;
	}

	public String getDeviceId() {
		return myDeviceId;
	}

	public String getUnit() {
		return myUnit;
	}

	public Location getGlobalRegion() {
		// GETS REGION AND CREATES A NEW LOCATION

		Location Paris = new Location("Paris");
		// Paris.setArea(1771500);
		myGlobalLocation = Paris;

		return myGlobalLocation;
	}

	// TODO USING THIS I DEFINED MY GLOBAL REGION
	// public ArrayList<Double> getLocationCoordinates() {

	// return myLocation;
	// }
	public DefaultDouble2dLocationData getLocationCoordinates() {
		return myLocation;
	}

	public String getMeasuredDataType() {
		return myMeasuredDataType;
	}

	public void setLocation(DefaultDouble2dLocationData xyCoordinates) {
		myLocation = xyCoordinates;
	}

	public void setCoordinateX(double x) {
		myCoordinateX = x;
	}

	public double getCoordinateX() {
		return myCoordinateX;
	}

	public void setCoordinateY(double y) {
		myCoordinateY = y;
	}

	public double getCoordinateY() {
		return myCoordinateY;
	}

	public void setUnit(String unit) {
		myUnit = unit;
	}

	public Map<Integer, ArrayList<Double>> getEstimatedPath() {

		// Map<Integer, ArrayList<Double>> locations = new HashMap<Integer,
		// ArrayList<Double>>();
		// ArrayList<Double> xyCoordinates = new ArrayList<Double>();

		/*
		 * xyCoordinates.add(3.0); xyCoordinates.add(2.0); locations.put(2,
		 * xyCoordinates);
		 * 
		 * xyCoordinates = new ArrayList<Double>(); xyCoordinates.add(4.0);
		 * xyCoordinates.add(5.0); locations.put(3, xyCoordinates);
		 * 
		 * xyCoordinates = new ArrayList<Double>(); xyCoordinates.add(4.0);
		 * xyCoordinates.add(5.0); locations.put(4, xyCoordinates);
		 * 
		 * xyCoordinates = new ArrayList<Double>(); xyCoordinates.add(4.0);
		 * xyCoordinates.add(5.0); locations.put(5, xyCoordinates);
		 * 
		 * xyCoordinates = new ArrayList<Double>(); xyCoordinates.add(4.0);
		 * xyCoordinates.add(5.0); locations.put(6, xyCoordinates);
		 */

		// myEstimatedPath = locations;
		return myEstimatedPath;
	}

	public String getServiceType() {
		return myType;
	}

	public double getServiceAccuracy() {
		return mySensingAccuracy;
	}

	public String getTypeOfServiceSensor() {
		return mySensorType;
	}

	public double getServiceRange() {
		return mySensingRange;
	}

	public double getServiceProbThreshold() {
		return myProbabilityThreshold;
	}

	// HOW WILL THE SERVICE KNOW ITS ADDRESS?
	public String getServiceAddress() {
		return myAddress;
	};

	public String getConcept() {
		return myPhysicalConcept;
	};

	// TODO the method should actually get the path from somewhere
	public void setEstimatedPath(Map<Integer, ArrayList<Double>> path) {
		myEstimatedPath = path;

	}

	// TODO REGION SHOULD BE PROVIDED BY THE ONTOLOGY BASED ON XY COORDINATES
	public void setGlobalRegion(String region) {

		myGlobalLocation = new Location(region);
	}

}
