package org.ow2.choreos.datarepository;

import org.json.simple.JSONObject;

import fr.inria.arles.choreos.iots.common.Constants;

public class DataDescription {

	private static final String DATASTRING = "dataString";
	private static final String ADDRESS = "address";
	private static final String NAME = "name";
	private static final String DEVICEID = "DeviceId";
	private static final String DATADOUBLE = "dataDouble";
	private static final String GLOBALREGION = "global_region";
	private static final String UNIT = "unit";
	private static final String SENSOR = "sensor";
	private static final String CONCEPT = "concept";
	private static final String DATATYPE = "dataType";
	String deviceID;
	String address;
	String name;
	Double myDataDouble, myDataDouble1, myDataDouble2, myDataDouble3;
	Long myDataLong;
	Integer myDataInteger;
	String unit;
	String globalRegion;
	String dataString;
	String sensor;
	String concept;
	String dataType;

	private DataDescription() {
		// empty cons. needed for deserialization
	}

	public DataDescription(String deviceID, String address, String name,
			String dataString, double dataDouble, String globalRegion,
			String unit, String sensor, String concept, String dataType) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.myDataDouble = dataDouble;
		this.dataString = dataString;
		this.globalRegion = globalRegion;
		this.unit = unit;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
	}

	public DataDescription(String deviceID, String address, String name,
			String dataString, double dataDouble1, double dataDouble2,
			String globalRegion, String unit, String sensor, String concept,
			String dataType) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.myDataDouble1 = dataDouble1;
		this.myDataDouble2 = dataDouble2;
		this.dataString = dataString;
		this.globalRegion = globalRegion;
		this.unit = unit;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
	}

	public DataDescription(String deviceID, String address, String name,
			String dataString, double dataDouble1, double dataDouble2,
			double dataDouble3, String globalRegion, String unit,
			String sensor, String concept, String dataType) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.myDataDouble1 = dataDouble1;
		this.myDataDouble2 = dataDouble2;
		this.myDataDouble3 = dataDouble3;
		this.dataString = dataString;
		this.globalRegion = globalRegion;
		this.unit = unit;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
	}

	public DataDescription(String deviceID, String address, String name,
			String dataString, long dataLong, String globalRegion, String unit,
			String sensor, String concept, String dataType) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.myDataLong = dataLong;
		this.dataString = dataString;
		this.globalRegion = globalRegion;
		this.unit = unit;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
	}

	public DataDescription(String deviceID, String address, String name,
			String dataString, int dataInteger, String globalRegion,
			String unit, String sensor, String concept, String dataType) {
		super();
		this.deviceID = deviceID;
		this.address = address;
		this.name = name;
		this.myDataInteger = dataInteger;
		this.dataString = dataString;
		this.globalRegion = globalRegion;
		this.unit = unit;
		this.sensor = sensor;
		this.concept = concept;
		this.dataType = dataType;
	}

	public String getDeviceID() {
		return deviceID;
	}

	public String getDataType() {
		return dataType;
	}

	public double getDataDouble1() {
		return myDataDouble1;
	}

	public double getDataDouble2() {
		return myDataDouble2;
	}

	public double getDataDouble3() {
		return myDataDouble3;
	}

	public long getDataLong() {
		return myDataLong;
	}

	public int getDataInteger() {
		return myDataInteger;
	}

	public String getAddress() {
		return address;
	}

	public String getName() {
		return name;
	}

	public String getUnit() {
		return unit;
	}

	public double getdataDouble() {
		return myDataDouble;
	}

	public String getGlobalRegion() {
		return globalRegion;
	}

	public String getDataString() {
		return dataString;
	}

	public String getSensor() {
		return sensor;
	}

	public String getConcept() {
		return concept;
	}

	public JSONObject serializeAsJSON() {
		JSONObject ret = new JSONObject();

		ret.put(DATADOUBLE, myDataDouble);
		ret.put(ADDRESS, address);
		ret.put(NAME, name);
		ret.put(CONCEPT, concept);
		ret.put(DEVICEID, deviceID);
		ret.put(GLOBALREGION, globalRegion);
		ret.put(DATASTRING, dataString);
		ret.put(UNIT, unit);
		ret.put(SENSOR, sensor);
		ret.put(DATATYPE, dataType);
		System.out.println(dataType);
		return ret;

	}

	public static DataDescription deserializeFromJSONObject(JSONObject j) {
		DataDescription temp = new DataDescription();
		System.out.println(j.get(DATATYPE) + " " + j.get(CONCEPT));
		if (j.get(DATATYPE).equals(Constants.DOUBLE)
				|| j.get(DATATYPE).equals(Constants.DOUBLENOISE)
				|| j.get(DATATYPE).equals(Constants.DOUBLESOUND)
				|| j.get(DATATYPE).equals(Constants.DOUBLETEMPERATUREC)
				|| j.get(DATATYPE).equals(Constants.DOUBLETEMPERATUREF)) {
			temp.myDataDouble = Double
					.parseDouble(j.get(DATADOUBLE).toString());
			temp.address = j.get(ADDRESS).toString();
			temp.name = j.get(NAME).toString();
			temp.concept = j.get(CONCEPT).toString();
			temp.globalRegion = j.get(GLOBALREGION).toString();
			temp.sensor = j.get(SENSOR).toString();
			temp.dataString = j.get(DATASTRING).toString();
			temp.deviceID = j.get(DEVICEID).toString();
			temp.unit = j.get(UNIT).toString();
			temp.dataType = j.get(DATATYPE).toString();
		}

		return temp;

	}

}
