(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     22365,        761]
NotebookOptionsPosition[     18412,        615]
NotebookOutlinePosition[     18765,        631]
CellTagsIndexPosition[     18722,        628]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.557567319325137*^9, 3.557567340022554*^9}, {
  3.5575673995064697`*^9, 3.557567400256424*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", " ", "=", " ", 
  RowBox[{"40", "*", 
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", "0.1"}], "*", "x"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5575681708691807`*^9, 3.557568200684677*^9}, {
  3.557568248595725*^9, 3.55756828353141*^9}}],

Cell[BoxData[
 RowBox[{"40", " ", 
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", "0.1`"}], " ", "x"}]]}]], "Output",
 CellChangeTimes->{
  3.557568202579815*^9, {3.557568249106798*^9, 3.5575682837595367`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"plot", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.5575682050377293`*^9, 3.557568207403914*^9}}],

Cell[BoxData[
 RowBox[{"plot", "[", 
  RowBox[{"60", " ", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"0.01`", " ", "x"}]]}], "]"}]], "Output",
 CellChangeTimes->{3.5575682080086184`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"f", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.557568209770055*^9, 3.557568215437068*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Plot", "::", "pllim"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Range specification \[NoBreak]\\!\\(x\\)\[NoBreak] is not \
of the form {x, xmin, xmax}. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Plot/pllim\\\", ButtonNote -> \
\\\"Plot::pllim\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.557568216116238*^9}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"f", ",", "x"}], "]"}]], "Output",
 CellChangeTimes->{3.5575682161171923`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"f", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "60"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5575682199805393`*^9, 3.5575682449473553`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVkX081Accx8Wa0+amoziRVajoPN/J4/erE45+pgdZhRJH21DLs9wqWfSw
lKfMysuZtLEocXW/btyuhF5rUs5dZzEZvfTAne7OQ2s3++Pzev/1/uf9WbX/
4Dauvp6eHrGw/6kd6rlne6bVny+YGNDp2NhfbZETIC8BS461eYWWjbisd7+F
vBYm03M6Xd6wMTOiQWYgb4HNCZEJaQo2Lp00L5mTScCdmnWI0cbGYVH4QbXs
MUTNpqoPf8XGINuXz1Sy52BWtS6VObgJ52Se5UrZNHT3LI9a3xWAd9lX6/pq
DTDfoaKcEwZoNSwc37/BGF1WXfhCed8HzZL3NhiyTXFR5eXh7wQbscQ16E54
pAWmV8wzmZ1MfFrpIlaZWGN3oPJqSJQ7nqk72qtPX4V+Wwf5iQauaF42eqr0
8hpUpM5mJ+k5YeEOjv9jrR1Gr7CqTr3mgGle/L09+euQJXONeZ63FgOn5nNT
Rx3wUZzzpWmFLR733RpnuZGBM5rleVeKV6N30/et33Q4o1Tw4gh7z6eYPKs6
1m3siixGuOAUzRrnHE2GGJFuONFi/8PScjr6Nv5SU1HhjvYVmc67zy9HFS10
306JBwa9u0eh08zw77P7dh42ZKF0qLc84tpS5ExlccZYnujR8mOiJvETfB1P
SWs9uhF99bWf/XP5o4We5vqFEi9sGunIi/mcgrSH9ueuT3mj2LSB0lC3GK2K
miNYLF8c4uwLZBgbYKWjl4lpkh9advP41RN6+MAygPn2gj/m5kRTaPR/wdtK
ct55AHAk8kRFRsE8UA1q0+PyEZkJ2SVtxTOw8riN7y77AJztSdvBI9VgZBct
2Lbwm31xRxE3eBqc/OjNWTGbUPCirC87QAmHh2h3Q/XY6N1hh901r2Hq7dlI
TiUblV2Wpz2SJyDY+X4VhxGI58y+TDHij0P7W593M38E4tbwP4/UqEYhdYOb
oo+7GWOjG10WkyPgN5nQv8soCPXbT1JPuA/DZlsLwrg2CK1/KxOxbwzCumOn
syWewRi7hc68WysHB65Xh50iGN0VoojtN6XAbT9Q0Pp1CKojnit0QU+go6Y/
QbWMgw1KNCLVj0D9k27G+RYHX602dJkYewjxdo1GVUQoFpq3ZW0vfwAqh1JW
izIUmyNtChhJXXC77t2IpigMp4UN4/5d92B34Br0WbkFiWdu70meBFakFAqd
xFuQfqSrfU2YGJYtSb5BRBGo18OzCtGIoI7Ny1XuIpCeaGRIGReBG+8cuzSa
QI/6qrneARGEK69L5XEECj3GxrJui+DkgGYuPpnA+SVe3LV5IpitPbop9ziB
JsXUqEWLRaDwKX1S30ggxeGYT4HVHTiQUXeJ00TgI7ckGz/qHdA2tXFfXycw
nc8seq8jgbZaPuMqILB17Ka8bJSEMIq11a9iAj2XPP3QupEEUX99whMpgd+m
1Due9yEhlHqbkSlf8C/EFHYwSJAH92gtBgk8kFG5XmtDgpp8VRT7F4Gx1BC3
nA9IYPBdrk28JPCQf+eE9KEQRIqAzLNvCNSflFBBLIRQs+3grCQwn5TuaW4R
QmJhRl+6hsCPw9fvvXJRCGrxySrzWQKdoseNHU8LIX/+Yjw5T2C86Q3prTwh
mHj8vCHmPYGCwt9bwg4KoTqF1Oh0BPp08vjjcUL4D6JjNug=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 60}, {0., 39.99999510204112}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.557568230633243*^9, 3.557568285224688*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", 
  RowBox[{"(", "1", ")"}]}]], "Input",
 CellChangeTimes->{{3.557568339369277*^9, 3.557568340664446*^9}}],

Cell[BoxData[
 RowBox[{"40", " ", 
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{
    RowBox[{"-", "0.1`"}], " ", "x"}]]}]], "Output",
 CellChangeTimes->{3.557568341168201*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", 
  RowBox[{"(", 
   RowBox[{"x", "=", "1"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.557568347130818*^9, 3.557568349748672*^9}}],

Cell[BoxData["36.19349672143838`"], "Output",
 CellChangeTimes->{3.557568350198353*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", 
  RowBox[{"(", 
   RowBox[{"x", "=", "2"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.557568355243844*^9, 3.557568357603469*^9}}],

Cell[BoxData["72.38699344287676`"], "Output",
 CellChangeTimes->{3.557568357861829*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"x", "=", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.557568360858849*^9, 3.557568361059951*^9}, 
   3.557568417500279*^9, {3.557568457292027*^9, 3.557568464610569*^9}}],

Cell[BoxData[
 RowBox[{"32.749230123119276`", "[", "1", "]"}]], "Output",
 CellChangeTimes->{3.557568464854053*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["f"], "Input",
 CellChangeTimes->{3.557568467216476*^9}],

Cell[BoxData["36.19349672143838`"], "Output",
 CellChangeTimes->{3.557568467519208*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["f"], "Input",
 CellChangeTimes->{3.557568470697508*^9}],

Cell[BoxData["36.19349672143838`"], "Output",
 CellChangeTimes->{3.557568470966133*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["f"], "Input",
 CellChangeTimes->{3.557568471381419*^9}],

Cell[BoxData["36.19349672143838`"], "Output",
 CellChangeTimes->{3.5575684723487997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "1.41421356"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5575684814912367`*^9, 3.557568482323329*^9}, {
  3.557659948487577*^9, 3.557659953973504*^9}}],

Cell[BoxData["34.724937824023954`"], "Output",
 CellChangeTimes->{
  3.557568482678502*^9, {3.557659949943365*^9, 3.557659954552953*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "2.82842712"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568484931964*^9, 3.557568485587349*^9}, {
  3.55765999313702*^9, 3.5576599960947933`*^9}}],

Cell[BoxData["30.145532672058234`"], "Output",
 CellChangeTimes->{3.557568485892819*^9, 3.557659997504849*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "3"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568488227597*^9, 3.557568488843128*^9}}],

Cell[BoxData["29.632728827268714`"], "Output",
 CellChangeTimes->{3.557568489079184*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "4.24264069"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568491179779*^9, 3.557568491819006*^9}, {
  3.557660061055847*^9, 3.557660063286642*^9}}],

Cell[BoxData["26.170043666562577`"], "Output",
 CellChangeTimes->{3.557568492341193*^9, 3.557660063910186*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "5.65685425"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5575684940362387`*^9, 3.557568494772019*^9}, {
  3.557660086433131*^9, 3.557660089142683*^9}}],

Cell[BoxData["22.718828479334434`"], "Output",
 CellChangeTimes->{3.5575684950572863`*^9, 3.557660090414997*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "6"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568497355711*^9, 3.5575685011098557`*^9}}],

Cell[BoxData["21.952465443761056`"], "Output",
 CellChangeTimes->{{3.557568497657174*^9, 3.557568501588107*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "7.07106781"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5575685042831497`*^9, 3.557568504843491*^9}, {
  3.557649322022963*^9, 3.557649325030658*^9}, {3.557660117176578*^9, 
  3.5576601209514236`*^9}}],

Cell[BoxData["19.72274765948882`"], "Output",
 CellChangeTimes->{3.557568505021235*^9, 3.55764932554812*^9, 
  3.557660122036942*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "8.48528137"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568506795764*^9, 3.557568507307273*^9}, {
  3.557649288406748*^9, 3.55764928893501*^9}, {3.557664204192834*^9, 
  3.5576642090611486`*^9}}],

Cell[BoxData["17.121779654866582`"], "Output",
 CellChangeTimes->{3.557568507517654*^9, 3.557649289329733*^9, 
  3.557664210170841*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"40", "*", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.1"}], "*", "9.69535971"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.557568509915916*^9, 3.5575685109085207`*^9}, {
  3.5576492692008333`*^9, 3.557649270431055*^9}, {3.557664237174417*^9, 
  3.55766424006135*^9}}],

Cell[BoxData["15.170359377817295`"], "Output",
 CellChangeTimes->{3.557568511132893*^9, 3.557649271072548*^9, 
  3.557664241259707*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1.4", ",", "34.724937824023954"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2.82842712", ",", "30.145532672058234"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4.24264069", ",", "26.170043666562577"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5.65685425", ",", "22.718828479334434"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"7.07106781", ",", "19.72274765948882"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"8.48528137", ",", "17.121779654866582"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"9.69535971", ",", "15.170359377817295"}], "}"}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.557568515812265*^9, 3.5575685968149357`*^9}, {
  3.557649086798699*^9, 3.55764914436841*^9}, {3.557649176520216*^9, 
  3.557649208969111*^9}, {3.557649275137586*^9, 3.557649331957283*^9}, {
  3.55764944070601*^9, 3.557649449921329*^9}, {3.5576605557465*^9, 
  3.5576605623534927`*^9}, {3.557664321570773*^9, 3.557664421137558*^9}, {
  3.557664462998458*^9, 3.5576644772392693`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.4`", ",", "34.724937824023954`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.82842712`", ",", "30.145532672058234`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.24264069`", ",", "26.170043666562577`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.65685425`", ",", "22.718828479334434`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.07106781`", ",", "19.72274765948882`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8.48528137`", ",", "17.121779654866582`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.69535971`", ",", "15.170359377817295`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5576643283562*^9, 3.5576644792996397`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.4", ",", "36.19349672143838"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "32.749230123119276"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "29.632728827268714"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "26.812801841425575"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "23"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6.2", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7.518", ".89466210964059"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8.3`", ",", "17.441971452861424`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.5`", ",", "15.469640938180047`"}], "}"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5576643045335007`*^9, 3.557664304631979*^9}, {
  3.557664427465267*^9, 3.5576644479139547`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindFit", "[", 
  RowBox[{"d", ",", 
   RowBox[{"A", "*", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "0.1"}], "*", "z"}], "]"}]}], ",", "A", ",", "z"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.55756860832939*^9, 3.5575687024147263`*^9}, {
  3.5575687504911346`*^9, 3.5575687536365213`*^9}, {3.557649220923472*^9, 
  3.557649255775079*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"A", "\[Rule]", "39.98376331342686`"}], "}"}]], "Output",
 CellChangeTimes->{{3.557568673573092*^9, 3.557568703077186*^9}, 
   3.55756875407073*^9, 3.557649149150299*^9, {3.557649211610721*^9, 
   3.557649337327079*^9}, 3.557649452163978*^9, 3.5576639076074753`*^9, 
   3.557664330856147*^9, 3.5576644811462793`*^9}]
}, Open  ]],

Cell[BoxData[" "], "Input",
 CellChangeTimes->{3.5576496560149813`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.5576636112591476`*^9, 3.5576636137616568`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "36.19349672143838`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "32.749230123119276`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "29.632728827268714`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"4", ",", "26.812801841425575`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "23"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"6.2`", ",", "21"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"7.5`", ",", "18.89466210964059`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"8.3`", ",", "17.441971452861424`"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"9.5`", ",", "15.469640938180047`"}], "}"}]}], "}"}], "[", "2", 
  "]"}]], "Output",
 CellChangeTimes->{3.5576636144619913`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"l", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.557663618122189*^9, 3.5576636220866528`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.5576636232897577`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"l", 
  RowBox[{"(", "1", ")"}]}]], "Input",
 CellChangeTimes->{{3.557663625137643*^9, 3.557663626326548*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.55766362695343*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"l", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.557663629052745*^9, 3.557663661668885*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.5576636314007797`*^9, 3.5576636622054033`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"test", "[", 
   RowBox[{"1", ",", "1"}], "]"}], "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.557665396273409*^9, 3.557665435750757*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.557665426074712*^9, 3.557665436145599*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"test", "[", 
   RowBox[{"2", ",", "2"}], "]"}], " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.557665476662837*^9, 3.557665484318852*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.55766548534056*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"test", "[", 
  RowBox[{"1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.557665486870245*^9, 3.5576654910067053`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.557665491575964*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"test", "[", 
  RowBox[{"2", ",", "2"}], "]"}]], "Input",
 CellChangeTimes->{{3.557665493055599*^9, 3.557665507798617*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{{3.557665498837796*^9, 3.557665508302372*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tests", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "=", " ", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5576657374094763`*^9, 3.5576657460711*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Set", "::", "noval"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Symbol \[NoBreak]\\!\\(tests\\)\[NoBreak] in part \
assignment does not have an immediate value. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/noval\\\", ButtonNote -> \
\\\"Set::noval\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.557665746806676*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.5576657468076*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tests", "[", "1", "]"}], " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5576657500043983`*^9, 3.55766575736703*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.557665758010154*^9}]
}, Open  ]]
},
WindowSize->{740, 752},
WindowMargins->{{0, Automatic}, {8, Automatic}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (October 5, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 143, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[725, 26, 278, 7, 27, "Input"],
Cell[1006, 35, 229, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1272, 46, 125, 2, 27, "Input"],
Cell[1400, 50, 194, 5, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1631, 60, 146, 3, 27, "Input"],
Cell[1780, 65, 462, 10, 23, "Message"],
Cell[2245, 77, 125, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2407, 85, 210, 5, 27, "Input"],
Cell[2620, 92, 2107, 40, 245, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4764, 137, 133, 3, 27, "Input"],
Cell[4900, 142, 178, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5115, 152, 157, 4, 27, "Input"],
Cell[5275, 158, 87, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5399, 164, 157, 4, 27, "Input"],
Cell[5559, 170, 87, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5683, 176, 215, 4, 27, "Input"],
Cell[5901, 182, 115, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6053, 189, 69, 1, 27, "Input"],
Cell[6125, 192, 87, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6249, 198, 69, 1, 27, "Input"],
Cell[6321, 201, 87, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6445, 207, 69, 1, 27, "Input"],
Cell[6517, 210, 89, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6643, 216, 252, 6, 27, "Input"],
Cell[6898, 224, 137, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7072, 231, 251, 6, 27, "Input"],
Cell[7326, 239, 110, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7473, 245, 192, 5, 27, "Input"],
Cell[7668, 252, 88, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7793, 258, 250, 6, 27, "Input"],
Cell[8046, 266, 110, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8193, 272, 252, 6, 27, "Input"],
Cell[8448, 280, 112, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8597, 286, 194, 5, 27, "Input"],
Cell[8794, 293, 112, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8943, 299, 303, 7, 27, "Input"],
Cell[9249, 308, 133, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9419, 315, 300, 7, 27, "Input"],
Cell[9722, 324, 135, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9894, 331, 302, 7, 27, "Input"],
Cell[10199, 340, 135, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10371, 347, 1096, 24, 73, "Input"],
Cell[11470, 373, 721, 18, 43, "Output"]
}, Open  ]],
Cell[12206, 394, 830, 22, 58, InheritFromParent],
Cell[CellGroupData[{
Cell[13061, 420, 381, 10, 27, "Input"],
Cell[13445, 432, 355, 6, 27, "Output"]
}, Open  ]],
Cell[13815, 441, 71, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[13911, 446, 124, 2, 27, "Input"],
Cell[14038, 450, 816, 23, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14891, 478, 184, 4, 27, "Input"],
Cell[15078, 484, 127, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15242, 492, 133, 3, 27, "Input"],
Cell[15378, 497, 124, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15539, 505, 143, 3, 27, "Input"],
Cell[15685, 510, 96, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15818, 516, 217, 6, 27, "Input"],
Cell[16038, 524, 139, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16214, 532, 227, 6, 27, "Input"],
Cell[16444, 540, 114, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16595, 548, 148, 3, 27, "Input"],
Cell[16746, 553, 115, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16898, 561, 146, 3, 27, "Input"],
Cell[17047, 566, 139, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17223, 574, 223, 6, 27, "Input"],
Cell[17449, 582, 471, 10, 23, "Message"],
Cell[17923, 594, 113, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18073, 602, 205, 5, 27, "Input"],
Cell[18281, 609, 115, 3, 27, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

